/*
**
** (C) 2002 Grzegorz Fitrzyk SP9WUN
**   email: sp9wun@poczta.onet.pl
**    http://sp9wun.republika.pl/
**
*/

#define VERSION		"2.00beta28 (03.01.2003)"

#include <stdio.h>
#include <string.h>
#include <stdarg.h>
#include <stdlib.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <unistd.h>
#include <errno.h>
#include <math.h>
#include <syslog.h>
#include <signal.h>
#include <setjmp.h>

#define TIMEOUT		300
#define IP_CONNTRACK 	"/proc/net/ip_conntrack"
#define DEVFILE		"/proc/net/dev"

int			exit_signal = 0;
jmp_buf   		env_buf;

int			natstat_tab_pos = 0;
int			natstat_tab_pos_upload = 0;
char			**iplista;
char			**iplista_iface;
char			**iplista_int_iface;
int			*iplista_ip;
int			*iplista_mask;
int			*iplista_bool;
int			*iplista_bool_upload;
unsigned long int	*iplista_lo;
unsigned long int	*iplista_hi;
unsigned long int	*iplista_lo_upload;
unsigned long int	*iplista_hi_upload;
unsigned long int	*ipspeed;
unsigned long int	*ipspeed_upload;
unsigned long int       *iptime;
unsigned long int       *iptime_upload;
unsigned long int	*ipspeed_last;
unsigned long int	*ipspeed_last2;
unsigned long int       *ipspeed_last2_counter;
unsigned long int       *iptime_last;
unsigned long int	*ipspeed_last_upload;
unsigned long int	*ipspeed_last2_upload;
unsigned long int       *ipspeed_last2_counter_upload;
unsigned long int       *iptime_last_upload;
unsigned long int	*squid_speed;
unsigned long int       *squid_time;
unsigned long int	*squid_speed_last;
unsigned long int	*squid_speed_last2;
unsigned long int       *squid_time_last;
int			iplista_pos = 0;
int			**local_int_tab2 = NULL;
int			local_int_pos = 1;
int			bitrate_user_last_pos[10];
int			bitrate_user_last_pos_upload[10];
int			ignore_pos = 1;
char			**devlist;
int			devlist_pos = 1;
int			masqip_pos[11];
int			masqip_pos_upload[11];
int			kernel_type = 0;

// Config
int			upload_control = 0;
int			high_start_speed = 1;
int			even_division = 0;
int			continuous_control = 0;
int			squid = 0;
int			squid_port = 8192;
int			nomasq = 0;
int			nomasq_cycles = 6;
int			jump_type = 0;
int			divide_upload = 0;
unsigned long int	speed_out = 70000;
char			speed_ext[10] = "\0";
int			delay	= 10;
int			olddelay= 6;
int			debug = 0;
int			notc = 0;
int			class_type = 0; // 0-CBQ 1-HTB
int			upload_class_type = 0; // 0-CBQ 1-HTB
int			check_always = 0;
int			shaperd_counter = 0;
char			configfile[100];
char			pidfile[100];
char			ignorefile[100];
char			iplistfile[100];
char			oldfile[100];
char			oldfile_upload[100];
unsigned int		cnt[10][256];	// tablica licznikow klas

void frmem(void);
void error(char *, ...);
int my_system (const char *);
int numlines(char *);
unsigned long int ckbitrate_user(char *);
unsigned long int ckbitrate_user_upload(char *);
void read_iplist(char ***);
void read_firewall(int);
void read_firewall_upload(int);
void write_bitrate(char *);
char **dev_list(void);
void cbq_off(char *);
void cbq_off_local(char ***);
void cbq_off_all(char ***);
void cbq_setup_root(char *, unsigned long int, int, int);
void cbq_setup_clas(char *, unsigned long int, int, char *, char *, int);
void cbq_setup_xfilters(char *, int, char *, char *);
void cbq_class_add(char *, unsigned long int, unsigned long int, int, int, char *, char *, int , int, char *, int);
void cbq_class_change(char *, unsigned long int, unsigned long int, int, int, char *, char *, int , int, char *, int);
void cbq_class_del(char *, unsigned long int, unsigned long int, int, int, char *, char *, int , int, char *, int);
void cbq_class_add_upload(char *, unsigned long int, unsigned long int, int, int, char *, char *, int , int, char *, int);
void cbq_class_change_upload(char *, unsigned long int, unsigned long int, int, int, char *, char *, int , int, char *, int);
void cbq_class_del_upload(char *, unsigned long int, unsigned long int, int, int, char *, char *, int , int, char *, int);
void cbq_standard_on(char ***);
char ***read_config(char *);
void free_config(char ***);
char ***natstat(char **, char ***, int);
char ***natstat_upload(char **, char ***, int);
void free_natstat_tab(char ***);
void free_natstat_tab_upload(char ***);
char **read_ignore(char *);
void free_ignore(char **);
char **get_masqip(char ***, char *, int);
char **get_masqip_upload(char ***, char *, int);
void free_masqip(char **, int);
void free_masqip_upload(char **, int);
char ***create_speed_table(int);
void free_speed_table(char ***, int);
void add_ip2speed_table_new(char ***,char *);
void add_ip2speed_table_sub1(char ***,char *);
void add_ip2speed_table_nop1(char ***,char *);
void add_ip2speed_table_add1(char ***,char *);
void add_ip2speed_table_sub2(char ***,char *);
void add_ip2speed_table_nop2(char ***,char *);
void add_ip2speed_table_add2(char ***,char *);
void del_ip2speed_table(char ***,char *);
char *get_speed_table_new(char ***, int);
char *get_speed_table_sub1(char ***, int);
char *get_speed_table_nop1(char ***, int);
char *get_speed_table_add1(char ***, int);
char *get_speed_table_sub2(char ***, int);
char *get_speed_table_nop2(char ***, int);
char *get_speed_table_add2(char ***, int);
char *get_speed_table_del(char ***, int);
char *get_ip_iface(char *);
char *get_ip_int_iface(char *);
unsigned short int get_ip_cnt(char *);
int get_ip_mask(char *);
unsigned long int get_ip_lospeed(char *);
unsigned long int get_ip_hispeed(char *);
unsigned long int get_ip_lospeed_upload(char *);
unsigned long int get_ip_hispeed_upload(char *);
int get_config_by_ip(char ***, char *);
int get_config_by_ip_upload(char ***, char *);
char *check_mask(char *);
int ip2hex(char *);
int ip2hex2(char *);
char *hex2ip(int);
char *hex2ip2(char *);
char *get_ip_iface2(char ***, char *);
int mask2hex(char *);
void create_firewall(char ***, int);
void delete_firewall(char ***, int);
char ***mkbitrate_user_last(char ***, char *, long int, int);
char ***mkbitrate_user_last_upload(char ***, char *, long int, int);
char ***clear_bitrate_user_last(char ***, char **, int);
char ***clear_bitrate_user_last_upload(char ***, char **, int);
long int ckbitrate_user_last(char ***, char *, int);
long int ckbitrate_user_last_upload(char ***, char *, int);
void free_bitrate_user_last(char ***, int);
void free_bitrate_user_last_upload(char ***, int);
void write_bitrate_user_last(char ****,char *, int);
void write_bitrate_user_last_upload(char ****, char *, int);
static int daemonize(void);
int check_linux(void);
int check_ipchains(void);
int check_iptables(void);
int is_shaperd_running(void);
int is_iproute2(void);
int is_qos(void);
void shownat(char ***);
char *lower(char *);
void exit_handler();
void read_squid(int);
char *ip2ip_with_mask(char *);
char *get_mainip(char *);
int count_char_in_string(char *, char);
int is_device(char *);

int main(int argc, char *argv[])
{
    int			n,mult;
    int			nr[10];
    int			nr_upload[10];
    char		***nattab;
    char		***nattab_upload;
    char		***config;
    char		***speed_tab[10];
    char		***del_tab[10];
    char		***speed_tab_upload[10];
    char		***del_tab_upload[10];
    char		***bitrate_user_last[10];
    char		***bitrate_user_last_upload[10];
    char		**lista;
    char		**ignore;
    char		**masq[10];
    char		**masq_upload[10];
    char		*str;
    unsigned long int	speed[10];
    unsigned long int	speed_upload[10];
    unsigned long int	tspeed;
    unsigned long int	even_speed;
    long int		reszta[10];
    long int		reszta_upload[10];
    unsigned long int   currbitrate;
    unsigned long int   currbitrate_total;
    long int		lastbitrate;
    int			ilip[10];
    int			ilip_upload[10];
    int			log;
    int			old = olddelay;
    int			ipcol = 0;
    int			firewall_type = 0;
    int			start_time;
    int			delta_time;
    int			delay_org;
    int			int_cnt;

    log = 1;

    for(n=0;n<10;n++)
    {
	bitrate_user_last[n] = NULL;
	bitrate_user_last_upload[n] = NULL;
	bitrate_user_last_pos[n] = 0;
	bitrate_user_last_pos_upload[n] = 0;
    }

    // Start syslog
    if (log)
    {
	char	buf[20];
	
	sprintf(buf,"shaperd%d",shaperd_counter);
        openlog(buf, LOG_CONS|LOG_PERROR, LOG_DAEMON);
	openlog(buf, LOG_CONS, LOG_DAEMON);
    }

    if ((int) signal(SIGTERM, exit_handler) == -1)
    {
	syslog(LOG_ERR,"Cannot setup SIGTERM handler.");
	syslog(LOG_ERR,"Exit.");
	error("Cannot setup SIGTERM handler.\nExiting\n");
    }

    // Sprawdzamy czy pakiet iproute2 jest zainstalowany
    if (!is_iproute2())
    {
	syslog(LOG_ERR,"Package iproute2 not found.");
	syslog(LOG_ERR,"Exit.");
	error("Package iproute2 not found.\nExiting\n");
    }
    
    // Sprawdzamy czy w kernelu jest obsluga QoS
    if (!is_qos())
    {
	syslog(LOG_ERR,"This kernel don't supporte QoS - recompile it with QoS support enabled.");
	syslog(LOG_ERR,"Exit.");
	error("This kernel don't supporte QoS - recompile it with QoS support enabled.\nExiting\n");
    }

    // sprawdzamy wersje kernela
    kernel_type = check_linux();

    // Sprawdzamy rodzaj firewalla
    if (check_ipchains())
    {
	if (debug) syslog(LOG_INFO,"Checking firewall type: ipchains");
	firewall_type=1;
    }
    else
    if (check_iptables())
    {
	if (debug) syslog(LOG_INFO,"Checking firewall type: iptables");
	firewall_type=2;
    }

    if (!firewall_type)
    {
	syslog(LOG_ERR,"Unknown firewall type");
	syslog(LOG_ERR,"Exit.");
	error("Unknown firewall type.\nExiting.\n");
    }
    
    // sprawdzamy, ktora wersje konfiguracji wczytac
    if (argc>1)
    {
	char    *p;
			
	for(n=1;n<argc;n++)
	{
	    if (strstr(argv[n],"-config="))
	    {
		p = strtok(argv[n],"=");
		p = strtok(NULL," ");
		if (p)
		{
		    shaperd_counter = atoi(p);
		    if (shaperd_counter < 0 || shaperd_counter > 9)
		    {
			syslog(LOG_ERR,"value of config type out of range. Should be 0-9.\nExiting.\n");
			error("value of config type out of range. Should be 0-9.\nExiting.\n");
		    }
		}
	    }
	}
    }

    sprintf(configfile,"/etc/shaper/shaper.%d.cfg",shaperd_counter);
    sprintf(pidfile,"/var/run/shaperd.%d.pid",shaperd_counter);
    sprintf(ignorefile,"/etc/shaper/ignore.%d",shaperd_counter);
    sprintf(iplistfile,"/etc/shaper/iplist.%d",shaperd_counter);
    sprintf(oldfile,"/var/shaper/bitrate_user_sh.%d.old",shaperd_counter);
    sprintf(oldfile_upload,"/var/shaper/bitrate_user_up.%d.old",shaperd_counter);

    // czytamy liste interfejsow w systemie
    if (debug>2) printf("debug 3: reading list of system interfaces\n");
    lista = dev_list();

    // czytamy plik konfiguracyjny
    if (debug>2) printf("debug 3: Reading %d config file\n",shaperd_counter);
    config = read_config(configfile);

    // sprawdzamy parametry podane przy starcie programu
    if (debug>2) printf("debug 3: Reading start options\n");
    if (argc>1)
    {
	char	*p;
	int	fin;

	for(n=1;n<argc;n++)
	{
	    fin = 0;
	    p = strtok(argv[n],"=");
	    if (!strcmp(p,"-config"))
	    {
		p = strtok(NULL," ");
		fin = 1;
	    }
	    else
	    if (!strcmp(p,"-speed_ext"))
	    {
		p = strtok(NULL," ");
		if (p)
		{
		    char	*lo = lower(p);
		    
		    if (! strcmp(lo,"kbit") || ! strcmp(lo,"mbit")) strncpy(speed_ext,lo,10);
		    else strncpy(speed_ext,"\0",10);
		    fin = 1;
		    free(lo);
		}
	    }
	    else
	    if (!strcmp(p,"-debug"))
	    {
		p = strtok(NULL," ");
		if (p)
		{
		    debug = atoi(p);
		    fin = 1;
		}
	    }
	    else
	    if (!strcmp(p,"-delay"))
	    {
		p = strtok(NULL," ");
		if (p)
		{
		    delay = atoi(p);
		    if (delay < 10) delay = 10;
		    fin = 1;
		}
	    }
	    else
	    if (!strcmp(p,"-write_delay"))
	    {
		p = strtok(NULL," ");
		if (p)
		{
		    olddelay = atoi(p);
		    if (olddelay < 0) olddelay = 0;
		    fin = 1;
		}
	    }
	    else
	    if (!strcmp(p,"-high_start_speed"))
	    {
		p = strtok(NULL," ");
		if (p)
		{
		    char	*lo = lower(p);

		    if (!strcmp(lo,"yes")) high_start_speed = 1;
		    else
		    if (!strcmp(lo,"no")) high_start_speed = 0;
		    else
			high_start_speed = atoi(p);
		    fin = 1;
		}
	    }
	    else
	    if (!strcmp(p,"-even_division"))
	    {
		p = strtok(NULL," ");
		if (p)
		{
		    char	*lo = lower(p);

		    if (!strcmp(lo,"yes")) even_division = 1;
		    else
		    if (!strcmp(lo,"no")) even_division = 0;
		    else
    			even_division = atoi(p);
		    fin = 1;
		}
	    }
	    else
	    if (!strcmp(p,"-continuous_control"))
	    {
		p = strtok(NULL," ");
		if (p)
		{
		    char	*lo = lower(p);

		    if (!strcmp(lo,"yes")) continuous_control = 1;
		    else
		    if (!strcmp(lo,"no")) continuous_control = 0;
		    else
    			continuous_control = atoi(p);
		    fin = 1;
		}
	    }
	    else
	    if (!strcmp(p,"-jump_type"))
	    {
		p = strtok(NULL," ");
		if (p)
		{
    		    jump_type = atoi(p);
		    fin = 1;
		}
	    }
	    else
	    if (!strcmp(p,"-check_always"))
	    {
		p = strtok(NULL," ");
		if (p)
		{
		    char	*lo = lower(p);

		    if (!strcmp(lo,"yes")) check_always = 1;
		    else
		    if (!strcmp(lo,"no")) check_always = 0;
		    else
    			check_always = atoi(p);
		    fin = 1;
		}
	    }
	    else
	    if (!strcmp(p,"-squid_support"))
	    {
		p = strtok(NULL," ");
		if (p)
		{
		    char	*lo = lower(p);

		    if (!strcmp(lo,"yes")) squid = 1;
		    else
		    if (!strcmp(lo,"no")) squid = 0;
		    else
			squid = atoi(p);
		    fin = 1;
		    if (squid) syslog(LOG_INFO,"squid_support active");
		}
	    }
	    else
	    if (!strcmp(p,"-divide_upload"))
	    {
		p = strtok(NULL," ");
		if (p)
		{
		    char	*lo = lower(p);

		    if (!strcmp(lo,"yes")) divide_upload = 1;
		    else
		    if (!strcmp(lo,"no")) divide_upload = 0;
		    else
			divide_upload = atoi(p);
		    fin = 1;
		    if (divide_upload) syslog(LOG_INFO,"divide_upload active");
		}
	    }
	    else
	    if (!strcmp(p,"-nomasq"))
	    {
		p = strtok(NULL," ");
		if (p)
		{
		    char	*lo = lower(p);

		    if (!strcmp(lo,"yes")) nomasq = 1;
		    else
		    if (!strcmp(lo,"no")) nomasq = 0;
		    else
			nomasq = atoi(p);
		    fin = 1;
		    if (nomasq) syslog(LOG_INFO,"masquerade control deactivated");
		}
	    }
	    else
	    if (!strcmp(p,"-class_type"))
	    {
		p = strtok(NULL," ");
		if (p)
		{
		    if (!strcmp(lower(p),"cbq")) class_type = 0;
		    else
		    if (!strcmp(lower(p),"htb")) class_type = 1;
		    fin = 1;
		    if (class_type) syslog(LOG_INFO,"HTB Download Class type activated");
		    free(p);
		}
	    }
	    else
	    if (!strcmp(p,"-upload_class_type"))
	    {
		p = strtok(NULL," ");
		if (p)
		{
		    if (!strcmp(lower(p),"cbq")) upload_class_type = 0;
		    else
		    if (!strcmp(lower(p),"htb")) upload_class_type = 1;
		    fin = 1;
		    if (upload_class_type) syslog(LOG_INFO,"HTB Upload Class type activated");
		    free(p);
		}
	    }
	    else
	    if (!strcmp(p,"shownat_all"))
	    {
//		ignore = read_ignore(ignorefile);
		read_iplist(config);
//		lista = dev_list();
		if (squid)
		{
		    read_squid(firewall_type);
		    nattab = natstat(ignore, config, firewall_type);
		    free_natstat_tab(nattab);
		    sleep(1);
		    read_squid(firewall_type);
		}
		nattab = natstat(ignore, config, firewall_type);
		shownat(nattab);
		closelog();
		free_natstat_tab(nattab);
//	        free_ignore(ignore);
		free_config(config);
		frmem();
		exit(0);
	    }
	    else
	    if (!strcmp(p,"shownat"))
	    {
		ignore = read_ignore(ignorefile);
		read_iplist(config);
//		lista = dev_list();
		if (squid)
		{
		    read_squid(firewall_type);
		    nattab = natstat(ignore, config, firewall_type);
		    free_natstat_tab(nattab);
		    sleep(1);
		    read_squid(firewall_type);
		}
		nattab = natstat(ignore, config, firewall_type);
		shownat(nattab);
		closelog();
		free_natstat_tab(nattab);
	        free_ignore(ignore);
		free_config(config);
		frmem();
		exit(0);
	    }
	    else
	    if (!strcmp(p,"--version") || !strcmp(p,"-V"))
	    {
		printf("shaperd %s\n",VERSION);
		closelog();
		free_config(config);
		frmem();
		exit(0);
	    }
	    else
	    if (!strcmp(p,"--help"))
	    {
		printf("Usage: shaperd [options] [commands]\n\
Options:\n\
\t-config=0-9			number of shaperd config (deflt. 0)\n\
\t-high_start_speed=yes|no	high speed start switch (deflt. yes)\n\
\t-check_always=yes|no		always control bandwidth (deflt. no)\n\
\t-squid_support=yes|no		PROXY support switch (deflt. no)\n\
\t-divide_upload=yes|no		divide upload bandwidth (deflt. no)\n\
\t-nomasq=yes|no			disable masquerade connections \n\
\t				tracking <deflt. no)\n\
\t-class_type=cbq|htb		download class type (deflt. cbq)\n\
\t-upload_class_type=cbq|htb	upload class type (deflt. cbq)\n\
\t-even_division=yes|no		even division of bandwidth (deflt. no)\n\
\t-continuous_control=yes|no	continuous QoS control (deflt. no)\n\
\t-jump_type=n			multiplier of speed jump (deflt. 0)\n\
\t-speed_ext=bit|kbit|mbit	speed extension (deflt. bit)\n\
\t-delay=seconds			cycle delay time (deflt 10)\n\
\t-write_delay=n			after how many cycles to write\n\
\t				bitrate_user_sh.x.old file (deflt. 6)\n\
\t-debug=0|1|2|3|4		debug level (deflt. 0)\n\
\t--version\t-V		print package version\n\
\t--help help\n\
\n\
Commands:\n\
\tshownat		show current masqueraded connections (without ignore)\n\
\tshownat_all	show all current masqueraded connections\n\n");

		closelog();
		free_config(config);
		frmem();
		exit(1);
	    }
	    else
	    if (fin == 0)
	    {
		syslog(LOG_ERR,"syntax error. Unknown parameter: %s.",argv[n]);
		closelog();
//		free_ignore(ignore);
		free_config(config);
		frmem();
		error("shaperd: syntax error. Unknown parameter: %s.\ntry: shaperd --help\n\n",argv[n]);
	    }
	}
    }

    // sprawdzamy czy juz jakis shaper nie pracuje
    if (debug>2) printf("debug 3: checking if any other shaperd.%d is working\n",shaperd_counter);
    if (is_shaperd_running())
    {
	syslog(LOG_ERR,"Any shaperd%d is still working. Exiting.",shaperd_counter);
	closelog();
	free_config(config);
	frmem();
	error("Any shaperd%d is still working. Exiting.\n",shaperd_counter);
	exit(1);
    }

    // czytamy liste ignorowanych polaczen
    if (debug>2) printf("debug 3: reading /etc/shaper/ignore.%d file\n",shaperd_counter);
    ignore = read_ignore(ignorefile);
    
    // czytamy liste lokalnych numerow ip
    if (debug>2) printf("debug 3: reading /etc/shaper/iplist.%d file\n",shaperd_counter);
    read_iplist(config);

    // uruchamiamy program jako daemona systemowego
    if (debug>2) printf("debug 3: daemonize\n");
    if (daemonize() < 0) exit(1);

    // czy ciagla kontrola QoS wlaczona
    if (continuous_control)
    {
	if (debug) printf("Continuous traffic control enabled\n");
	syslog(LOG_INFO, "Continuous traffic control enabled\n");
    }

    // tworzymy regulki na firewallu rejestrujace ilosc pobranych danych
    if (debug>2) printf("debug 3: removing firewall shaperd rules\n");
    delete_firewall(config,firewall_type);
    if (debug>2) printf("debug 3: creating firewall shaperd rules\n");
    create_firewall(config,firewall_type);

    syslog(LOG_INFO, "Initialisation finished");

    delay_org = delay;

    mult = 1;
    if (! strcmp(speed_ext,"bit")) mult = 1;
    else if (! strcmp(speed_ext,"kbit")) mult = 1024;
    else if (! strcmp(speed_ext,"mbit")) mult = 1048576;

    for(n=1;n<11;n++)
    {
	masqip_pos[n]=1;
	masqip_pos_upload[n]=1;
    }

    if (continuous_control)
    {
	// usuwamy wszystkie ograniczenia
	if (debug>2) printf("debug 3: removing all QoS classes\n");
	cbq_off_local(config);

	// ustawiamy standardowe ograniczenia
	if (debug>2) printf("debug 3: creating root QoS classes\n");
	cbq_standard_on(config);
    }

    // petla glowna
    if (debug>2) printf("debug 3: beginning main loop\n");
    while(!exit_signal)
    {
	start_time = time(NULL);
	currbitrate_total = 0;

	// czytamy na firewallu ilosc pobranych i wyslanych danych 
	if (debug>2) printf("debug 3: reading firewall\n");
	read_firewall(firewall_type);
	if (divide_upload) read_firewall_upload(firewall_type);
	if (squid) read_squid(firewall_type);

	// czytamy wszystkie polaczenia na maskaradzie
	nattab = natstat(ignore, config, firewall_type);
	if (divide_upload) nattab_upload = natstat_upload(ignore, config, firewall_type);

	// petla interfejsow internetowych
	for(int_cnt=1;int_cnt<local_int_pos;int_cnt++)
	{
	    // tworzymy liste maskowanych numerow ip dla przydzialow
	    if (debug>2) printf("debug 3: creating working ip's table.\n");
	    masq[int_cnt] = get_masqip(nattab,config[1][(int_cnt*6)+1],int_cnt);
	    if (divide_upload) masq_upload[int_cnt] = get_masqip_upload(nattab_upload,config[1][(int_cnt*6)+1],int_cnt);

	    nr[int_cnt] = 1;
	    nr_upload[int_cnt] = 1;

	    // sprawdzamy czy interfejs jest internetowy
	    if (local_int_tab2[1][(int_cnt*6)+5])
	    {
		// petla userow na maskaradzie - download
		for(n=1;n<masqip_pos[int_cnt];n++)
		{
		    // sprawdzamy czy interfejs internetowy usera jest taki sam jak aktualny
		    if (!strcmp(config[1][(int_cnt*6)+1],get_ip_int_iface(masq[int_cnt][n])))
			// zwiekszamy licznik ilosci userow na maskardzie
			nr[int_cnt]++;
		}
		if (debug) printf("Number of IP's on %s interface for download allocation bandwidth: %d\n",config[1][(int_cnt*6)+1],nr[int_cnt]-1);

		// petla userow na maskaradzie - upload
		if (divide_upload)
		{
		    for(n=1;n<masqip_pos_upload[int_cnt];n++)
		    {
			// sprawdzamy czy interfejs internetowy usera jest taki sam jak aktualny
			if (!strcmp(config[1][(int_cnt*6)+1],get_ip_int_iface(masq_upload[int_cnt][n])))
			    // zwiekszamy licznik ilosci userow na maskardzie
			    nr_upload[int_cnt]++;
		    }
		    if (debug) printf("Number of IP's on %s interface for upload allocation bandwidth: %d\n",config[1][(int_cnt*6)+1],nr[int_cnt]-1);
		}

		// tworzymy tablice z aktualnymi przydzialami
		if (debug>2) printf("debug 3: creating user's speed allocation table for %s interface.\n",config[1][(int_cnt*6)+1]);
    		speed_tab[int_cnt] = create_speed_table(nr[int_cnt]);
    		if (divide_upload) speed_tab_upload[int_cnt] = create_speed_table(nr_upload[int_cnt]);
		del_tab[int_cnt] = create_speed_table(iplista_pos+1);
		if (divide_upload) del_tab_upload[int_cnt] = create_speed_table(iplista_pos+1);

		// czyscimy tablice z ostatnimi przydzialami
		if (debug>2) printf("debug 3: clearing user's last speed allocation table\n");
		bitrate_user_last[int_cnt] = clear_bitrate_user_last(bitrate_user_last[int_cnt],masq[int_cnt],int_cnt);
		if (divide_upload) bitrate_user_last_upload[int_cnt] = clear_bitrate_user_last_upload(bitrate_user_last_upload[int_cnt],masq_upload[int_cnt],int_cnt);

		// robimy ograniczenia download tylko wtedy gdy jest wiecej niz jeden user lub check_always=1
    		if (nr[int_cnt]-1 > 1 || (nr[int_cnt]-1 > 0 && check_always))
		{
		    int	t;

		    if (debug) printf("Dnload ip: IP\t\t\tCurr.Bitrate\tLast Bitrate\t%s\n",config[1][(int_cnt*6)+1]);
		    ilip[int_cnt] = nr[int_cnt]-1;
		    speed[int_cnt] = (local_int_tab2[1][(int_cnt*6)+2] * mult) / ilip[int_cnt];
		    for(n=1;n<nr[int_cnt];n++)
		    {
			currbitrate = ckbitrate_user(masq[int_cnt][n]);
			lastbitrate = ckbitrate_user_last(bitrate_user_last[int_cnt],masq[int_cnt][n],int_cnt) * mult;
			if (even_division || lastbitrate < 0 || lastbitrate == 0)
			    add_ip2speed_table_new(speed_tab[int_cnt],masq[int_cnt][n]);
			else
			    if (lastbitrate <= speed[int_cnt])
			    {
	    			if (currbitrate < lastbitrate*0.5)
				    add_ip2speed_table_sub1(speed_tab[int_cnt],masq[int_cnt][n]);
				else
				    if (currbitrate < lastbitrate*0.7)
					add_ip2speed_table_nop1(speed_tab[int_cnt],masq[int_cnt][n]);
				    else
					add_ip2speed_table_add1(speed_tab[int_cnt],masq[int_cnt][n]);
			    }
			    else
			    {
				if (currbitrate < lastbitrate*0.5)
				    add_ip2speed_table_sub2(speed_tab[int_cnt],masq[int_cnt][n]);
				else
				    if (currbitrate < lastbitrate*0.7)
					add_ip2speed_table_nop2(speed_tab[int_cnt],masq[int_cnt][n]);
				    else
					add_ip2speed_table_add2(speed_tab[int_cnt],masq[int_cnt][n]);
			    }
			if (debug) printf("Dnload ip: %s\t\t%lu\t\t%ld\n",masq[int_cnt][n],currbitrate,lastbitrate);
		    }

		}

		// robimy ograniczenia upload tylko wtedy gdy jest wiecej niz jeden user lub check_always=1
		if (divide_upload)
		{
    		    if (nr_upload[int_cnt]-1 > 1 || (nr_upload[int_cnt]-1 > 0 && check_always))
		    {
			int	t;

			if (debug) printf("Upload ip: IP\t\t\tCurr.Bitrate\tLast Bitrate\t%s\n",config[1][(int_cnt*6)+1]);
		        ilip_upload[int_cnt] = nr_upload[int_cnt]-1;
		        speed_upload[int_cnt] = (local_int_tab2[1][(int_cnt*6)+4] * mult) / ilip_upload[int_cnt];
		        for(n=1;n<nr_upload[int_cnt];n++)
			{
			    currbitrate = ckbitrate_user_upload(masq_upload[int_cnt][n]);
			    lastbitrate = ckbitrate_user_last_upload(bitrate_user_last_upload[int_cnt],masq_upload[int_cnt][n],int_cnt) * mult;
			    if (even_division || lastbitrate < 0 || lastbitrate == 0)
			        add_ip2speed_table_new(speed_tab_upload[int_cnt],masq_upload[int_cnt][n]);
			    else
			        if (lastbitrate <= speed_upload[int_cnt])
			        {
	    			    if (currbitrate < lastbitrate*0.5)
				        add_ip2speed_table_sub1(speed_tab_upload[int_cnt],masq_upload[int_cnt][n]);
				    else
				        if (currbitrate < lastbitrate*0.7)
				    	    add_ip2speed_table_nop1(speed_tab_upload[int_cnt],masq_upload[int_cnt][n]);
					else
					    add_ip2speed_table_add1(speed_tab_upload[int_cnt],masq_upload[int_cnt][n]);
				}
				else
				{
				    if (currbitrate < lastbitrate*0.5)
					add_ip2speed_table_sub2(speed_tab_upload[int_cnt],masq_upload[int_cnt][n]);
				    else
					if (currbitrate < lastbitrate*0.7)
					    add_ip2speed_table_nop2(speed_tab_upload[int_cnt],masq_upload[int_cnt][n]);
					else
					    add_ip2speed_table_add2(speed_tab_upload[int_cnt],masq_upload[int_cnt][n]);
				}
			    if (debug) printf("Upload ip: %s\t\t%lu\t\t%ld\n",masq_upload[int_cnt][n],currbitrate,lastbitrate);
			}
		    }
		}

		if (continuous_control)
		{
		    // Usuwamy ograniczenia download dla niepracujacych numerow IP
		    int         *iplista_fin;
		    int		m;

		    if (iplista_pos)
		    {
			iplista_fin = (int *) calloc(iplista_pos,sizeof(int));

	    		for(n=1;n<iplista_pos;n++)
			    iplista_fin[n] = 0;

			for(n=1;n<iplista_pos;n++)
		        {
			    for(m=1;m<nr[int_cnt];m++)
			    {
		    		if ((ip2hex2(masq[int_cnt][m])&iplista_mask[n]) == (iplista_ip[n]&iplista_mask[n]))
				{
		    		    iplista_fin[n] = 1;
				    iplista_bool[n] = 1;
				}
			    }
			}

    			for(n=1;n<iplista_pos;n++)
			{
			    if (! iplista_fin[n])
		    	    {
			        del_ip2speed_table(del_tab[int_cnt],iplista[n]);
			    }
			}
			free(iplista_fin);
		    }

		    // Usuwamy ograniczenia upload dla niepracujacych numerow IP
		    if (divide_upload)
		    {
			if (iplista_pos)
			{
			    iplista_fin = (int *) calloc(iplista_pos,sizeof(int));

	    		    for(n=1;n<iplista_pos;n++)
				iplista_fin[n] = 0;

			    for(n=1;n<iplista_pos;n++)
		    	    {
				for(m=1;m<nr_upload[int_cnt];m++)
				{
		    		    if ((ip2hex2(masq_upload[int_cnt][m])&iplista_mask[n]) == (iplista_ip[n]&iplista_mask[n]))
				    {
		    			iplista_fin[n] = 1;
					iplista_bool_upload[n] = 1;
				    }
				}
			    }

    			    for(n=1;n<iplista_pos;n++)
			    {
				if (! iplista_fin[n])
		    		{
			    	    del_ip2speed_table(del_tab_upload[int_cnt],iplista[n]);
				}
			    }
			    free(iplista_fin);
			}
		    }
		}
	    }
	}

	if (! continuous_control)
	{
    	    // usuwamy wszystkie ograniczenia
    	    if (debug>2) printf("debug 3: removing all QoS classes\n");
    	    cbq_off_local(config);

    	    // ustawiamy standardowe ograniczenia
    	    if (debug>2) printf("debug 3: creating root QoS classes\n");
    	    cbq_standard_on(config);
	}
	
	for(int_cnt=1;int_cnt<local_int_pos;int_cnt++)
	{
	    // jesli interfejs z internetem
	    if (local_int_tab2[1][(int_cnt*6)+5])
	    {
		reszta[int_cnt] = local_int_tab2[1][(int_cnt*6)+2];
		reszta_upload[int_cnt] = local_int_tab2[1][(int_cnt*6)+4];
	    
		for(n=1;n<local_int_pos;n++)
		    cnt[int_cnt][n] = 4;

		if (debug>2) printf("debug 3: creating user's download QoS classes for %s interface.\n",config[1][(int_cnt*6)+1]);

		// download new:
		for(n=1;n<nr[int_cnt];n++)
		{
		    int		pos;
		    char	*intf;
		    char	*ipg;
		    int		bcn,isp;
		    int		los,his;

    		    str = get_speed_table_new(speed_tab[int_cnt],n);
		    if (str[0])
		    {
			if (high_start_speed || even_division)
			{
			    his = get_ip_hispeed(str);
			    tspeed = speed[int_cnt] / mult;
			    if (tspeed > his) tspeed = his;
			    if (debug) printf("high_speed_start_dnload: %ld\n",tspeed);
			}
			else tspeed = get_ip_lospeed(str);

    			if ((pos = get_config_by_ip(config,str)) != -1)
			{
		    	    intf = get_ip_iface(str);
			    bcn = atoi(config[1][(pos*6)+5]);
			    isp = atoi(config[1][(pos*6)+2]);
			    ipg = config[1][(pos*6)+3];
			    cbq_class_add(intf,isp,tspeed,bcn,get_ip_cnt(str)+4,ipg,str,1,20,"sharing borrow",class_type);
		    	    bitrate_user_last[int_cnt] = mkbitrate_user_last(bitrate_user_last[int_cnt],str,tspeed,int_cnt);
		    	    reszta[int_cnt] = reszta[int_cnt] - tspeed;
		    	    ilip[int_cnt]--;
		    	    cnt[int_cnt][pos]++;
			    if (cnt[int_cnt][pos] > 255)
			    {
				syslog(LOG_ERR,"Ooops! Too many IP numbers. Could by problem with creating CBQ class.");
			        if (debug>2) printf("debug 3: Ooops! Too many IP numbers. Could byproblem with creating CBQ class.\n");
			    }
			}
			else
		        {
			    syslog(LOG_ERR,"Interface name for IP number %s not found in  /etc/shaper/iplist.%d",str,shaperd_counter);
			    if (debug>2) printf("debug 3: Interface name for IP number %s not found in  /etc/shaper/iplist.%d",str,shaperd_counter);
			}
			if (debug) printf("new_dnload:  %s\n",str);
		    }
		}

		// upload new:
		if (divide_upload) {
		for(n=1;n<nr_upload[int_cnt];n++)
		{
		    int		pos;
		    char	*intf;
		    char	*ipg;
		    int		bcn,isp;
		    int		los,his;

    		    str = get_speed_table_new(speed_tab_upload[int_cnt],n);
		    if (str[0])
		    {
			if (high_start_speed || even_division)
			{
			    his = get_ip_hispeed_upload(str);
			    tspeed = speed_upload[int_cnt] / mult;
			    if (tspeed > his) tspeed = his;
			    if (debug) printf("high_speed_start_upload: %ld\n",tspeed);
			}
			else tspeed = get_ip_lospeed_upload(str);

    			if ((pos = get_config_by_ip_upload(config,str)) != -1)
			{
		    	    intf = get_ip_int_iface(str);
			    bcn = atoi(config[1][(pos*6)+3]);
			    isp = local_int_tab2[1][(int_cnt*6)+4];
			    ipg = config[1][(pos*6)+3];
			    cbq_class_add_upload(intf,isp,tspeed,bcn,get_ip_cnt(str)+4,ipg,str,1,20,"sharing borrow",upload_class_type);
		    	    bitrate_user_last_upload[int_cnt] = mkbitrate_user_last_upload(bitrate_user_last_upload[int_cnt],str,tspeed,int_cnt);
		    	    reszta_upload[int_cnt] = reszta_upload[int_cnt] - tspeed;
		    	    ilip_upload[int_cnt]--;
//		    	    cnt[int_cnt][pos]++;
//			    if (cnt[int_cnt][pos] > 255)
//			    {
//				syslog(LOG_ERR,"Ooops! Too many IP numbers. Could by problem with creating CBQ class.");
//			        if (debug>2) printf("debug 3: Ooops! Too many IP numbers. Could byproblem with creating CBQ class.\n");
//			    }
			}
			else
		        {
			    syslog(LOG_ERR,"Interface name for IP number %s not found in  /etc/shaper/iplist.%d",str,shaperd_counter);
			    if (debug>2) printf("debug 3: Interface name for IP number %s not found in  /etc/shaper/iplist.%d",str,shaperd_counter);
			}
			if (debug) printf("new_upload:  %s\n",str);
		    }
		}
		}
//printf("1\n");
		// download sub1:
		for(n=1;n<nr[int_cnt];n++)
		{
	    	    int		pos;
	    	    char	*intf;
		    char	*ipg;
	    	    int		bcn,isp;
		    int		his,los;

		    str = get_speed_table_sub1(speed_tab[int_cnt],n);
		    if (str[0])
		    {
	        	lastbitrate = ckbitrate_user_last(bitrate_user_last[int_cnt],str,int_cnt) * mult;
	        	if (! even_division) tspeed = (lastbitrate * 0.8) / mult;
			else tspeed = speed[int_cnt] / mult;
		        los = get_ip_lospeed(str);
			if (tspeed > (reszta[int_cnt] / ilip[int_cnt])) tspeed = reszta[int_cnt] / ilip[int_cnt];
	        	if (! even_division && tspeed < los) tspeed = los;
    	    	        if ((pos = get_config_by_ip(config,str)) != -1)
			{
	    	            intf = get_ip_iface(str);
		            bcn = atoi(config[1][(pos*6)+5]);
		            isp = atoi(config[1][(pos*6)+2]);
		    	    ipg = config[1][(pos*6)+3];
			    if (! continuous_control) cbq_class_add(intf,isp,tspeed,bcn,get_ip_cnt(str)+4,ipg,str,0,20,"",class_type);
			    else cbq_class_change(intf,isp,tspeed,bcn,get_ip_cnt(str)+4,ipg,str,0,20,"",class_type);
		            bitrate_user_last[int_cnt] = mkbitrate_user_last(bitrate_user_last[int_cnt],str,tspeed,int_cnt);
		            reszta[int_cnt] = reszta[int_cnt] - tspeed;
		            ilip[int_cnt]--;
		            cnt[int_cnt][pos]++;
			    if (cnt[int_cnt][pos] > 255)
			    {
			        syslog(LOG_ERR,"Ooops! Too many IP numbers. Could by problem with creating CBQ class.");
			        if (debug>2) printf("debug 3: Ooops! Too many IP numbers. Could byproblem with creating CBQ class.\n");
			    }
			}
		        else
	    	        {
		    	    syslog(LOG_ERR,"Interface name for IP number %s not found in  /etc/shaper/iplist.%d",str,shaperd_counter);
			    if (debug>2) printf("debug 3: Interface name for IP number %s not found in  /etc/shaper/iplist.%d",str,shaperd_counter);
			}
		        if (debug) printf("sub1_dnload::  %s\n",str);
		    }
		}
//printf("2\n");
		// upload sub1:
		if (divide_upload) {
		for(n=1;n<nr_upload[int_cnt];n++)
		{
	    	    int		pos;
	    	    char	*intf;
		    char	*ipg;
	    	    int		bcn,isp;
		    int		his,los;

		    str = get_speed_table_sub1(speed_tab_upload[int_cnt],n);
		    if (str[0])
		    {
	        	lastbitrate = ckbitrate_user_last_upload(bitrate_user_last_upload[int_cnt],str,int_cnt) * mult;
	        	if (! even_division) tspeed = (lastbitrate * 0.8) / mult;
			else tspeed = speed_upload[int_cnt] / mult;
		        los = get_ip_lospeed_upload(str);
			if (tspeed > (reszta_upload[int_cnt] / ilip_upload[int_cnt])) tspeed = reszta_upload[int_cnt] / ilip_upload[int_cnt];
	        	if (! even_division && tspeed < los) tspeed = los;
    	    	        if ((pos = get_config_by_ip_upload(config,str)) != -1)
			{
	    	            intf = get_ip_int_iface(str);
		            bcn = atoi(config[1][(pos*6)+3]);
			    isp = local_int_tab2[1][(int_cnt*6)+4];
		    	    ipg = config[1][(pos*6)+3];
			    if (! continuous_control) cbq_class_add_upload(intf,isp,tspeed,bcn,get_ip_cnt(str)+4,ipg,str,0,20,"",upload_class_type);
			    else cbq_class_change_upload(intf,isp,tspeed,bcn,get_ip_cnt(str)+4,ipg,str,0,20,"",upload_class_type);
		            bitrate_user_last_upload[int_cnt] = mkbitrate_user_last_upload(bitrate_user_last_upload[int_cnt],str,tspeed,int_cnt);
		            reszta_upload[int_cnt] = reszta_upload[int_cnt] - tspeed;
		            ilip_upload[int_cnt]--;
//		            cnt[int_cnt][pos]++;
//			    if (cnt[int_cnt][pos] > 255)
//			    {
//			        syslog(LOG_ERR,"Ooops! Too many IP numbers. Could by problem with creating CBQ class.");
//			        if (debug>2) printf("debug 3: Ooops! Too many IP numbers. Could byproblem with creating CBQ class.\n");
//			    }
			}
		        else
	    	        {
		    	    syslog(LOG_ERR,"Interface name for IP number %s not found in  /etc/shaper/iplist.%d",str,shaperd_counter);
			    if (debug>2) printf("debug 3: Interface name for IP number %s not found in  /etc/shaper/iplist.%d",str,shaperd_counter);
			}
		        if (debug) printf("sub1_upload:  %s\n",str);
		    }
		}
		}
//printf("3\n");
		// download nop1:
		for(n=1;n<nr[int_cnt];n++)
		{
		    int		pos;
	    	    char	*intf;
		    char        *ipg;
	    	    int		bcn,isp;
		    int		los,his;

		    str = get_speed_table_nop1(speed_tab[int_cnt],n);
	    	    if (str[0])
	    	    {
	    	        lastbitrate = ckbitrate_user_last(bitrate_user_last[int_cnt],str,int_cnt) * mult;
		        his = get_ip_hispeed(str);
		        if (! even_division) tspeed = lastbitrate / mult;
			else tspeed = speed[int_cnt] / mult;
			if (tspeed > (reszta[int_cnt] / ilip[int_cnt])) tspeed = reszta[int_cnt] / ilip[int_cnt];
		        if (tspeed > his) tspeed = his;
		        if (tspeed > reszta[int_cnt]) tspeed = reszta[int_cnt];
    			if ((pos = get_config_by_ip(config,str)) != -1)
		        {
		            intf = get_ip_iface(str);
			    bcn = atoi(config[1][(pos*6)+5]);
		            isp = atoi(config[1][(pos*6)+2]);
		    	    ipg = config[1][(pos*6)+3];
		    	    if (! continuous_control) cbq_class_add(intf,isp,tspeed,bcn,get_ip_cnt(str)+4,ipg,str,1,20,"",class_type);
			    else cbq_class_change(intf,isp,tspeed,bcn,get_ip_cnt(str)+4,ipg,str,1,20,"",class_type);
		    	    bitrate_user_last[int_cnt] = mkbitrate_user_last(bitrate_user_last[int_cnt],str,tspeed,int_cnt);
		    	    reszta[int_cnt] = reszta[int_cnt] - tspeed;
		    	    ilip[int_cnt]--;
		    	    cnt[int_cnt][pos]++;
			    if (cnt[int_cnt][pos] > 255)
			    {
			        syslog(LOG_ERR,"Ooops! Too many IP numbers. Could by problem with creating CBQ class.");
				if (debug>2) printf("debug 3: Ooops! Too many IP numbers. Could byproblem with creating CBQ class.\n");
			    }
			}
		        else
			{
			    syslog(LOG_ERR,"Interface name for IP number %s not found in  /etc/shaper/iplist.%d",str,shaperd_counter);
			    if (debug>2) printf("debug 3: Interface name for IP number %s not found in  /etc/shaper/iplist.%d",str,shaperd_counter);
			}
			if (debug) printf("nop1_dnload:  %s\n",str);
		    }
		}
//printf("4\n");
		// upload nop1:
		if (divide_upload) {
		for(n=1;n<nr_upload[int_cnt];n++)
		{
		    int		pos;
	    	    char	*intf;
		    char        *ipg;
	    	    int		bcn,isp;
		    int		los,his;

//printf("a\n");
		    str = get_speed_table_nop1(speed_tab_upload[int_cnt],n);
//printf("aa\n");
	    	    if (str[0])
	    	    {
//printf("b\n");
	    	        lastbitrate = ckbitrate_user_last_upload(bitrate_user_last_upload[int_cnt],str,int_cnt) * mult;
		        his = get_ip_hispeed_upload(str);
//printf("c\n");
		        if (! even_division) tspeed = lastbitrate / mult;
			else tspeed = speed_upload[int_cnt] / mult;
			if (tspeed > (reszta_upload[int_cnt] / ilip_upload[int_cnt])) tspeed = reszta_upload[int_cnt] / ilip_upload[int_cnt];
		        if (tspeed > his) tspeed = his;
		        if (tspeed > reszta_upload[int_cnt]) tspeed = reszta_upload[int_cnt];
//printf("d\n");
    			if ((pos = get_config_by_ip_upload(config,str)) != -1)
		        {
		            intf = get_ip_int_iface(str);
			    bcn = atoi(config[1][(pos*6)+3]);
			    isp = local_int_tab2[1][(int_cnt*6)+4];
		    	    ipg = config[1][(pos*6)+3];
		    	    if (! continuous_control) cbq_class_add_upload(intf,isp,tspeed,bcn,get_ip_cnt(str)+4,ipg,str,1,20,"",upload_class_type);
			    else cbq_class_change_upload(intf,isp,tspeed,bcn,get_ip_cnt(str)+4,ipg,str,1,20,"",upload_class_type);
		    	    bitrate_user_last_upload[int_cnt] = mkbitrate_user_last_upload(bitrate_user_last_upload[int_cnt],str,tspeed,int_cnt);
		    	    reszta_upload[int_cnt] = reszta_upload[int_cnt] - tspeed;
		    	    ilip_upload[int_cnt]--;
//		    	    cnt[int_cnt][pos]++;
//			    if (cnt[int_cnt][pos] > 255)
//			    {
//			        syslog(LOG_ERR,"Ooops! Too many IP numbers. Could by problem with creating CBQ class.");
//				if (debug>2) printf("debug 3: Ooops! Too many IP numbers. Could byproblem with creating CBQ class.\n");
//			    }
			}
		        else
			{
			    syslog(LOG_ERR,"Interface name for IP number %s not found in  /etc/shaper/iplist.%d",str,shaperd_counter);
			    if (debug>2) printf("debug 3: Interface name for IP number %s not found in  /etc/shaper/iplist.%d",str,shaperd_counter);
			}
			if (debug) printf("nop1_upload:  %s\n",str);
		    }
		}
		}
//printf("5\n");
		// download add1:
		for(n=1;n<nr[int_cnt];n++)
		{
	    	    int		pos;
	    	    char	*intf;
		    char        *ipg;
		    int		bcn,isp;
		    int		los,his;

	    	    str = get_speed_table_add1(speed_tab[int_cnt],n);
		    if (str[0])
	    	    {
	    	        lastbitrate = ckbitrate_user_last(bitrate_user_last[int_cnt],str,int_cnt) * mult;
		        los = get_ip_lospeed(str);
		        his = get_ip_hispeed(str);
		        if (! even_division)
			{
			    if (jump_type) tspeed = ((lastbitrate/mult) + (los * jump_type));
			    else tspeed = ((lastbitrate/mult) + (reszta[int_cnt] / ilip[int_cnt]));
			}
			else tspeed = speed[int_cnt] / mult;
		        if (tspeed > (reszta[int_cnt] / ilip[int_cnt])) tspeed = reszta[int_cnt] / ilip[int_cnt];
			if (tspeed > his) tspeed = his;
		        if (tspeed > reszta[int_cnt]) tspeed = reszta[int_cnt];
    		        if ((pos = get_config_by_ip(config,str)) != -1)
		        {
	    	            intf = get_ip_iface(str);
		            bcn = atoi(config[1][(pos*6)+5]);
		            isp = atoi(config[1][(pos*6)+2]);
		    	    ipg = config[1][(pos*6)+3];
		    	    if (! continuous_control) cbq_class_add(intf,isp,tspeed,bcn,get_ip_cnt(str)+4,ipg,str,2,20,"",class_type);
			    else cbq_class_change(intf,isp,tspeed,bcn,get_ip_cnt(str)+4,ipg,str,2,20,"",class_type);
			    bitrate_user_last[int_cnt] = mkbitrate_user_last(bitrate_user_last[int_cnt],str,tspeed,int_cnt);
		    	    reszta[int_cnt] = reszta[int_cnt] - tspeed;
		    	    ilip[int_cnt]--;
		    	    cnt[int_cnt][pos]++;
			    if (cnt[int_cnt][pos] > 255)
			    {
			        syslog(LOG_ERR,"Ooops! Too many IP numbers. Could by problem with creating CBQ class.");
			        if (debug>2) printf("debug 3: Ooops! Too many IP numbers. Could byproblem with creating CBQ class.\n");
			    }
			}
		        else
		        {
		    	    syslog(LOG_ERR,"Interface name for IP number %s not found in  /etc/shaper/iplist.%d",str,shaperd_counter);
			    if (debug>2) printf("debug 3: Interface name for IP number %s not found in  /etc/shaper/iplist.%d",str,shaperd_counter);
			}
			if (debug) printf("add1_dnload:  %s\n",str);
		    }
    		}
//printf("6\n");
		// upload add1:
		if (divide_upload) {
		for(n=1;n<nr_upload[int_cnt];n++)
		{
	    	    int		pos;
	    	    char	*intf;
		    char        *ipg;
		    int		bcn,isp;
		    int		los,his;

//printf("a\n");
	    	    str = get_speed_table_add1(speed_tab_upload[int_cnt],n);
//printf("aa\n");
		    if (str[0])
	    	    {
//printf("b\n");
	    	        lastbitrate = ckbitrate_user_last_upload(bitrate_user_last_upload[int_cnt],str,int_cnt) * mult;
		        los = get_ip_lospeed_upload(str);
		        his = get_ip_hispeed_upload(str);
//printf("c\n");
		        if (! even_division)
			{
			    if (jump_type) tspeed = ((lastbitrate/mult) + (los * jump_type));
			    else tspeed = ((lastbitrate/mult) + (reszta_upload[int_cnt] / ilip_upload[int_cnt]));
			}
			else tspeed = speed_upload[int_cnt] / mult;
		        if (tspeed > (reszta_upload[int_cnt] / ilip_upload[int_cnt])) tspeed = reszta_upload[int_cnt] / ilip_upload[int_cnt];
			if (tspeed > his) tspeed = his;
		        if (tspeed > reszta_upload[int_cnt]) tspeed = reszta_upload[int_cnt];
//printf("d\n");
    		        if ((pos = get_config_by_ip_upload(config,str)) != -1)
		        {
	    	            intf = get_ip_int_iface(str);
		            bcn = atoi(config[1][(pos*6)+3]);
			    isp = local_int_tab2[1][(int_cnt*6)+4];
		    	    ipg = config[1][(pos*6)+3];
		    	    if (! continuous_control) cbq_class_add_upload(intf,isp,tspeed,bcn,get_ip_cnt(str)+4,ipg,str,2,20,"",upload_class_type);
			    else cbq_class_change_upload(intf,isp,tspeed,bcn,get_ip_cnt(str)+4,ipg,str,2,20,"",upload_class_type);
			    bitrate_user_last_upload[int_cnt] = mkbitrate_user_last_upload(bitrate_user_last_upload[int_cnt],str,tspeed,int_cnt);
		    	    reszta_upload[int_cnt] = reszta_upload[int_cnt] - tspeed;
		    	    ilip_upload[int_cnt]--;
//		    	    cnt[int_cnt][pos]++;
//			    if (cnt[int_cnt][pos] > 255)
//			    {
//			        syslog(LOG_ERR,"Ooops! Too many IP numbers. Could by problem with creating CBQ class.");
//			        if (debug>2) printf("debug 3: Ooops! Too many IP numbers. Could byproblem with creating CBQ class.\n");
//			    }
			}
		        else
		        {
		    	    syslog(LOG_ERR,"Interface name for IP number %s not found in  /etc/shaper/iplist.%d",str,shaperd_counter);
			    if (debug>2) printf("debug 3: Interface name for IP number %s not found in  /etc/shaper/iplist.%d",str,shaperd_counter);
			}
			if (debug) printf("add1_upload:  %s\n",str);
		    }
//printf("x\n");
    		}
		}
//printf("7\n");
		// download sub2:
		for(n=1;n<nr[int_cnt];n++)
	        {
    	    	    int		pos;
		    char		*intf;
		    char            *ipg;
	    	    int		bcn,isp;
		    int		his,los;

	    	    str = get_speed_table_sub2(speed_tab[int_cnt],n);
	    	    if (str[0])
	    	    {
		        lastbitrate = ckbitrate_user_last(bitrate_user_last[int_cnt],str,int_cnt) * mult;
		        if (! even_division) tspeed = (lastbitrate * 0.8) / mult;
			else tspeed = speed[int_cnt] / mult;
		        los = get_ip_lospeed(str);
			if (tspeed > (reszta[int_cnt] / ilip[int_cnt])) tspeed = reszta[int_cnt] / ilip[int_cnt];
		        if (tspeed > reszta[int_cnt]) tspeed = reszta[int_cnt];
			if (! even_division && tspeed < los) tspeed = los;
    	    	        if ((pos = get_config_by_ip(config,str)) != -1)
	    	        {
	    		    intf = get_ip_iface(str);
			    bcn = atoi(config[1][(pos*6)+5]);
		    	    isp = atoi(config[1][(pos*6)+2]);
			    ipg = config[1][(pos*6)+3];
		    	    if (! continuous_control) cbq_class_add(intf,isp,tspeed,bcn,get_ip_cnt(str)+4,ipg,str,2,5,"bounded",class_type);
			    else cbq_class_change(intf,isp,tspeed,bcn,get_ip_cnt(str)+4,ipg,str,2,5,"bounded",class_type);
			    bitrate_user_last[int_cnt] = mkbitrate_user_last(bitrate_user_last[int_cnt],str,tspeed,int_cnt);
		    	    reszta[int_cnt] = reszta[int_cnt] - tspeed;
		    	    ilip[int_cnt]--;
		    	    cnt[int_cnt][pos]++;
			    if (cnt[int_cnt][pos] > 255)
			    {
				syslog(LOG_ERR,"Ooops! Too many IP numbers. Could by problem with creating CBQ class.");
			        if (debug>2) printf("debug 3: Ooops! Too many IP numbers. Could byproblem with creating CBQ class.\n");
			    }
			}
	    	        else
			{
			    syslog(LOG_ERR,"Interface name for IP number %s not found in  /etc/shaper/iplist.%d",str,shaperd_counter);
			    if (debug>2) printf("debug 3: Interface name for IP number %s not found in  /etc/shaper/iplist.%d",str,shaperd_counter);
	    		}
	    		if (debug) printf("sub2_dnload:  %s\n",str);
		    }
		}
//printf("8\n");
		// upload sub2:
		if (divide_upload) {
		for(n=1;n<nr_upload[int_cnt];n++)
	        {
    	    	    int		pos;
		    char	*intf;
		    char        *ipg;
	    	    int		bcn,isp;
		    int		his,los;

	    	    str = get_speed_table_sub2(speed_tab_upload[int_cnt],n);
	    	    if (str[0])
	    	    {
		        lastbitrate = ckbitrate_user_last_upload(bitrate_user_last_upload[int_cnt],str,int_cnt) * mult;
		        if (! even_division) tspeed = (lastbitrate * 0.8) / mult;
			else tspeed = speed_upload[int_cnt] / mult;
		        los = get_ip_lospeed_upload(str);
			if (tspeed > (reszta_upload[int_cnt] / ilip_upload[int_cnt])) tspeed = reszta_upload[int_cnt] / ilip_upload[int_cnt];
		        if (tspeed > reszta_upload[int_cnt]) tspeed = reszta_upload[int_cnt];
			if (! even_division && tspeed < los) tspeed = los;
    	    	        if ((pos = get_config_by_ip_upload(config,str)) != -1)
	    	        {
	    		    intf = get_ip_int_iface(str);
			    bcn = atoi(config[1][(pos*6)+3]);
			    isp = local_int_tab2[1][(int_cnt*6)+4];
			    ipg = config[1][(pos*6)+3];
		    	    if (! continuous_control) cbq_class_add_upload(intf,isp,tspeed,bcn,get_ip_cnt(str)+4,ipg,str,2,5,"bounded",upload_class_type);
			    else cbq_class_change_upload(intf,isp,tspeed,bcn,get_ip_cnt(str)+4,ipg,str,2,5,"bounded",upload_class_type);
			    bitrate_user_last_upload[int_cnt] = mkbitrate_user_last_upload(bitrate_user_last_upload[int_cnt],str,tspeed,int_cnt);
		    	    reszta_upload[int_cnt] = reszta_upload[int_cnt] - tspeed;
		    	    ilip_upload[int_cnt]--;
//		    	    cnt[int_cnt][pos]++;
//			    if (cnt[int_cnt][pos] > 255)
//			    {
//				syslog(LOG_ERR,"Ooops! Too many IP numbers. Could by problem with creating CBQ class.");
//			        if (debug>2) printf("debug 3: Ooops! Too many IP numbers. Could byproblem with creating CBQ class.\n");
//			    }
			}
	    	        else
			{
			    syslog(LOG_ERR,"Interface name for IP number %s not found in  /etc/shaper/iplist.%d",str,shaperd_counter);
			    if (debug>2) printf("debug 3: Interface name for IP number %s not found in  /etc/shaper/iplist.%d",str,shaperd_counter);
	    		}
	    		if (debug) printf("sub2_upload:  %s\n",str);
		    }
		}
		}
//printf("9\n");
		// download nop2
	        for(n=1;n<nr[int_cnt];n++)
    		{
	    	    int		pos;
	    	    char	*intf;
		    char        *ipg;
		    int		bcn,isp;
		    int		los,his;

		    str = get_speed_table_nop2(speed_tab[int_cnt],n);
	    	    if (str[0])
	    	    {
	        	lastbitrate = ckbitrate_user_last(bitrate_user_last[int_cnt],str,int_cnt) * mult;
	    	        if (! even_division) tspeed = lastbitrate / mult;
			else tspeed = speed[int_cnt] / mult;
			his = get_ip_hispeed(str);
	    	        if (tspeed > (reszta[int_cnt] / ilip[int_cnt])) tspeed = reszta[int_cnt] / ilip[int_cnt];
			if (tspeed > his) tspeed = his;
		        if (tspeed > reszta[int_cnt]) tspeed = reszta[int_cnt];
    	    	        if ((pos = get_config_by_ip(config,str)) != -1)
	    		{
			    intf = get_ip_iface(str);
			    bcn = atoi(config[1][(pos*6)+5]);
			    isp = atoi(config[1][(pos*6)+2]);
			    ipg = config[1][(pos*6)+3];
			    if (! continuous_control) cbq_class_add(intf,isp,tspeed,bcn,get_ip_cnt(str)+4,ipg,str,3,2,"bounded",class_type);
			    else cbq_class_change(intf,isp,tspeed,bcn,get_ip_cnt(str)+4,ipg,str,3,2,"bounded",class_type);
		    	    bitrate_user_last[int_cnt] = mkbitrate_user_last(bitrate_user_last[int_cnt],str,tspeed,int_cnt);
		    	    reszta[int_cnt] = reszta[int_cnt] - tspeed;
		    	    ilip[int_cnt]--;
		    	    cnt[int_cnt][pos]++;
			    if (cnt[int_cnt][pos] > 255)
			    {
			        syslog(LOG_ERR,"Ooops! Too many IP numbers. Could by problem with creating CBQ class.");
			        if (debug>2) printf("debug 3: Ooops! Too many IP numbers. Could byproblem with creating CBQ class.\n");
			    }
			}
	    	        else
	    		{
			    syslog(LOG_ERR,"Interface name for IP number %s not found in  /etc/shaper/iplist.%d",str,shaperd_counter);
			    if (debug>2) printf("debug 3: Interface name for IP number %s not found in  /etc/shaper/iplist.%d",str,shaperd_counter);
			}
	    	        if (debug) printf("nop2_dnload:  %s\n",str);
		    }
		}
//printf("10\n");
		// upload nop2
		if (divide_upload) {
	        for(n=1;n<nr_upload[int_cnt];n++)
    		{
	    	    int		pos;
	    	    char	*intf;
		    char        *ipg;
		    int		bcn,isp;
		    int		los,his;

		    str = get_speed_table_nop2(speed_tab_upload[int_cnt],n);
	    	    if (str[0])
	    	    {
	        	lastbitrate = ckbitrate_user_last_upload(bitrate_user_last_upload[int_cnt],str,int_cnt) * mult;
	    	        if (! even_division) tspeed = lastbitrate / mult;
			else tspeed = speed_upload[int_cnt] / mult;
			his = get_ip_hispeed_upload(str);
	    	        if (tspeed > (reszta_upload[int_cnt] / ilip_upload[int_cnt])) tspeed = reszta_upload[int_cnt] / ilip_upload[int_cnt];
			if (tspeed > his) tspeed = his;
		        if (tspeed > reszta_upload[int_cnt]) tspeed = reszta_upload[int_cnt];
    	    	        if ((pos = get_config_by_ip_upload(config,str)) != -1)
	    		{
			    intf = get_ip_int_iface(str);
			    bcn = atoi(config[1][(pos*6)+3]);
//			    isp = atoi(config[1][(pos*6)+2]);
			    isp = local_int_tab2[1][(int_cnt*6)+4];
			    ipg = config[1][(pos*6)+3];
			    if (! continuous_control) cbq_class_add_upload(intf,isp,tspeed,bcn,get_ip_cnt(str)+4,ipg,str,3,2,"bounded",upload_class_type);
			    else cbq_class_change_upload(intf,isp,tspeed,bcn,get_ip_cnt(str)+4,ipg,str,3,2,"bounded",upload_class_type);
		    	    bitrate_user_last_upload[int_cnt] = mkbitrate_user_last_upload(bitrate_user_last_upload[int_cnt],str,tspeed,int_cnt);
		    	    reszta_upload[int_cnt] = reszta_upload[int_cnt] - tspeed;
		    	    ilip_upload[int_cnt]--;
//		    	    cnt[int_cnt][pos]++;
//			    if (cnt[int_cnt][pos] > 255)
//			    {
//			        syslog(LOG_ERR,"Ooops! Too many IP numbers. Could by problem with creating CBQ class.");
//			        if (debug>2) printf("debug 3: Ooops! Too many IP numbers. Could byproblem with creating CBQ class.\n");
//			    }
			}
	    	        else
	    		{
			    syslog(LOG_ERR,"Interface name for IP number %s not found in  /etc/shaper/iplist.%d",str,shaperd_counter);
			    if (debug>2) printf("debug 3: Interface name for IP number %s not found in  /etc/shaper/iplist.%d",str,shaperd_counter);
			}
	    	        if (debug) printf("nop2_dnload:  %s\n",str);
		    }
		}
		}
//printf("11\n");
		// download add2
		for(n=1;n<nr[int_cnt];n++)
    		{
	    	    int		pos;
		    char		*intf;
		    char            *ipg;
		    int		bcn,isp;
		    int		los,his;

		    str = get_speed_table_add2(speed_tab[int_cnt],n);
	    	    if (str[0])
		    {
		        lastbitrate = ckbitrate_user_last(bitrate_user_last[int_cnt],str,int_cnt) * mult;
			los = get_ip_lospeed(str);
		        his = get_ip_hispeed(str);
		        if (! even_division)
			{
			    if (jump_type) tspeed = ((lastbitrate/mult) + (los * jump_type));
			    else tspeed = ((lastbitrate/mult) + (reszta[int_cnt] / ilip[int_cnt]));
			}
			else tspeed = speed[int_cnt] / mult;
			if (tspeed > (reszta[int_cnt] / ilip[int_cnt])) tspeed = reszta[int_cnt] / ilip[int_cnt];
		        if (tspeed > his) tspeed = his;
    			if ((pos = get_config_by_ip(config,str)) != -1)
	    		{
			    intf = get_ip_iface(str);
		    	    bcn = atoi(config[1][(pos*6)+5]);
		    	    isp = atoi(config[1][(pos*6)+2]);
			    ipg = config[1][(pos*6)+3];
			    if (! continuous_control) cbq_class_add(intf,isp,tspeed,bcn,get_ip_cnt(str)+4,ipg,str,3,1,"bounded",class_type);
			    else cbq_class_change(intf,isp,tspeed,bcn,get_ip_cnt(str)+4,ipg,str,3,1,"bounded",class_type);
		    	    bitrate_user_last[int_cnt] = mkbitrate_user_last(bitrate_user_last[int_cnt],str,tspeed,int_cnt);
		    	    reszta[int_cnt] = reszta[int_cnt] - tspeed;
		    	    ilip[int_cnt]--;
		    	    cnt[int_cnt][pos]++;
			    if (cnt[int_cnt][pos] > 255)
			    {
				syslog(LOG_ERR,"Ooops! Too many IP numbers. Could by problem with creating CBQ class.");
				if (debug>2) printf("debug 3: Ooops! Too many IP numbers. Could byproblem with creating CBQ class.\n");
			    }
			}
			else
			{
			    syslog(LOG_ERR,"Interface name for IP number %s not found in  /etc/shaper/iplist.%d",str,shaperd_counter);
			    if (debug>2) printf("debug 3: Interface name for IP number %s not found in  /etc/shaper/iplist.%d",str,shaperd_counter);
			}
			if (debug) printf("add2_dnload:  %s\n",str);
		    }
		}
//printf("12\n");
		// upload add2
		if (divide_upload) {
		for(n=1;n<nr_upload[int_cnt];n++)
    		{
	    	    int		pos;
		    char	*intf;
		    char        *ipg;
		    int		bcn,isp;
		    int		los,his;

		    str = get_speed_table_add2(speed_tab_upload[int_cnt],n);
	    	    if (str[0])
		    {
		        lastbitrate = ckbitrate_user_last_upload(bitrate_user_last_upload[int_cnt],str,int_cnt) * mult;
			los = get_ip_lospeed_upload(str);
		        his = get_ip_hispeed_upload(str);
		        if (! even_division)
			{
			    if (jump_type) tspeed = ((lastbitrate/mult) + (los * jump_type));
			    else tspeed = ((lastbitrate/mult) + (reszta_upload[int_cnt] / ilip_upload[int_cnt]));
			}
			else tspeed = speed_upload[int_cnt] / mult;
			if (tspeed > (reszta_upload[int_cnt] / ilip_upload[int_cnt])) tspeed = reszta_upload[int_cnt] / ilip_upload[int_cnt];
		        if (tspeed > his) tspeed = his;
    			if ((pos = get_config_by_ip_upload(config,str)) != -1)
	    		{
			    intf = get_ip_int_iface(str);
		    	    bcn = atoi(config[1][(pos*6)+3]);
			    isp = local_int_tab2[1][(int_cnt*6)+4];
			    ipg = config[1][(pos*6)+3];
			    if (! continuous_control) cbq_class_add_upload(intf,isp,tspeed,bcn,get_ip_cnt(str)+4,ipg,str,3,1,"bounded",upload_class_type);
			    else cbq_class_change_upload(intf,isp,tspeed,bcn,get_ip_cnt(str)+4,ipg,str,3,1,"bounded",upload_class_type);
		    	    bitrate_user_last_upload[int_cnt] = mkbitrate_user_last_upload(bitrate_user_last_upload[int_cnt],str,tspeed,int_cnt);
		    	    reszta_upload[int_cnt] = reszta_upload[int_cnt] - tspeed;
		    	    ilip_upload[int_cnt]--;
//		    	    cnt[int_cnt][pos]++;
//			    if (cnt[int_cnt][pos] > 255)
//			    {
//				syslog(LOG_ERR,"Ooops! Too many IP numbers. Could by problem with creating CBQ class.");
//				if (debug>2) printf("debug 3: Ooops! Too many IP numbers. Could byproblem with creating CBQ class.\n");
//			    }
			}
			else
			{
			    syslog(LOG_ERR,"Interface name for IP number %s not found in  /etc/shaper/iplist.%d",str,shaperd_counter);
			    if (debug>2) printf("debug 3: Interface name for IP number %s not found in  /etc/shaper/iplist.%d",str,shaperd_counter);
			}
			if (debug) printf("add2_upload:  %s\n",str);
		    }
		}
		}

//		printf("reszta=%ld\n",reszta[int_cnt]);

		if (reszta[int_cnt] < 0)
		{
		    syslog(LOG_ERR,"Total of assigned download bandwidth is more than hispeed!");
		    if (debug)
		    {
			printf("debug: Total of assigned download bandwidth is more than hispeed!\n");
		    }
		}

		if (divide_upload && reszta_upload[int_cnt] < 0)
		{
		    syslog(LOG_ERR,"Total of assigned upload bandwidth is more than hispeed!");
		    if (debug)
		    {
			printf("debug: Total of assigned upload bandwidth is more than hispeed!\n");
		    }
		}

		// download
		if (continuous_control)
		{
		    for(n=1;n<iplista_pos;n++)
    		    {
	    		int		pos;
		        char		*intf;
		        char        	*ipg;
		        int		bcn,isp;
		        int		los,his;
		        int		fin, m;

			str = get_speed_table_del(del_tab[int_cnt],n);
	    		if (str[0])
		        {
		    	    lastbitrate = ckbitrate_user_last(bitrate_user_last[int_cnt],str,int_cnt) * mult;

			    fin = 0;
			    for(m=1;m<iplista_pos;m++)
				if (!strcmp(iplista[m],str) && !strcmp(str,iplista[m])) fin = m;

			    if (iplista_bool[fin] == 1)
			    {
				iplista_bool[fin] = 0;
			        los = get_ip_lospeed(str);
		    	        his = get_ip_hispeed(str);
			        tspeed = ((lastbitrate/mult) + los);
    				if ((pos = get_config_by_ip(config,str)) != -1)
	    		        {
				    intf = get_ip_iface(str);
		    	    	    bcn = atoi(config[1][(pos*6)+5]);
		    		    isp = atoi(config[1][(pos*6)+2]);
			    	    ipg = config[1][(pos*6)+3];
				    cbq_class_del(intf,isp,lastbitrate/mult,bcn,get_ip_cnt(str)+4,ipg,str,3,1,"",class_type);
				}
				else
				{
				    syslog(LOG_ERR,"Interface name for IP number %s not found in  /etc/shaper/iplist.%d",str,shaperd_counter);
				    if (debug>2) printf("debug 3: Interface name for IP number %s not found in  /etc/shaper/iplist.%d",str,shaperd_counter);
				}
				if (debug) printf("del_dnload:  %s\n",str);
			    }
			}
		    }
		}

		// upload
		if (divide_upload) {
		if (continuous_control)
		{
		    for(n=1;n<iplista_pos;n++)
    		    {
	    		int		pos;
		        char		*intf;
		        char        	*ipg;
		        int		bcn,isp;
		        int		los,his;
		        int		fin, m;

			str = get_speed_table_del(del_tab_upload[int_cnt],n);
	    		if (str[0])
		        {
		    	    lastbitrate = ckbitrate_user_last_upload(bitrate_user_last_upload[int_cnt],str,int_cnt) * mult;

			    fin = 0;
			    for(m=1;m<iplista_pos;m++)
				if (!strcmp(iplista[m],str) && !strcmp(str,iplista[m])) fin = m;

			    if (iplista_bool_upload[fin] == 1)
			    {
				iplista_bool_upload[fin] = 0;
			        los = get_ip_lospeed_upload(str);
		    	        his = get_ip_hispeed_upload(str);
			        tspeed = ((lastbitrate/mult) + los);
    				if ((pos = get_config_by_ip_upload(config,str)) != -1)
	    		        {
				    intf = get_ip_int_iface(str);
		    	    	    bcn = atoi(config[1][(pos*6)+3]);
//		    		    isp = atoi(config[1][(pos*6)+2]);
				    isp = local_int_tab2[1][(int_cnt*6)+4];
			    	    ipg = config[1][(pos*6)+3];
				    cbq_class_del_upload(intf,isp,lastbitrate/mult,bcn,get_ip_cnt(str)+4,ipg,str,3,1,"",upload_class_type);
				}
				else
				{
				    syslog(LOG_ERR,"Interface name for IP number %s not found in  /etc/shaper/iplist.%d",str,shaperd_counter);
				    if (debug>2) printf("debug 3: Interface name for IP number %s not found in  /etc/shaper/iplist.%d",str,shaperd_counter);
				}
				if (debug) printf("del_upload:  %s\n",str);
			    }
			}
		    }
		}
		}
	    }
	}

	// sprawdzamy czas przydzialu widelek, jesli za dlugi w stosunku do
	// opoznienia delay to zwiekszamy opoznienie o 10%
	// jesli czas jest bardzo krotki to zmniejszamy opoznienie.
	delta_time = time(NULL)-start_time;
	if (debug) printf("Time of creating allocations %d\n",delta_time);

	if (delta_time*5 > delay)
	{
	    delay = delta_time * 5;
	    if (debug)
	    {
    		syslog(LOG_INFO,"Delay parameter has too low amount for this number of IP's or possibility of server.");
		syslog(LOG_INFO,"Increasing delay to %d seconds",delay);
	        printf("debug: Delay parameter has too low amount for this number of IP's or possibility of server.\n");
	        printf("debug: Increasing delay to %d seconds\n",delay);
	    }
	}
	else
	if (delta_time*5 < delay)
	{
	    delay = delta_time * 5;
	    if (delay <= delay_org) delay = delay_org;
	    else
	    {
		if (debug)
		{
	    	    syslog(LOG_INFO,"delay parameter has too high amount.");
	    	    syslog(LOG_INFO,"Decreasing delay to %d seconds",delay);
	            printf("debug: Delay parameter has too high amount.\n");
		    printf("debug: Decreasing delay to %d seconds\n",delay);
		}
	    }
	}

/*
	n=0;
	start_time = time(NULL);
	while(!exit_signal && n<delay)
	{
	    sleep(1);
	    n++;
	}
	delta_time = time(NULL)-start_time;
	if (debug) printf("Delay time %d\n",delta_time);
*/

	// zapisujemy plik bitrate_user_sh.old
	old++;
	if (old >= olddelay)
	{
	    for(int_cnt=1;int_cnt<local_int_pos;int_cnt++)
	    {
		if (local_int_tab2[1][(int_cnt*6)+5])
		{
		    if (nr[int_cnt]-1 == 1 && !check_always)
		    {
	    		bitrate_user_last[int_cnt] = clear_bitrate_user_last(bitrate_user_last[int_cnt],masq[int_cnt],int_cnt);
			bitrate_user_last[int_cnt] = mkbitrate_user_last(bitrate_user_last[int_cnt],masq[int_cnt][1],local_int_tab2[1][(int_cnt*6)+2],int_cnt);
			if (divide_upload)
			{
	    		    bitrate_user_last_upload[int_cnt] = clear_bitrate_user_last_upload(bitrate_user_last_upload[int_cnt],masq_upload[int_cnt],int_cnt);
			    bitrate_user_last_upload[int_cnt] = mkbitrate_user_last_upload(bitrate_user_last_upload[int_cnt],masq_upload[int_cnt][1],local_int_tab2[1][(int_cnt*6)+4],int_cnt);
			}
		    }
		    else
		    if (nr[int_cnt]-1 < 1)
		    {
	    		bitrate_user_last[int_cnt] = clear_bitrate_user_last(bitrate_user_last[int_cnt],masq[int_cnt],int_cnt);
	    		if (divide_upload) bitrate_user_last_upload[int_cnt] = clear_bitrate_user_last_upload(bitrate_user_last_upload[int_cnt],masq_upload[int_cnt],int_cnt);
		    }
/*
		    if (debug>2) printf("debug 3: free_masqip memory allocation\n");
		    free_masqip(masq[int_cnt],int_cnt);
		    if (debug>2) printf("debug 3: free_speed_table memory allocation\n");
    		    free_speed_table(speed_tab[int_cnt],nr[int_cnt]);
    		    free_speed_table(del_tab[int_cnt],iplista_pos+1);
*/
		}
	    }
	    if (debug>2) printf("debug 3: writing /var/shaper/bitrate_user_sh.%d.old file\n",shaperd_counter);
	    write_bitrate_user_last(bitrate_user_last,oldfile,int_cnt);
	    if (divide_upload)
	    {
		if (debug>2) printf("debug 3: writing /var/shaper/bitrate_user_up.%d.old file\n",shaperd_counter);
		write_bitrate_user_last_upload(bitrate_user_last_upload,oldfile_upload,int_cnt);
	    }
	    old = 0;
	}
	
	// robimy opoznienie
	n=0;
	start_time = time(NULL);
	while(!exit_signal && n<delay)
	{
	    sleep(1);
	    n++;
	}

	// obliczamy czas tworzenia widelek
	delta_time = time(NULL)-start_time;
	if (debug) printf("Delay time %d\n",delta_time);

	for(int_cnt=1;int_cnt<local_int_pos;int_cnt++)
	{
	    if (local_int_tab2[1][(int_cnt*6)+5])
	    {
		if (debug>2) printf("debug 3: free_masqip memory allocation\n");
	        free_masqip(masq[int_cnt],int_cnt);
	        if (divide_upload) free_masqip_upload(masq_upload[int_cnt],int_cnt);
		if (debug>2) printf("debug 3: free_speed_table memory allocation\n");
    		free_speed_table(speed_tab[int_cnt],nr[int_cnt]);
    		free_speed_table(del_tab[int_cnt],iplista_pos+1);
    		if (divide_upload)
		{
		    free_speed_table(speed_tab_upload[int_cnt],nr_upload[int_cnt]);
    		    free_speed_table(del_tab_upload[int_cnt],iplista_pos+1);
		}
	    }
	}

	if (debug>2) printf("debug 3: free_natstat_tab memory allocation\n");
    	free_natstat_tab(nattab);
    	if (divide_upload) free_natstat_tab_upload(nattab_upload);
    }
    // usuwamy wszystkie ograniczenia
    if (debug>2) printf("debug 3: removing all QoS classes\n");
    cbq_off_all(config);

    // usuwamy PID
    if (debug) printf("Removing %s\n",pidfile);
    remove(pidfile);

    closelog();
    if (debug>2) printf("debug 3: free_bitrate_user_last memory allocation\n");
    
    for(int_cnt=1;int_cnt<local_int_pos;int_cnt++)
    {
        if (local_int_tab2[1][(int_cnt*6)+5])
        {
	    free_bitrate_user_last(bitrate_user_last[int_cnt],int_cnt);
	    if (divide_upload) free_bitrate_user_last_upload(bitrate_user_last_upload[int_cnt],int_cnt);
	}
    }
    if (debug>2) printf("debug 3: removing firewall shaperd rules\n");
    delete_firewall(config,firewall_type);
    if (debug>2) printf("debug 3: free_ignore memory allocation\n");
    free_ignore(ignore);
    if (debug>2) printf("debug 3: free_config memory allocation\n");
    free_config(config);
    if (debug>2) printf("debug 3: frmem memory allocation\n");
    frmem();
    if (debug>2) printf("debug 3: exiting\n");
    exit(0);
}

void frmem(void)
{
    int		m;

    if (iplista)
    {
	m = 0;
	while(iplista[m])
	{
	    free(iplista[m]);
	    free(iplista_iface[m]);
	    free(iplista_int_iface[m++]);
	}
	free(iplista);
    }
    if (iplista_ip) free(iplista_ip);
    if (iplista_mask) free(iplista_mask);
    if (iplista_bool) free(iplista_bool);
    if (divide_upload) if (iplista_bool_upload) free(iplista_bool_upload);
    if (iplista_lo) free(iplista_lo);
    if (iplista_hi) free(iplista_hi);
    if (divide_upload)
    {
	if (iplista_lo_upload) free(iplista_lo_upload);
	if (iplista_hi_upload) free(iplista_hi_upload);
    }
    if (ipspeed) free(ipspeed);
    if (ipspeed_last) free(ipspeed_last);
    if (ipspeed_last2) free(ipspeed_last2);
    if (ipspeed_last2_counter) free(ipspeed_last2_counter);
    if (iptime) free(iptime);
    if (iptime_last) free(iptime_last);

    if (divide_upload)
    {
	if (ipspeed_upload) free(ipspeed_upload);
	if (ipspeed_last_upload) free(ipspeed_last_upload);
	if (ipspeed_last2_upload) free(ipspeed_last2_upload);
        if (ipspeed_last2_counter_upload) free(ipspeed_last2_counter_upload);
	if (iptime_upload) free(iptime_upload);
        if (iptime_last_upload) free(iptime_last_upload);
    }

    if (squid_speed) free(squid_speed);
    if (squid_speed_last) free(squid_speed_last);
    if (squid_speed_last2) free(squid_speed_last2);
    if (squid_time) free(squid_time);
    if (squid_time_last) free(squid_time_last);

    if (devlist)
    {
	for(m=1;m<devlist_pos;m++)
	{
	    free(devlist[m]);
	}
	free(devlist);
    }

    return;
}

void error(char *fmt, ...)
{
    va_list	args;

    va_start(args, fmt);
    fprintf(stderr, "shaperd%d: ",shaperd_counter);
    vfprintf(stderr, fmt, args);
    fprintf(stderr,"\n");
    va_end(args);

    frmem();

    exit(1);
}

int my_system (const char *command)
{
    char	*environ[]=
    {
	"HOME=/",
	"PATH=/sbin:/bin:/usr/sbin:/usr/bin",
	"TERM=linux",
	NULL
    };

    int pid, status;

    if (command == 0)
	return 1;
    pid = fork();
    if (pid == -1)
	return -1;
    if (pid == 0)
    {
	char *argv[4];

	argv[0] = "sh";
	argv[1] = "-c";
	argv[2] = (char *) command;
	argv[3] = 0;
	execve("/bin/sh", argv, environ);
	exit(127);
    }
    do
    {
	if (waitpid(pid, &status, 0) == -1)
	{
	    if (errno != EINTR) return -1;
	}
	else return status;
    }
    while(1);
}

int numlines(char *fname)
{
    FILE	*fp;
    int		line=0;
    char	buf[1000];
    
    if (!(fp = fopen(fname,"r")))
    {
	syslog(LOG_ERR,"File %s not found.",fname);
	error("debug 3: File %s not found.\ndebug 3: exiting\n",fname);
    }
    while(fgets(buf,1000,fp))
    {
	if (buf[0] != '#') line++;
    }
    fclose(fp);
    return(line);
}

unsigned long int ckbitrate_user(char *ip)
{
    int		m,n,pos;
    FILE	*fp;
    char	buf[1000];
    char	ip_tmp[20];
    char	ipt[20];
    long unsigned int	d1,d2,sp,tm,res;

    res = 0;
//    ip = ip2ip_with_mask(ip_)
    for(n=1;n<iplista_pos;n++)
    {
	if ((ip2hex2(ip)&iplista_mask[n]) == (iplista_ip[n]&iplista_mask[n]))
//	   || (!strcmp(iplista[n],ip) && (!strcmp(ip,iplista[n]))))
//	if ((!strcmp(iplista[n],ip) && (!strcmp(ip,iplista[n]))))
	{
	    sp = ipspeed[n]-ipspeed_last[n];
	    if (squid)
	    {
//		printf("sp=%lu sq=%lu\n",sp,squid_speed[n]-squid_speed_last[n]);
		sp = sp + (squid_speed[n]-squid_speed_last[n]);
	    }
	    tm = iptime[n]-iptime_last[n];
	    if (tm > 0)
	    {
		res = ((sp/tm)*8);
		ipspeed_last[n] = ipspeed[n];
		iptime_last[n] = iptime[n];
		if (squid)
		{
		    squid_speed_last[n] = squid_speed[n];
		    squid_time_last[n] = squid_time[n];
		}
	    }
	}
    }
    return(res);
}

unsigned long int ckbitrate_user_upload(char *ip)
{
    int		m,n,pos;
    FILE	*fp;
    char	buf[1000];
    char	ip_tmp[20];
    char	ipt[20];
    long unsigned int	d1,d2,sp,tm,res;

    res = 0;
    for(n=1;n<iplista_pos;n++)
    {
	if ((ip2hex2(ip)&iplista_mask[n]) == (iplista_ip[n]&iplista_mask[n]))
	{
	    sp = ipspeed_upload[n]-ipspeed_last_upload[n];
	    tm = iptime_upload[n]-iptime_last_upload[n];
	    if (tm > 0)
	    {
		res = ((sp/tm)*8);
		ipspeed_last_upload[n] = ipspeed_upload[n];
		iptime_last_upload[n] = iptime_upload[n];
	    }
	}
    }
    return(res);
}

void read_iplist(char ***config)
{
    int		f1,m,n;
    struct	stat stbuf;
    int		d1,d2,d3,d4;
    int		m1,m2,m3,m4;
    long unsigned int	d5,d6,d7,d8;
    char	*src;
    char 	*ip, *mask;
    char	iface[10];
    char	int_iface[10];
    char	buf[30];
    char	bufor[1000];
    FILE	*fp;

    m = numlines(iplistfile) + 1;
    iplista = (char **) calloc(m,sizeof(char *));
    iplista_ip    = (int *) calloc(m,sizeof(int));
    iplista_mask  = (int *) calloc(m,sizeof(int));
    iplista_iface = (char **) calloc(m,sizeof(char *));
    iplista_int_iface = (char **) calloc(m,sizeof(char *));
    iplista_lo = (long unsigned int *) calloc(m,sizeof(long unsigned int));
    iplista_hi = (long unsigned int *) calloc(m,sizeof(long unsigned int));
    if (divide_upload)
    {
	iplista_lo_upload = (long unsigned int *) calloc(m,sizeof(long unsigned int));
        iplista_hi_upload = (long unsigned int *) calloc(m,sizeof(long unsigned int));
        iplista_bool_upload = (int *) calloc(m,sizeof(int));
    }
    iplista_bool = (int *) calloc(m,sizeof(int));
    ipspeed = (long unsigned int *) calloc(m,sizeof(long unsigned int));
    iptime  = (long unsigned int *) calloc(m,sizeof(long unsigned int));
    ipspeed_last = (long unsigned int *) calloc(m,sizeof(long unsigned int));
    ipspeed_last2= (long unsigned int *) calloc(m,sizeof(long unsigned int));
    ipspeed_last2_counter = (long unsigned int *) calloc(m,sizeof(long unsigned int));
    iptime_last  = (long unsigned int *) calloc(m,sizeof(long unsigned int));
    if (divide_upload)
    {
        ipspeed_upload = (long unsigned int *) calloc(m,sizeof(long unsigned int));
	iptime_upload = (long unsigned int *) calloc(m,sizeof(long unsigned int));
        ipspeed_last_upload  = (long unsigned int *) calloc(m,sizeof(long unsigned int));
        ipspeed_last2_upload = (long unsigned int *) calloc(m,sizeof(long unsigned int));
	ipspeed_last2_counter_upload = (long unsigned int *) calloc(m,sizeof(long unsigned int));
	iptime_last_upload = (long unsigned int *) calloc(m,sizeof(long unsigned int));
    }
    if (squid)
    {
    squid_speed = (long unsigned int *) calloc(m,sizeof(long unsigned int));
    squid_time  = (long unsigned int *) calloc(m,sizeof(long unsigned int));
    squid_speed_last = (long unsigned int *) calloc(m,sizeof(long unsigned int));
    squid_speed_last2= (long unsigned int *) calloc(m,sizeof(long unsigned int));
    squid_time_last  = (long unsigned int *) calloc(m,sizeof(long unsigned int));
    }
    
    iplista_pos = 1;
    fp = fopen(iplistfile,"r");
    while ((fgets(bufor,1000,fp)) != NULL)
    {
	if (bufor[0] != '#' && strlen(bufor))
	{
	    d5 = 0;
	    d6 = 0;
	    d7 = 0;
	    d8 = 0;
	    if (strchr(bufor,'/'))
	    {
		char 	*iface2;
	
	        ip = strtok(bufor,"/");
		mask = strtok(NULL,"=");
	        iface2= strtok(NULL,"\n");
		sscanf(iface2,"%s %s %lu %lu %lu %lu",iface,int_iface,&d5,&d6,&d7,&d8);
	        sprintf(buf,"%s/%s",ip,mask);
	    }
	    else
	    {
	        sscanf(bufor,"%3d.%3d.%3d.%3d=%s %s %lu %lu %lu %lu\n",&d1,&d2,&d3,&d4,iface,int_iface,&d5,&d6,&d7,&d8);
	        mask = "32";
	        sprintf(buf,"%d.%d.%d.%d/%s",d1,d2,d3,d4,mask);
	    }
	    iplista[iplista_pos] = (char *) calloc(strlen(buf)+2,sizeof(char));
	    iplista_ip[iplista_pos]   = (int) calloc(1,sizeof(int));
	    iplista_mask[iplista_pos] = (int) calloc(1,sizeof(int));
	    iplista_bool[iplista_pos] = (int) calloc(1,sizeof(int));
	    if (divide_upload) iplista_bool_upload[iplista_pos] = (int) calloc(1,sizeof(int));
	    iplista_iface[iplista_pos] = (char *) calloc(strlen(iface)+2,sizeof(char));
	    iplista_int_iface[iplista_pos] = (char *) calloc(strlen(int_iface)+2,sizeof(char));

	    for(n=1;n<local_int_pos;n++)
	    {
	        if (local_int_tab2[1][(n*6)+5]
	    	    && !strcmp(int_iface,config[1][(n*6)+1])
		    && !strcmp(config[1][(n*6)+1],int_iface))
		{
		    // download
		    if (d5 == 0) d5 = local_int_tab2[1][(n*6)+1];  //lospeed
		    if (d5 > local_int_tab2[1][(n*6)+2]) d5 = local_int_tab2[1][(n*6)+2]; //hispeed
		    if (d6 == 0) d6 = local_int_tab2[1][(n*6)+2]; //hispeed
		    if (d6 > local_int_tab2[1][(n*6)+2]) d6 = local_int_tab2[1][(n*6)+2]; //hispeed
		    // upload
		    if (d7 == 0) d7 = local_int_tab2[1][(n*6)+3];  //lospeed
		    if (d7 > local_int_tab2[1][(n*6)+3]) d7 = local_int_tab2[1][(n*6)+3]; //hispeed
		    if (d8 == 0) d8 = local_int_tab2[1][(n*6)+4]; //hispeed
		    if (d8 > local_int_tab2[1][(n*6)+4]) d8 = local_int_tab2[1][(n*6)+4]; //hispeed
		}
	    }
	    iplista_lo[iplista_pos] = d5;
	    iplista_hi[iplista_pos] = d6;
	    if (divide_upload)
	    {
		iplista_lo_upload[iplista_pos] = d7;
		iplista_hi_upload[iplista_pos] = d8;
	    }
	    strcpy(iplista[iplista_pos],buf);
	    iplista_ip[iplista_pos]   = ip2hex2(buf);
	    iplista_mask[iplista_pos] = mask2hex2(mask);
	    iplista_bool[iplista_pos] = 0;
	    if (divide_upload) iplista_bool_upload[iplista_pos] = 0;
	    strcpy(iplista_iface[iplista_pos],iface);
	    strcpy(iplista_int_iface[iplista_pos],int_iface);
	    if (debug)
	    {
		printf("read_iplist: %s %x %x %s %s %lu %lu %lu %lu %x\n",
		    iplista[iplista_pos],iplista_ip[iplista_pos],
		    iplista_mask[iplista_pos],
		    iplista_iface[iplista_pos],
		    iplista_int_iface[iplista_pos],
		    d5,d6,d7,d8,
		    iplista_ip[iplista_pos] & iplista_mask[iplista_pos]);
	    }
	    iplista_pos++;
	}
    }
    fclose(fp);
}

void read_firewall(int firewall_type)
{
    int		f1,m,n;
    struct	stat stbuf;
    unsigned long int	cnt1,cnt2;
    unsigned long int	dd1,dd2,dd3,dd4;
    char	aa[12][20];
    char	*src;
    char	buf[30];
    char	buft[1000];
    char	pop[200];

    FILE	*fp;

    fflush(NULL);

    if (firewall_type==1)
    {
	sprintf(pop,"ipchains -vxL shaper%d -n 2> /dev/null\n",shaperd_counter);
	if (!(fp = popen(pop,"r")))
	{
	    syslog(LOG_ERR,"Can't read shaper%d table from ipchains",shaperd_counter);
	    error("Can't read shaper%d table from ipchains.\nExiting\n",shaperd_counter);
	}
    }
    else
    if (firewall_type==2)
    {
	sprintf(pop,"iptables -vxL shaper%d -n 2> /dev/null\n",shaperd_counter);
	if (!(fp = popen(pop,"r")))
	{
	    syslog(LOG_ERR,"Can't read shaper%d table from iptables",shaperd_counter);
	    error("Can't read shaper%d table from iptables.\nExiting\n",shaperd_counter);
	}
    }
    else
    {
	syslog(LOG_ERR,"BUG: firewall type %d not exists!",firewall_type);
	error("BUG: firewall type %d not exists!\nExiting\n",firewall_type);
    }

    while ((fgets(buft,1000,fp))!=NULL)
    {
	char	bufor[200];
	char	ipt[20];

	sscanf(buft,"%lu %lu %s %s %s %s %s %s %s %s %s",
	    &dd1,&dd2,aa[3],aa[4],aa[5],aa[6],aa[7],aa[8],aa[9],aa[10],aa[11]);
	for(m=1;m<iplista_pos;m++)
	{
	    if (iplista_mask[m] == 0xffffffff)
	    {
		char	*res = hex2ip(iplista_ip[m]&iplista_mask[m]);
		
		strcpy(ipt,res);
		free(res);
	    }
	    else
	    {
		strcpy(ipt,iplista[m]);
	    }

	    strcat(ipt," ");
//	    printf("read_firewall_cmp: %s %s %s\n",iplista[m],buft,ipt);
	    if (strstr(buft,ipt))
	    {
		ipspeed[m] = dd2;
		iptime[m]  = (long unsigned int) time(NULL);
//		if (debug > 1) printf("read_firewall: %s %lu %lu\n",iplista[m],ipspeed[m],iptime[m]);
		if (debug > 1) printf("read_firewall: %s %x %lu %lu\n",iplista[m],iplista_ip[m]&iplista_mask[m],ipspeed[m],iptime[m]);
	    }
	}
    }
    pclose(fp);
}

void read_firewall_upload(int firewall_type)
{
    int		f1,m,n;
    struct	stat stbuf;
    unsigned long int	cnt1,cnt2;
    unsigned long int	dd1,dd2,dd3,dd4;
    char	aa[12][20];
    char	*src;
    char	buf[30];
    char	buft[1000];
    char	pop[200];

    FILE	*fp;

    fflush(NULL);
    if (firewall_type==1)
    {
	sprintf(pop,"ipchains -vxL shaout%d -n 2> /dev/null\n",shaperd_counter);
	if (!(fp = popen(pop,"r")))
	{
	    syslog(LOG_ERR,"Can't read shaout%d table from ipchains",shaperd_counter);
	    error("debug 3: Can't read shaout%d table from ipchains.\nExiting\n",shaperd_counter);
	}
    }
    else
    if (firewall_type==2)
    {
	sprintf(pop,"iptables -vxL shaout%d -n 2> /dev/null\n",shaperd_counter);
	if (!(fp = popen(pop,"r")))
	{
	    syslog(LOG_ERR,"Can't read shaout%d table from iptables",shaperd_counter);
	    error("debug 3: Can't read shaout%d table from iptables.\nExiting\n",shaperd_counter);
	}
    }
    else
    {
	if (debug) syslog(LOG_ERR,"BUG: firewall type %d not exists!",firewall_type);
	error("BUG: firewall type %d not exists!\nExiting\n",firewall_type);
    }
//    fgets(buft,1000,fp);
//    fgets(buft,1000,fp);
    while ((fgets(buft,1000,fp))!=NULL)
    {
	char	bufor[200];
	char	ipt[20];

//	printf("%s\n",buft);
	sscanf(buft,"%lu %lu %s %s %s %s %s %s %s %s %s",
	    &dd1,&dd2,aa[3],aa[4],aa[5],aa[6],aa[7],aa[8],aa[9],aa[10],aa[11]);
	for(m=1;m<iplista_pos;m++)
	{
	    if (iplista_mask[m] == 0xffffffff)
	    {
		char	*res = hex2ip(iplista_ip[m]&iplista_mask[m]);
		
		strcpy(ipt,res);
		free(res);
	    }
	    else
	    {
		strcpy(ipt,iplista[m]);
	    }

	    strcat(ipt," ");
//	    printf("read_firewall_cmp: %s %s %s\n",iplista[m],buft,ipt);
	    if (strstr(buft,ipt))
	    {
		ipspeed_upload[m] = dd2;
		iptime_upload[m]  = (long unsigned int) time(NULL);
		if (debug > 1) printf("read_firewall_upload: %s %x %lu %lu\n",iplista[m],iplista_ip[m]&iplista_mask[m],ipspeed_upload[m],iptime_upload[m]);
	    }
	}
    }
    pclose(fp);
}

void write_bitrate(char *fname)
{
    FILE	*fw;
    int		m;
    int		fd;
    char	buf[200];

    fd = creat(fname,0644);
    for(m=1;m<iplista_pos;m++)
    {
	sprintf(buf,"%s %lu %lu\n",iplista[m],ipspeed[m],iptime[m]);
	write(fd,buf,strlen(buf));
    }
    close(fd);
}

char **dev_list(void)
{
    FILE        *fp;
    int         m,n;
    char	buft[1000];
    char	*buftptr=buft;
    char	iface[10];
    char	*devlist_cont;
    char	*res;

    m=numlines(DEVFILE);
    devlist = (char **) calloc(m+2,sizeof(char *));
    fp = fopen(DEVFILE,"r");
    fgets(buft,1000,fp);
    fgets(buft,1000,fp);
    while ((fgets(buft,1000,fp))!=NULL)
    {
	res=strtok(buft,":");
	while(isspace(*res))
	    res++;

	devlist[devlist_pos] = (char *) calloc(strlen(res)+2,sizeof(char));
	strcpy(devlist[devlist_pos],res);
	if (debug > 1) printf("devlist: %s\n",devlist[devlist_pos]);
	devlist_pos++;
    }
    fclose(fp);
    return(devlist);
}

void cbq_off(char *dev)
{
    char	buf[200];
    FILE	*fp;

    fflush(NULL);
    if (!notc && (fp = popen("/bin/sh 2>/dev/null","w")))
    {
        sprintf(buf,"tc qdisc del dev %s root 2>/dev/null\n",dev);
	if (debug > 3) printf("%s",buf);
	fputs(buf,fp);
        sprintf(buf,"tc qdisc del dev %s ingress 2>/dev/null\n",dev);
	if (debug > 3) printf("%s",buf);
	fputs(buf,fp);
	pclose(fp);
    }
}

void cbq_off_local(char ***config)
{
    int		n;

    for(n=1;n<local_int_pos;n++)
    {
	if (!(local_int_tab2[1][(n*6)+5]))
    	    cbq_off(config[1][(n*6)+1]);
    }
}

void cbq_off_all(char ***config)
{
    int		n;

    for(n=1;n<local_int_pos;n++)
    {
        cbq_off(config[1][(n*6)+1]);
    }
}

void cbq_setup_root(char *iface, unsigned long int max_speed, int id1, int type)
{
    unsigned long int	ts;
    char	buf[4000];
    FILE	*fp;

    fflush(NULL);
    if (!notc && (fp = popen("/bin/sh 2>/dev/null","w")))
    {
	ts = max_speed/id1;
	if (type == 0)
	{
	    if (debug > 0) printf("cbq_setup_root:\n");
	    sprintf(buf,"tc qdisc add dev %s root handle %d: cbq bandwidth %lu%s avpkt 1000 cell 8\n",
		    iface,id1,max_speed,speed_ext);
	    if (debug > 3) printf("%s",buf);
	    fputs(buf,fp);
	}
	else
	if (type == 1)
	{
	    if (debug > 0) printf("htb_setup_root:\n");
	    sprintf(buf,"tc qdisc add dev %s root handle %d: htb default 2\n",
		    iface,id1);
	    fputs(buf,fp);
	    if (debug > 3) printf("%s",buf);
	}
	if (type == 0)
	{
    	    sprintf(buf,"tc class add dev %s parent %d:0 classid %d:1 cbq bandwidth %lu%s rate %lu%s allot 1514 cell 8 weight %lu%s prio 1 maxburst 20 avpkt 1000\n",
		    iface,id1,id1,max_speed,speed_ext,max_speed,speed_ext,ts,speed_ext);
	}
	else
	if (type == 1)
	{
	    int		burst;
	    int		mult;

	    if (! strcmp(speed_ext,"bit")) mult = 1;
	    else if (! strcmp(speed_ext,"kbit")) mult = 1024;
	    else if (! strcmp(speed_ext,"mbit")) mult = 1048576;
	    burst = (max_speed * mult)/8;
    	    sprintf(buf,"tc class add dev %s parent %d:0 classid %d:1 htb rate %lu%s burst %d\n",
		    iface,id1,id1,max_speed,speed_ext,burst);
	}
	if (debug > 3) printf("%s",buf);
	fputs(buf,fp);
	pclose(fp);
    }
}

//void cbq_setup_clas(char *mainip, char *iface, unsigned long int max_speed, int id1, char *ipg, char *ipd)
void cbq_setup_clas(char *iface, unsigned long int max_speed, int id1, char *ipg, char *ipd, int type)
{
    char        buf[2000];
    FILE	*fp;

    fflush(NULL);
    if (!notc && (fp = popen("/bin/sh 2>/dev/null","w")))
    {
	if (type == 0)
	{
	    sprintf(buf,"tc class add dev %s parent %d:1 classid %d:2 cbq bandwidth %lu%s rate %lu%s allot 1514 cell 8 weight 1kbit prio 2 maxburst 20 avpkt 1000 bounded\n",
	    	    iface, id1, id1, max_speed, speed_ext, max_speed, speed_ext);
	    if (debug > 0) printf("cbq_setup_clas:\n");
	}
	else
	if (type == 1)
	{
	    int		burst;
	    int		mult;

	    if (! strcmp(speed_ext,"bit")) mult = 1;
	    else if (! strcmp(speed_ext,"kbit")) mult = 1024;
	    else if (! strcmp(speed_ext,"mbit")) mult = 1048576;
	    burst = (max_speed * mult)/8;
	    sprintf(buf,"tc class add dev %s parent %d:1 classid %d:2 htb rate %lu%s burst %d\n",
		    iface, id1, id1, max_speed, speed_ext, burst);
	    if (debug > 0) printf("htb_setup_clas:\n");
	}
	if (debug > 3) printf("%s",buf);
	fputs(buf,fp);
	if (type == 0)
	{
    	    sprintf(buf,"tc qdisc add dev %s parent %d:2 tbf rate %lu%s buffer 10Kb limit 15Kb\n",
	    	    iface, id1, max_speed, speed_ext);
	}
	else
	if (type == 1)
	{
    	    sprintf(buf,"tc qdisc add dev %s parent %d:2 handle %d: sfq perturb 10\n",
	    	    iface, id1, (id1*10)+2);
	}

	if (debug > 3) printf("%s",buf);
	fputs(buf,fp);

	if (squid)
	{
	// wszystkie pakiety z serwera proxy i portu 8192 z wyzerowanym TOS
    	sprintf(buf,"tc filter add dev %s parent %d:0 protocol ip prio 3 handle %d::%d u32 match ip src %s match ip sport 0x2000 0xffff match ip tos 0 0xff flowid %d:2\n",
	        iface, id1, 800, 1, ipg, id1);
	if (debug > 3) printf("%s",buf);
	fputs(buf,fp);
	// pozostale pakiety z serwera lokalnego bez portu 8192
    	sprintf(buf,"tc filter add dev %s parent %d:0 protocol ip prio 3 handle %d::%d u32 match ip src %s match ip sport 0x0 0xe000 flowid %d:2\n",
	    iface, id1, 800, 2, ipg, id1);
	if (debug > 3) printf("%s",buf);
	fputs(buf,fp);
    	sprintf(buf,"tc filter add dev %s parent %d:0 protocol ip prio 3 handle %d::%d u32 match ip src %s match ip sport 0x2001 0x2001 flowid %d:2\n",
	    iface, id1, 800, 3, ipg, id1);
	if (debug > 3) printf("%s",buf);
	fputs(buf,fp);
	}
	else
	{
        sprintf(buf,"tc filter add dev %s parent %d:0 protocol ip prio 100 handle %d::%d u32 match ip src %s match ip sport 0 0x0 match ip dst %s flowid %d:2\n",
	        iface, id1, 800, 1, ipg, ipd, id1);
	if (debug > 3) printf("%s",buf);
	fputs(buf,fp);
//	sprintf(buf,"tc filter add dev %s parent %d:0 protocol ip prio 100 u32 match ip src %s match ip sport 0 0x0 match ip dst %s flowid %d:2\n",
//		iface, id1, mainip, ipd, id1);
//	if (debug > 1) printf("%s",buf);
//	fputs(buf,fp);
	}
	pclose(fp);
    }
}

void cbq_setup_xfilters(char *iface, int id1, char *mainip, char *ipd)
{
    char        buf[2000];
    FILE	*fp;

    fflush(NULL);
    if (!notc && (fp = popen("/bin/sh 2>/dev/null","w")))
    {
	if (debug > 0) printf("cbq_setup_xfilters:\n");
	sprintf(buf,"tc filter add dev %s parent %d:0 protocol ip prio 100 handle %d::%d u32 match ip src %s match ip sport 0 0x0 match ip dst %s flowid %d:1\n",
		iface, id1, 800, 4, mainip, ipd, id1);
	if (debug > 3) printf("%s",buf);
	fputs(buf,fp);
	pclose(fp);
    }
}

void cbq_class_add(	char *iface, unsigned long int max_speed,
			unsigned long int t_speed, int id1, int id2,
			char *ipg, char *ipd, int pri, int maxburst,
			char *borrow, int type)
{
    int		prio = 100;
    char	buf[2000];
    FILE	*fp;

    fflush(NULL);
    if (!notc && (fp = popen("/bin/sh 2>/dev/null","w")))
    {
	if (type == 0)
	{
	    pri = pri + 2;
	    sprintf(buf,"tc class add dev %s parent %d:1 classid %d:%d cbq bandwidth %lu%s rate %lu%s allot 1600 cell 8 weight 1kbit prio %d maxburst %d avpkt 1000 %s\n",
    		    iface,id1,id1,id2,max_speed,speed_ext,t_speed,speed_ext,pri,maxburst,borrow);
	    if (debug > 0) printf("cbq_class_add:\n");
	}
	else
	if (type == 1)
	{
	    int		burst;
	    int		mult;

	    if (! strcmp(speed_ext,"bit")) mult = 1;
	    else if (! strcmp(speed_ext,"kbit")) mult = 1024;
	    else if (! strcmp(speed_ext,"mbit")) mult = 1048576;
	    burst = (t_speed * mult)/8;

//	    pri = pri - 3;
//	    if (pri < 0) pri = 0;
	    if (strstr(borrow,"bounded"))
	    {
//		sprintf(buf,"tc class add dev %s parent %d:1 classid %d:%d htb rate %lu%s ceil %lu prio %d burst %d\n",
//			iface,id1,id1,id2,t_speed,speed_ext,(unsigned long int)(t_speed*mult)+8000,pri,burst);
		sprintf(buf,"tc class add dev %s parent %d:1 classid %d:%d htb rate %lu%s prio %d burst %d\n",
			iface,id1,id1,id2,t_speed,speed_ext,pri,burst);
	    }
	    else
	    {
//		sprintf(buf,"tc class add dev %s parent %d:1 classid %d:%d htb rate %lu%s ceil %lu prio %d burst %d\n",
//    			iface,id1,id1,id2,t_speed,speed_ext,(unsigned long int)(t_speed*mult)+16000,pri,burst);
		sprintf(buf,"tc class add dev %s parent %d:1 classid %d:%d htb rate %lu%s prio %d burst %d\n",
    			iface,id1,id1,id2,t_speed,speed_ext,pri,burst);
	    }
	    if (debug > 0) printf("htb_class_add:\n");
	}

	if (debug > 3) printf("%s",buf); 
	fputs(buf,fp);
	if (type == 0)
	{
	    sprintf(buf,"tc qdisc add dev %s parent %d:%d tbf rate %lu%s buffer 10Kb limit 5Kb\n",
	    	    iface,id1,id2,t_speed,speed_ext);
	}
	else
	if (type == 1)
	{
	    sprintf(buf,"tc qdisc add dev %s parent %d:%d sfq perturb 10\n",
	    	    iface,id1,id2);
	}
	if (debug > 3) printf("%s",buf);
	fputs(buf,fp);
	if (squid)
	{
    	sprintf(buf,"tc filter add dev %s parent %d:0 protocol ip prio %d handle %d::%d u32 match ip src %s match ip sport %d 0xffff match ip tos 8 0xff match ip dst %s flowid %d:%d\n",
		iface,id1,prio,800,400+id2,ipg,squid_port,ipd,id1,id2);
	if (debug > 3) printf("%s",buf);
	fputs(buf,fp);
	}
        sprintf(buf,"tc filter add dev %s parent %d:0 protocol ip prio %d handle %d::%d u32 match ip sport 0 0x0 match ip dst %s flowid %d:%d\n",
    	        iface,id1,prio,800,100+id2,ipd,id1,id2);
	if (debug > 3) printf("%s",buf);
	fputs(buf,fp);
	pclose(fp);
    }
}

void cbq_class_add_upload(char *iface, unsigned long int max_speed,
			unsigned long int t_speed, int id1, int id2,
			char *ipg, char *ipd, int pri, int maxburst,
			char *borrow, int type)
{
    int		prio = 100;
    char	buf[2000];
    FILE	*fp;

    fflush(NULL);
    if (!notc && (fp = popen("/bin/sh 2>/dev/null","w")))
    {
	if (type == 0)
	{
	    pri = pri + 2;
	    sprintf(buf,"tc class add dev %s parent %d:1 classid %d:%d cbq bandwidth %lu%s rate %lu%s allot 1600 cell 8 weight 1kbit prio %d maxburst %d avpkt 1000 %s\n",
    		    iface,id1,id1,id2,max_speed,speed_ext,t_speed,speed_ext,pri,maxburst,borrow);
	    if (debug) printf("cbq_class_add_upload:\n");
	}
	else
	if (type == 1)
	{
	    int		burst;
	    int		mult;

	    if (! strcmp(speed_ext,"bit")) mult = 1;
	    else if (! strcmp(speed_ext,"kbit")) mult = 1024;
	    else if (! strcmp(speed_ext,"mbit")) mult = 1048576;
	    burst = (t_speed * mult)/8;

//	    pri = pri - 3;
//	    if (pri < 0) pri = 0;
	    if (strstr(borrow,"bounded"))
	    {
//		sprintf(buf,"tc class add dev %s parent %d:1 classid %d:%d htb rate %lu%s ceil %lu prio %d burst %d\n",
//			iface,id1,id1,id2,t_speed,speed_ext,(unsigned long int)(t_speed*mult)+8000,pri,burst);
		sprintf(buf,"tc class add dev %s parent %d:1 classid %d:%d htb rate %lu%s prio %d burst %d\n",
			iface,id1,id1,id2,t_speed,speed_ext,pri,burst);
	    }
	    else
	    {
//		sprintf(buf,"tc class add dev %s parent %d:1 classid %d:%d htb rate %lu%s ceil %lu prio %d burst %d\n",
//    			iface,id1,id1,id2,t_speed,speed_ext,(unsigned long int)(t_speed*mult)+16000,pri,burst);
		sprintf(buf,"tc class add dev %s parent %d:1 classid %d:%d htb rate %lu%s prio %d burst %d\n",
    			iface,id1,id1,id2,t_speed,speed_ext,pri,burst);
	    }
	    if (debug > 0) printf("htb_class_add_upload:\n");
	}

	if (debug > 3) printf("%s",buf); 
	fputs(buf,fp);
	if (type == 0)
	{
	    sprintf(buf,"tc qdisc add dev %s parent %d:%d tbf rate %lu%s buffer 10Kb limit 5Kb\n",
	    	    iface,id1,id2,t_speed,speed_ext);
	}
	else
	if (type == 1)
	{
	    sprintf(buf,"tc qdisc add dev %s parent %d:%d sfq perturb 10\n",
	    	    iface,id1,id2);
	}
	if (debug > 3) printf("%s",buf);
	fputs(buf,fp);
//        sprintf(buf,"tc filter add dev %s parent %d:0 protocol ip prio %d handle %d::%d u32 match ip sport 0 0x0 match ip dst %s flowid %d:%d\n",
//    	        iface,id1,prio,800,900+id2,ipd,id1,id2);
        sprintf(buf,"tc filter add dev %s parent %d:0 protocol ip prio %d handle %d fw classid %d:%d\n",
    	        iface,id1,10,id2+(id1*1000),id1,id2);
	if (debug > 3) printf("%s",buf);
	fputs(buf,fp);
	pclose(fp);
    }
}

void cbq_class_change(	char *iface, unsigned long int max_speed,
			unsigned long int t_speed, int id1, int id2,
			char *ipg, char *ipd, int pri, int maxburst,
			char *borrow, int type)
{
    int		prio = 100;
    char	buf[2000];
    FILE	*fp;

    fflush(NULL);
    if (!notc && (fp = popen("/bin/sh 2>/dev/null","w")))
    {
	if (type == 0)
	{
	    pri = pri + 2;
	    sprintf(buf,"tc class change dev %s parent %d:1 classid %d:%d cbq bandwidth %lu%s rate %lu%s allot 1600 cell 8 weight 1kbit prio %d maxburst %d avpkt 1000 %s\n",
    		    iface,id1,id1,id2,max_speed,speed_ext,t_speed,speed_ext,pri,maxburst,borrow);
	    if (debug > 0) printf("cbq_class_change:\n");
	}
	else
	if (type == 1)
	{
	    int		burst;
	    int		mult;

	    if (! strcmp(speed_ext,"bit")) mult = 1;
	    else if (! strcmp(speed_ext,"kbit")) mult = 1024;
	    else if (! strcmp(speed_ext,"mbit")) mult = 1048576;
	    burst = (t_speed * mult)/8;

	    if (strstr(borrow,"bounded"))
	    {
		sprintf(buf,"tc class change dev %s parent %d:1 classid %d:%d htb rate %lu%s prio %d burst %d\n",
			iface,id1,id1,id2,t_speed,speed_ext,pri,burst);
	    }
	    else
	    {
		sprintf(buf,"tc class change dev %s parent %d:1 classid %d:%d htb rate %lu%s prio %d burst %d\n",
    			iface,id1,id1,id2,t_speed,speed_ext,pri,burst);
	    }
	    if (debug > 0) printf("htb_class_change:\n");
	}
	if (debug > 3) printf("%s",buf); 
	fputs(buf,fp);

	if (type == 0)
	{
	    sprintf(buf,"tc qdisc change dev %s parent %d:%d tbf rate %lu%s buffer 10Kb limit 5Kb\n",
	    	    iface,id1,id2,t_speed,speed_ext);
	}
	else
	if (type == 1)
	{
	    sprintf(buf,"tc qdisc change dev %s parent %d:%d sfq perturb 10\n",
	    	    iface,id1,id2);
	}
	if (debug > 3) printf("%s",buf);
	fputs(buf,fp);
	pclose(fp);
    }
}

void cbq_class_change_upload(char *iface, unsigned long int max_speed,
			    unsigned long int t_speed, int id1, int id2,
			    char *ipg, char *ipd, int pri, int maxburst,
			    char *borrow, int type)
{
    int		prio = 100;
    char	buf[2000];
    FILE	*fp;

    fflush(NULL);
    if (!notc && (fp = popen("/bin/sh 2>/dev/null","w")))
    {
	if (type == 0)
	{
	    pri = pri + 2;
	    sprintf(buf,"tc class change dev %s parent %d:1 classid %d:%d cbq bandwidth %lu%s rate %lu%s allot 1600 cell 8 weight 1kbit prio %d maxburst %d avpkt 1000 %s\n",
    		    iface,id1,id1,id2,max_speed,speed_ext,t_speed,speed_ext,pri,maxburst,borrow);
	    if (debug > 0) printf("cbq_class_change_upload:\n");
	}
	else
	if (type == 1)
	{
	    int		burst;
	    int		mult;

	    if (! strcmp(speed_ext,"bit")) mult = 1;
	    else if (! strcmp(speed_ext,"kbit")) mult = 1024;
	    else if (! strcmp(speed_ext,"mbit")) mult = 1048576;
	    burst = (t_speed * mult)/8;

	    if (strstr(borrow,"bounded"))
	    {
		sprintf(buf,"tc class change dev %s parent %d:1 classid %d:%d htb rate %lu%s prio %d burst %d\n",
			iface,id1,id1,id2,t_speed,speed_ext,pri,burst);
	    }
	    else
	    {
		sprintf(buf,"tc class change dev %s parent %d:1 classid %d:%d htb rate %lu%s prio %d burst %d\n",
    			iface,id1,id1,id2,t_speed,speed_ext,pri,burst);
	    }
	    if (debug > 0) printf("htb_class_change_upload:\n");
	}
	if (debug > 3) printf("%s",buf); 
	fputs(buf,fp);

	if (type == 0)
	{
	    sprintf(buf,"tc qdisc change dev %s parent %d:%d tbf rate %lu%s buffer 10Kb limit 5Kb\n",
	    	    iface,id1,id2,t_speed,speed_ext);
	}
	else
	if (type == 1)
	{
	    sprintf(buf,"tc qdisc change dev %s parent %d:%d sfq perturb 10\n",
	    	    iface,id1,id2);
	}
	if (debug > 3) printf("%s",buf);
	fputs(buf,fp);
	pclose(fp);
    }
}

void cbq_class_del(	char *iface, unsigned long int max_speed,
			unsigned long int t_speed, int id1, int id2,
			char *ipg, char *ipd, int pri, int maxburst,
			char *borrow, int type)
{
    int		prio = 100;
    char	buf[2000];
    FILE	*fp;

    fflush(NULL);
    if (!notc && (fp = popen("/bin/sh 2>/dev/null","w")))
    {
        sprintf(buf,"tc filter del dev %s parent %d:0 protocol ip prio %d handle %d::%d u32 match ip sport 0 0x0 match ip dst %s flowid %d:%d\n",
    	        iface,id1,prio,800,100+id2,ipd,id1,id2);
	if (debug > 3) printf("%s",buf);
	fputs(buf,fp);
	if (squid)
	{
    	sprintf(buf,"tc filter del dev %s parent %d:0 protocol ip prio %d handle %d::%d u32 match ip src %s match ip sport %d 0xffff match ip tos 8 0xff match ip dst %s flowid %d:%d\n",
		iface,id1,prio,800,400+id2,ipg,squid_port,ipd,id1,id2);
	if (debug > 3) printf("%s",buf);
	fputs(buf,fp);
	}

	if (type == 0)
	{
	    sprintf(buf,"tc qdisc del dev %s parent %d:%d\n",
	    	    iface,id1,id2);
	}
	else
	if (type == 1)
	{
	    sprintf(buf,"tc qdisc del dev %s parent %d:%d\n",
	    	    iface,id1,id2);
	}
	if (debug > 3) printf("%s",buf);
	fputs(buf,fp);

	if (type == 0)
	{
	    pri = pri + 2;
	    sprintf(buf,"tc class del dev %s parent %d:1 classid %d:%d\n",
    		    iface,id1,id1,id2);
	    if (debug > 0) printf("cbq_class_del:\n");
	}
	else
	if (type == 1)
	{
	    sprintf(buf,"tc class del dev %s parent %d:1 classid %d:%d\n",
	    	    iface,id1,id1,id2);
	    if (debug > 0) printf("htb_class_del:\n");
	}
	if (debug > 3) printf("%s",buf); 
	fputs(buf,fp);
	pclose(fp);
    }
}

void cbq_class_del_upload(char *iface, unsigned long int max_speed,
			unsigned long int t_speed, int id1, int id2,
			char *ipg, char *ipd, int pri, int maxburst,
			char *borrow, int type)
{
    int		prio = 100;
    char	buf[2000];
    FILE	*fp;

    fflush(NULL);
    if (!notc && (fp = popen("/bin/sh 2>/dev/null","w")))
    {
//        sprintf(buf,"tc filter del dev %s parent %d:0 protocol ip prio %d handle %d::%d u32 match ip sport 0 0x0 match ip dst %s flowid %d:%d\n",
//    	        iface,id1,prio,800,900+id2,ipd,id1,id2);
        sprintf(buf,"tc filter del dev %s parent %d:0 protocol ip prio %d handle %d fw classid %d:%d\n",
    	        iface,id1,1,id2+1000,id1,id2);
	if (debug > 3) printf("%s",buf);
	fputs(buf,fp);

	if (type == 0)
	{
	    sprintf(buf,"tc qdisc del dev %s parent %d:%d\n",
	    	    iface,id1,id2);
	}
	else
	if (type == 1)
	{
	    sprintf(buf,"tc qdisc del dev %s parent %d:%d\n",
	    	    iface,id1,id2);
	}
	if (debug > 3) printf("%s",buf);
	fputs(buf,fp);

	if (type == 0)
	{
	    pri = pri + 2;
	    sprintf(buf,"tc class del dev %s parent %d:1 classid %d:%d\n",
    		    iface,id1,id1,id2);
	    if (debug > 0) printf("cbq_class_del:\n");
	}
	else
	if (type == 1)
	{
	    sprintf(buf,"tc class del dev %s parent %d:1 classid %d:%d\n",
	    	    iface,id1,id1,id2);
	    if (debug > 0) printf("htb_class_del:\n");
	}
	if (debug > 3) printf("%s",buf); 
	fputs(buf,fp);
	pclose(fp);
    }
}

void cbq_standard_on(char ***config)
{
    char    	*dev;
    int     	bcn;
    unsigned long int isp;
    char    	*ipg;
    char    	*ipu;
    int		n,m;
    char	*mainip = NULL;

    for(n=1;n<local_int_pos;n++)
    {
	// jesli interfejs lokalny
	if (!(local_int_tab2[1][(n*6)+5]))
	{
	    dev = config[1][(n*6)+1];
	    bcn = atoi(config[1][(n*6)+5]);
	    isp = strtoul(config[1][(n*6)+2],NULL,10);
	    ipg = config[1][(n*6)+3];
	    ipu = config[1][(n*6)+4];
	    cbq_setup_root(dev,isp,bcn,class_type);
	    cbq_setup_clas(dev,isp,bcn,ipg,ipu,class_type);
	    // dla kazdego interfejsu lokalnego tworzymy wyjatki w ograniczeniach
	    // przy transferze z numeru IP zewnetrznego
	    for(m=1;m<local_int_pos;m++)
	    {
		if ((local_int_tab2[1][(m*6)+5]))
		cbq_setup_xfilters(dev,bcn,config[1][(m*6)+2],ipu);
	    }
	}
	else
	// jesli interfejs internetowy
	if ((local_int_tab2[1][(n*6)+5]))
	{
	    dev = config[1][(n*6)+1];
//	    bcn = atoi(config[1][(n*6)+3]);
//	    isp = local_int_tab2[1][(n*6)+3];
	    bcn = atoi(config[1][(n*6)+3]);
	    isp = local_int_tab2[1][(n*6)+4];
/*
	    if (class_type == 0) isp = local_int_tab2[1][(n*6)+3];
	    else isp = local_int_tab2[1][(n*6)+2]+local_int_tab2[1][(n*6)+3];
*/
	    if (isp)
	    {
		ipg = "0.0.0.0/0";
	        ipu = "255.255.255.255/32";
		if (! mainip) mainip = config[1][(n*6)+2];
		cbq_setup_root(dev,isp,bcn,upload_class_type);
	        cbq_setup_clas(dev,isp,bcn,ipg,ipu,upload_class_type);
		if (! divide_upload) cbq_class_add(dev,isp,local_int_tab2[1][(n*6)+4],bcn,4,"0.0.0.0/0","0.0.0.0/0",3,20,"bounded",upload_class_type);
	    }
	    else
	    {
		syslog(LOG_INFO,"disabled upload bandwidth control of %s interface.",dev);
		if (debug) printf("disabled upload bandwidth control of %s interface.\n",dev);
	    }
	}
        if (debug > 0)
        {
    	    printf("cbq_standard_on:\n");
	    printf("cbq_setup_root:  %s %lu %d\n",dev,isp,bcn);
	    printf("cbq_setup_clas:  %s %s %lu %d %s %s\n",mainip,dev,isp,bcn,ipg,ipu);
	}
    }
}

char ***read_config(char *fname)
{
    int		m,n;
    int		nr_linii = 0;
    FILE	*fp;
    char	buf[1000];
    char	buf_copy[1000];
    char	ip_tmp[20];
    char	ipt[20];
    long unsigned int	d1,d2,sp,tm;
    char	*res;
    char	***local_int_tab = NULL;
    char	**local_int;

    if (!(fp = fopen(fname,"r")))
    {
	syslog(LOG_ERR,"Can't read configuration file %s",fname);
	error("Can't read configuration file %s\nExiting\n",fname);
    }
    local_int_tab = (char ***) calloc(6,sizeof(char **));
    local_int_tab2 = (int **) calloc(6,sizeof(int *));
    local_int_tab[1] = (char **) NULL;
    local_int_tab2[1] = (int *) NULL;

    while ((fgets(buf,1000,fp))!=NULL)
    {
	nr_linii++;
	strcpy(buf_copy,buf);
	if (buf[0]!='#' && strlen(buf))
	{
	    res=strtok(buf,"=");
	    if ((! strcmp("high_start_speed",res)) && (! strcmp(res,"high_start_speed")))
	    {
		res = lower(strtok(NULL,"\n"));
		if (!strcmp(res,"yes")) high_start_speed = 1;
		else
		if (!strcmp(res,"no")) high_start_speed = 0;
		else
	    	    high_start_speed = atoi(res);
	    }
	    else
	    if ((! strcmp("even_division",res)) && (! strcmp(res,"even_division")))
	    {
		res = lower(strtok(NULL,"\n"));
		if (!strcmp(res,"yes")) even_division = 1;
		else
		if (!strcmp(res,"no")) even_division = 0;
		else
	    	    even_division = atoi(res);
	    }
	    else
	    if ((! strcmp("continuous_control",res)) && (! strcmp(res,"continuous_control")))
	    {
		res = lower(strtok(NULL,"\n"));
		if (!strcmp(res,"yes")) continuous_control = 1;
		else
		if (!strcmp(res,"no")) continuous_control = 0;
		else
	    	    continuous_control = atoi(res);
	    }
	    else
	    if ((! strcmp("jump_type",res)) && (! strcmp(res,"jump_type")))
	    {
		res = strtok(NULL,"\n");
	        jump_type = atoi(res);
	    }
	    else
	    if ((! strcmp("check_always",res)) && (! strcmp(res,"check_always")))
	    {
		res = lower(strtok(NULL,"\n"));
		if (!strcmp(res,"yes")) check_always = 1;
		else
		if (!strcmp(res,"no")) check_always = 0;
		else
		    check_always = atoi(res);
	    }
	    else
	    if ((! strcmp("squid_support",res)) && (! strcmp(res,"squid_support")))
	    {
		res = lower(strtok(NULL,"\n"));
		if (!strcmp(res,"yes")) squid = 1;
		else
		if (!strcmp(res,"no")) squid = 0;
		else
	    	    squid = atoi(res);
	        if (squid) syslog(LOG_INFO,"squid_support active");
	    }
	    else
	    if ((! strcmp("divide_upload",res)) && (! strcmp(res,"divide_upload")))
	    {
		res = lower(strtok(NULL,"\n"));
		if (!strcmp(res,"yes")) divide_upload = 1;
		else
		if (!strcmp(res,"no")) divide_upload = 0;
		else
	    	    divide_upload = atoi(res);
	        if (divide_upload) syslog(LOG_INFO,"divide_upload active");
	    }
	    else
	    if ((! strcmp("nomasq",res)) && (! strcmp(res,"nomasq")))
	    {
		res = lower(strtok(NULL,"\n"));
		if (!strcmp(res,"yes")) nomasq = 1;
		else
		if (!strcmp(res,"no")) nomasq = 0;
		else
	    	    nomasq = atoi(res);
	        if (nomasq) syslog(LOG_INFO,"masquerade control deactivated");
	    }
	    else
	    if ((! strcmp("class_type",res)) && (! strcmp(res,"class_type")))
	    {
	        res = lower(strtok(NULL,"\n"));
		if (!strcmp(res,"cbq")) class_type = 0;
		else
		if (!strcmp(res,"htb")) class_type = 1;
		if (class_type) syslog(LOG_INFO,"HTB Download Class type activated");
		free(res);
	    }
	    else
	    if ((! strcmp("upload_class_type",res)) && (! strcmp(res,"upload_class_type")))
	    {
	        res = lower(strtok(NULL,"\n"));
		if (!strcmp(res,"cbq")) upload_class_type = 0;
		else
		if (!strcmp(res,"htb")) upload_class_type = 1;
		if (upload_class_type) syslog(LOG_INFO,"HTB Upload Class type activated");
		free(res);
	    }
	    else
	    if ((! strcmp("speed_ext",res)) && (! strcmp(res,"speed_ext")))
	    {
	        res = lower(strtok(NULL,"\n"));
	        if (! strcmp(res,"kbit") || ! strcmp(res,"mbit")) strncpy(speed_ext,res,10);
	        else strncpy(speed_ext,"\0",10);
		free(res);
	    }
	    else
	    if ((! strcmp("debug",res)) && (! strcmp(res,"debug")))
	    {
	        res = strtok(NULL,"\n");
	        debug = atoi(res);
	    }
	    else
	    if ((! strcmp("notc",res)) && (! strcmp(res,"notc")))
	    {
		res = lower(strtok(NULL,"\n"));
		if (!strcmp(res,"yes")) notc = 1;
		else
		if (!strcmp(res,"no")) notc = 0;
		else
	    	    notc = atoi(res);
	    }
	    else
	    if ((! strcmp("delay",res)) && (! strcmp(res,"delay")))
	    {
	        res = strtok(NULL,"\n");
	        delay = atoi(res);
	        if (delay < 10) delay = 10;
	    }
	    else
	    if ((! strcmp("write_delay",res)) && (! strcmp(res,"write_delay")))
	    {
	        res = strtok(NULL,"\n");
	        olddelay = atoi(res);
	        if (olddelay < 0) olddelay = 0;
	    }
	    else
	    if ((! strcmp("inter_int",res)) && (! strcmp(res,"inter_int")))
	    {
		if (local_int_pos < 11)
		{
		    if (count_char_in_string(buf_copy,';') == 6)
		    {
	    		local_int_tab[1] = (char **) realloc((char **) local_int_tab[1],sizeof(char *)*6*(local_int_pos+1));
			local_int_tab2[1] = (int *) realloc((int *) local_int_tab2[1],sizeof(int)*6*(local_int_pos+1));
    
			// ustawiamy 1 dla internetowych interfejsow
	    		local_int_tab2[1][(local_int_pos*6)+5] = 1;
    
			// pobieramy nazwe interfejsu internetowego
	    		res=strtok(NULL,";");
			if (is_device(res))
			{
	    		    local_int_tab[1][(local_int_pos*6)+1]= (char *) calloc(strlen(res)+2,sizeof(char));
	    		    strcpy(local_int_tab[1][(local_int_pos*6)+1],res);

	    		    // pobieramy lospeed
	    		    res=strtok(NULL,";");
	    		    local_int_tab2[1][(local_int_pos*6)+1]= strtoul(res,NULL,10);

    	    		    // pobieramy hispeed
	    		    res=strtok(NULL,";");
	    		    local_int_tab2[1][(local_int_pos*6)+2]= strtoul(res,NULL,10);

	    		    // pobieramy upload_lospeed
	    		    res=strtok(NULL,";");
	    		    local_int_tab2[1][(local_int_pos*6)+3]= strtoul(res,NULL,10);

	    		    // pobieramy upload_hispeed
	    		    res=strtok(NULL,";");
	    		    local_int_tab2[1][(local_int_pos*6)+4]= strtoul(res,NULL,10);

	        	    // pobieramy numer IP
	    		    res=strtok(NULL,";");
	    		    if (!strcmp(res,"auto"))
	    		    {
				char	*ip;

    				if (ip = get_mainip(local_int_tab[1][(local_int_pos*6)+1]))
				{
		    		    local_int_tab[1][(local_int_pos*6)+2]= (char *) calloc(strlen(ip)+2,sizeof(char));
	    	    		    strcpy(local_int_tab[1][(local_int_pos*6)+2],ip);
				}
				else
	    			{
	    	    		    syslog(LOG_ERR,"Can't read IP from %s interface.",local_int_tab[1][(local_int_pos*6)+1]);
	    	    	    	    error("Can't read IP from %s interface.\n",local_int_tab[1][(local_int_pos*6)+1]);
				}
			    }
	    		    else
	    		    {
	    			local_int_tab[1][(local_int_pos*6)+2]= (char *) calloc(strlen(res)+2,sizeof(char));
				strcpy(local_int_tab[1][(local_int_pos*6)+2],res);
			    }

	    		    // pobieramy numer klasy
	    		    res=strtok(NULL,"\n");
			    if (atoi(res)<1 || atoi(res)>255)
			    {
    				syslog(LOG_ERR,"wrong CBQ class identifier in inter_int for %s interface. Should be 1-255",local_int_tab[1][(local_int_pos*6)+1]);
				error("wrong CBQ class identifier in inter_int for %s interface. Should be 1-255",local_int_tab[1][(local_int_pos*6)+1]);
			    }
	    		    local_int_tab[1][(local_int_pos*6)+3]= (char *) calloc(strlen(res)+2,sizeof(char *));
	    		    strcpy(local_int_tab[1][(local_int_pos*6)+3],res);

        		    syslog(LOG_INFO, "using IP %s for %s internet interface",local_int_tab[1][(local_int_pos*6)+2],local_int_tab[1][(local_int_pos*6)+1]);
	    		    local_int_pos++;
			}
			else
			{
			    error("device %s not exists - in line %d of %s file",res,nr_linii,fname);
			}
		    }
		    else
		    {
			error("syntax error in line %d of %s file",nr_linii,fname);
		    }
		}
		else
		{
	    	    syslog(LOG_ERR,"Too much interfaces.");
	    	    error("Too much interfaces.\n");
		}
	    }
	    else
	    if ((! strcmp("local_int",res)) && (! strcmp(res,"local_int")))
	    {
		if (local_int_pos < 11)
		{
		    if (count_char_in_string(buf_copy,';') == 4)
		    {
	    		local_int_tab[1] = (char **) realloc((char **) local_int_tab[1],sizeof(char *)*6*(local_int_pos+1));
	    	        local_int_tab2[1] = (int *) realloc((int *) local_int_tab2[1],sizeof(int)*6*(local_int_pos+1));
    
			// ustawiamy 0 dla lokalnych interfejsow
	    		local_int_tab2[1][(local_int_pos*6)+5] = 0;
    
    	    		// pobieramy nazwe interfejsu sieciowego
	    		res=strtok(NULL,";");
			if (is_device(res))
			{
			    local_int_tab[1][(local_int_pos*6)+1]= (char *) calloc(strlen(res)+2,sizeof(char));
	    		    strcpy(local_int_tab[1][(local_int_pos*6)+1],res);
    
	    		    // pobieramy przepustowosc interfejsu
			    res=strtok(NULL,";");
	    		    local_int_tab[1][(local_int_pos*6)+2]= (char *) calloc(strlen(res)+2,sizeof(char));
	    		    strcpy(local_int_tab[1][(local_int_pos*6)+2],res);

			    // pobieramy numer IP zrodlowy
	    	    	    res=strtok(NULL,";");
	    		    if (check_mask(res))
			    {
		    		local_int_tab[1][(local_int_pos*6)+3]= (char *) calloc(strlen(res)+2,sizeof(char));
				strcpy(local_int_tab[1][(local_int_pos*6)+3],res);
		    	        local_int_tab2[1][(local_int_pos*6)+1] = mask2hex(res);
			    }
	    		    else
	    		    {
		    		syslog(LOG_ERR,"Can't find mask for IP %s in local_int section - file /etc/shaper/shaper.%d.cfg",res,shaperd_counter);
		    		error("Can't find mask for IP %s in local_int section - file /etc/shaper/shaper.%d.cfg\nExiting\n",res,shaperd_counter);
			    }

			    // pobieramy numer IP interfejsu
	    		    res=strtok(NULL,";");
	    		    if (check_mask(res))
	    		    {
		    		local_int_tab[1][(local_int_pos*6)+4]= (char *) calloc(strlen(res)+2,sizeof(char));
		    		strcpy(local_int_tab[1][(local_int_pos*6)+4],res);
		    		local_int_tab2[1][(local_int_pos*6)+2] = mask2hex(res);
			    }
			    else
	    		    {
	    			syslog(LOG_ERR,"Can't find mask for IP %s in local_int section - file /etc/shaper/shaper.%d.cfg",res,shaperd_counter);
			        error("Can't find mask for IP %s in local_int section - file /etc/shaper/shaper.%d.cfg\nExiting\n",res,shaperd_counter);
			    }

			    // numer klasy
	    		    res=strtok(NULL,"\n");
			    if (atoi(res)<1 || atoi(res)>255)
			    {
    				syslog(LOG_ERR,"wrong CBQ class identifier in local_int for %s interface. Should be 1-255",local_int_tab[1][(local_int_pos*6)+1]);
				error("wrong CBQ class identifier in inter_int for %s interface. Should be 1-255",local_int_tab[1][(local_int_pos*6)+1]);
			    }
			    local_int_tab[1][(local_int_pos*6)+5]= (char *) calloc(strlen(res)+2,sizeof(char *));
			    strcpy(local_int_tab[1][(local_int_pos*6)+5],res);
    
    			    syslog(LOG_INFO, "using IP %s for %s local interface",local_int_tab[1][(local_int_pos*6)+4],local_int_tab[1][(local_int_pos*6)+1]);
	    		    local_int_pos++;
			}
			else
			{
			    error("device %s not exists - in line %d of %s file",res,nr_linii,fname);
			}
		    }
		    else
		    {
			error("syntax error in line %d of %s file",nr_linii,fname);
		    }
		}
		else
		{
	    	    syslog(LOG_ERR,"Too much interfaces.");
	    	    error("Too much interfaces.\n");
		}
	    }
	}
    }
    fclose(fp);
    return(local_int_tab);
}

void free_config(char ***local_int_tab)
{
    int	m,n;

    if (local_int_tab)
    {
	for(m=1;m<local_int_pos;m++)
	{
	    for(n=1;n<6;n++)
		free(local_int_tab[1][(m*6)+n]);
	}
	free(local_int_tab[1]);
	free(local_int_tab2[1]);
	free(local_int_tab);
	free(local_int_tab2);
	local_int_pos = 1;
    }
}

char ***natstat(char **ignore, char ***config, int firewall_type)
{
    char	source[20],destin[20],sport[10],port[10];
    char	source2[20],destin2[20],sport2[10],port2[10];
    char	s1[20],s2[20],s3[20],s4[20];
    int		timeout;
    int		d1,d2,d3,m,n,fin;
    FILE	*fp;
    char	source_b[20];
    char        source_b2[20];
    char	destin_b[20];
    char	loc_ip_b[20];
    char	gat_ip_b[20];
    unsigned int	source_i,source_ix;
    unsigned int	destin_i;
    unsigned int	source2_i,source2_ix;
    unsigned int	destin2_i;
    int		source_t;
    int		destin_t;
    unsigned int	loc_ip_i,loc_ip_ix;
    unsigned int	gat_ip_i;
    char	***natstat_tab = NULL;
    char	bufor[1000];
    char	ignorebuf[200];
    int		ignbuf = 0;
    int		prot = 0;

//    if (!nomasq && (firewall_type == 1) && (fp = fopen("/root/ipchains.2.4.x.2","r")))
    if (!nomasq && (firewall_type == 1) && (fp = popen("ipchains -L -M -n 2> /dev/null","r")))
    {
	if (debug>2) printf("debug 3: reading current connection on ipchains firewall\n");
	natstat_tab = (char ***) calloc(3,sizeof(char **));
	natstat_tab[1] = (char **) NULL;
	fgets(bufor,1000,fp);
	fgets(bufor,1000,fp);
	while(fgets(bufor,1000,fp))
	{
	    sscanf(bufor,"%s %4d:%s %s %s %s %s -> %s",s1,&d2,s2,source,destin,sport,s3,port);
	    if (strstr(bufor,"tcp")) prot = 0;
	    else prot = 1;

/*
	    timeout = d2 - (7200-(TIMEOUT/60));
	    if (timeout < 0 && timeout > ((TIMEOUT/60)-7200)) timeout = (TIMEOUT/60)-d2;
	    else timeout = 7200-d2;
*/
	    if (kernel_type >= 2 && kernel_type <=3) timeout = (TIMEOUT/60)-d2;
	    else
	    if (kernel_type >= 4) timeout = 7200-d2;
	    else
	    {
		syslog(LOG_ERR,"This software don't support 2.%d kernels.",kernel_type);
		error("This software don't support 2.%d kernels.",kernel_type);
	    }
	    
	    if (prot || (timeout <= TIMEOUT/60))
	    {
//		for(m=1;m<local_int_pos;m++)
		{
		    strcpy(ignorebuf,source);
		    strcat(ignorebuf," ");
		    strcat(ignorebuf,destin);
		    strcat(ignorebuf," ");
		    strcat(ignorebuf,port);
		    strcat(ignorebuf,"$");
		    fin = 0;
		    for(n=1;n<ignore_pos;n++)
			if (strstr(ignorebuf,ignore[n])) fin = 1;

		    if (! fin)
		    {
			natstat_tab[1] = (char **) realloc((char **)natstat_tab[1], sizeof(char *)*((natstat_tab_pos+1)*4));
		    	natstat_tab[1][(natstat_tab_pos*4)+1] = (char *) calloc(strlen(source)+2,sizeof(char));
		    	strcpy(natstat_tab[1][(natstat_tab_pos*4)+1],source);
		    	natstat_tab[1][(natstat_tab_pos*4)+2] = (char *) calloc(strlen(destin)+2,sizeof(char));
		    	strcpy(natstat_tab[1][(natstat_tab_pos*4)+2],destin);
		    	natstat_tab[1][(natstat_tab_pos*4)+3] = (char *) calloc(strlen(port)+2,sizeof(char));
		    	strcpy(natstat_tab[1][(natstat_tab_pos*4)+3],port);
    
    			if (debug > 1) printf("natstat: %s %s %s\n",
			    natstat_tab[1][(natstat_tab_pos*4)+1],
    			    natstat_tab[1][(natstat_tab_pos*4)+2],
			    natstat_tab[1][(natstat_tab_pos*4)+3]);
			natstat_tab_pos++;
		    }
		}
	    }
	}
	pclose(fp);
	return(natstat_tab);
    }
    else
    if (!nomasq && (firewall_type == 2) && (fp = fopen(IP_CONNTRACK,"r")))
    {
	if (debug>2) printf("debug 3: reading current connection on iptables firewall\n");
    	natstat_tab = (char ***) calloc(3,sizeof(char **));
    	natstat_tab[1] = (char **) NULL;
    	while(fgets(bufor,1000,fp))
    	{
	    if (strstr(bufor,"tcp"))
	    {
    	        sscanf(bufor,"%s %d %d %s src=%s dst=%s sport=%s dport=%s src=%s dst=%s sport=%s dport=%s [ASSURED] use=%d",
	    	    s1,&d1,&d2,s2,source,destin,sport,port,source2,destin2,sport2,port2,&d3);
	        prot = 0;
	    }
	    else
	    {
    	        sscanf(bufor,"%s %d %d src=%s dst=%s sport=%s dport=%s src=%s dst=%s sport=%s dport=%s",
	    	    s1,&d1,&d2,source,destin,sport,port,source2,destin2,sport2,port2);
	        prot = 1;
	    }
	    timeout=432000-d2;
	    if ((prot && strcmp(bufor,"127.0.0.1")) || (strcmp(bufor,"127.0.0.1")
	        && ! strcmp(s2,"ESTABLISHED")
		&& timeout <= TIMEOUT))
	    {
		for(m=1;m<local_int_pos;m++)
		{
		    // jesli interfejs lokalny
		    if (!local_int_tab2[1][(m*6)+5])
		    {
			source_i  = ip2hex2(source)  & local_int_tab2[1][(m*6)+1];
			source_ix = ip2hex2(source)  & local_int_tab2[1][(m*6)+2];
			destin_i  = ip2hex2(destin)  & local_int_tab2[1][(m*6)+2];
			source2_i = ip2hex2(source2) & local_int_tab2[1][(m*6)+1];
			source2_ix= ip2hex2(source2) & local_int_tab2[1][(m*6)+2];
			destin2_i = ip2hex2(destin2) & local_int_tab2[1][(m*6)+2];
			loc_ip_i  = ip2hex2(config[1][(m*6)+3]) & local_int_tab2[1][(m*6)+1];
			loc_ip_ix = ip2hex2(config[1][(m*6)+3]) & local_int_tab2[1][(m*6)+2];
			gat_ip_i  = ip2hex2(config[1][(m*6)+4]) & local_int_tab2[1][(m*6)+2];
			ignbuf = 0;
//		    printf("%x %x %x %x %x %x\n",source_i,loc_ip_i,destin_i,gat_ip_i,destin_i,loc_ip_i);
//		    printf("%x %x %x %x %x %x\n",source_ix,loc_ip_ix,destin_i,gat_ip_i,destin_i,loc_ip_i);

//	    	    if ((source_i == loc_ip_i)
//			&& (destin_i != gat_ip_i)
//	    		&& (destin_i != loc_ip_i))
//		    {
	    	        if (((source_ix == loc_ip_ix)
			    || (source_i == loc_ip_i))
			    && (destin_i != gat_ip_i)
	    		    && (destin_i != loc_ip_i))
			{
		    	    // emulacja grep'a
		    	    strcpy(ignorebuf,source);
		    	    strcat(ignorebuf," ");
		    	    strcat(ignorebuf,destin);
		    	    strcat(ignorebuf," ");
		    	    strcat(ignorebuf,port);
		    	    strcat(ignorebuf,"$");
		    	    ignbuf = 1;
			}
			else
//		    if ((source2_i == loc_ip_i)
//			&& (destin2_i != gat_ip_i)
//			&& (destin2_i != loc_ip_i))
//		    {
			if (((source2_ix == loc_ip_ix)
			    || (source2_i == loc_ip_i))
			    && (destin2_i != gat_ip_i)
			    && (destin2_i != loc_ip_i))
			{
		    	    strcpy(ignorebuf,source2);
		    	    strcat(ignorebuf," ");
		    	    strcat(ignorebuf,destin2);
		    	    strcat(ignorebuf," ");
		    	    strcat(ignorebuf,port2);
		    	    strcat(ignorebuf,"$");
		    	    ignbuf = 2;
			}
			if (ignbuf)
			{
			    fin = 0;
		    	    for(n=1;n<ignore_pos;n++)
				if (strstr(ignorebuf,ignore[n])) fin = 1;

			    if (! fin)
			    {
		    		natstat_tab[1] = (char **) realloc((char **)natstat_tab[1], sizeof(char *)*((natstat_tab_pos+1)*4));
				if (ignbuf == 1)
				{
		    	    	    natstat_tab[1][(natstat_tab_pos*4)+1] = (char *) calloc(strlen(source)+2,sizeof(char));
    	    		    	    strcpy(natstat_tab[1][(natstat_tab_pos*4)+1],source);
		    	    	    natstat_tab[1][(natstat_tab_pos*4)+2] = (char *) calloc(strlen(destin)+2,sizeof(char));
		    	    	    strcpy(natstat_tab[1][(natstat_tab_pos*4)+2],destin);
		    	    	    natstat_tab[1][(natstat_tab_pos*4)+3] = (char *) calloc(strlen(port)+2,sizeof(char));
		    	    	    strcpy(natstat_tab[1][(natstat_tab_pos*4)+3],port);
				}
				else
				{
		    	    	    natstat_tab[1][(natstat_tab_pos*4)+1] = (char *) calloc(strlen(source2)+2,sizeof(char));
    	    		    	    strcpy(natstat_tab[1][(natstat_tab_pos*4)+1],source2);
		    	    	    natstat_tab[1][(natstat_tab_pos*4)+2] = (char *) calloc(strlen(destin2)+2,sizeof(char));
		    	    	    strcpy(natstat_tab[1][(natstat_tab_pos*4)+2],destin2);
		    	    	    natstat_tab[1][(natstat_tab_pos*4)+3] = (char *) calloc(strlen(port2)+2,sizeof(char));
		    	    	    strcpy(natstat_tab[1][(natstat_tab_pos*4)+3],port2);
				}
    				if (debug) printf("natstat: %s %s %s\n",
			    	    natstat_tab[1][(natstat_tab_pos*4)+1],
    				    natstat_tab[1][(natstat_tab_pos*4)+2],
			    	    natstat_tab[1][(natstat_tab_pos*4)+3]);
				natstat_tab_pos++;
			    }
			}
		    }
		}
	    }
	}
	fclose(fp);
    }
    else
    if (nomasq)
    {
	if (debug>2) printf("debug 3: reading current connection without checking masquerade\n");
	    	natstat_tab = (char ***) calloc(3,sizeof(char **));
    	natstat_tab[1] = (char **) NULL;
	for(m=1;m<iplista_pos;m++)
	{
	    if ((ipspeed_last2_counter[m] > 0) || (ipspeed[m] > (ipspeed_last2[m] + 2000)))
	    {
//		printf("ipspeed_last2_counter %d\n",ipspeed_last2_counter[m]);
		if ((ipspeed_last2_counter[m] < 1) || (ipspeed[m] > (ipspeed_last2[m] + 2000))) ipspeed_last2_counter[m] = nomasq_cycles;
	        ipspeed_last2[m] = ipspeed[m];
	        natstat_tab[1] = (char **) realloc((char **)natstat_tab[1], sizeof(char *)*((natstat_tab_pos+1)*4));
	        natstat_tab[1][(natstat_tab_pos*4)+1] = (char *) calloc(strlen(iplista[m])+2,sizeof(char));
    	        strcpy(natstat_tab[1][(natstat_tab_pos*4)+1],iplista[m]);
	        natstat_tab[1][(natstat_tab_pos*4)+2] = (char *) calloc(strlen("nomasq")+2,sizeof(char));
	        strcpy(natstat_tab[1][(natstat_tab_pos*4)+2],"nomasq");
	        natstat_tab[1][(natstat_tab_pos*4)+3] = (char *) calloc(strlen("all")+2,sizeof(char));
	        strcpy(natstat_tab[1][(natstat_tab_pos*4)+3],"all");
	        if (debug) printf("natstat_nomasq: %s %s %s\n",
		    natstat_tab[1][(natstat_tab_pos*4)+1],
    	    	    natstat_tab[1][(natstat_tab_pos*4)+2],
	    	    natstat_tab[1][(natstat_tab_pos*4)+3]);
		natstat_tab_pos++;
	    }
	    else
	    {
		if (ipspeed[m] < ipspeed_last2[m]) ipspeed_last2[m] = ipspeed[m];
	    }
	    if (ipspeed_last2_counter[m] > 0) ipspeed_last2_counter[m]--;
	}
    }
    else
    {
	syslog(LOG_ERR,"Can't read from /proc/net/ip_conntrack file");
	error("Can't read from /proc/net/ip_conntrack file\nExiting\n");
    }

    if (squid)
    {
	if (debug>2) printf("debug 3: reading current squid connection\n");
        for(m=1;m<iplista_pos;m++)
        {
    	    if (squid_speed[m] > squid_speed_last2[m])
	    {
		//printf("aaa %lu\n",squid_speed[m]-squid_speed_last2[m]);
		squid_speed_last2[m] = squid_speed[m];
		sprintf(port,"%d",squid_port);
		natstat_tab[1] = (char **) realloc((char **)natstat_tab[1], sizeof(char *)*((natstat_tab_pos+1)*4));
		natstat_tab[1][(natstat_tab_pos*4)+1] = (char *) calloc(strlen(iplista[m])+2,sizeof(char));
    		strcpy(natstat_tab[1][(natstat_tab_pos*4)+1],iplista[m]);
		natstat_tab[1][(natstat_tab_pos*4)+2] = (char *) calloc(strlen("proxy")+2,sizeof(char));
		strcpy(natstat_tab[1][(natstat_tab_pos*4)+2],"proxy");
		natstat_tab[1][(natstat_tab_pos*4)+3] = (char *) calloc(strlen(port)+2,sizeof(char));
		strcpy(natstat_tab[1][(natstat_tab_pos*4)+3],port);
		if (debug) printf("natstat_squid: %s %s %s\n",
		    natstat_tab[1][(natstat_tab_pos*4)+1],
    	    	    natstat_tab[1][(natstat_tab_pos*4)+2],
	    	    natstat_tab[1][(natstat_tab_pos*4)+3]);
		    natstat_tab_pos++;
	    }
	    else
	    {
		if (squid_speed[m] < squid_speed_last2[m]) squid_speed_last2[m] = squid_speed[m];
	    }
	}
    }
    return(natstat_tab);
}

char ***natstat_upload(char **ignore, char ***config, int firewall_type)
{
    char	***natstat_tab_upload = NULL;
    int		m;

    if (debug>2) printf("debug 3: reading current upload connection without checking masquerade\n");
    natstat_tab_upload = (char ***) calloc(3,sizeof(char **));
    natstat_tab_upload[1] = (char **) NULL;
    for(m=1;m<iplista_pos;m++)
    {
        if ((ipspeed_last2_counter_upload[m] > 0) || (ipspeed_upload[m] > (ipspeed_last2_upload[m] + 2000)))
        {
//	    printf("ipspeed_last2_counter_upload %d\n",ipspeed_last2_counter_upload[m]);
    	    if ((ipspeed_last2_counter_upload[m] < 1) || (ipspeed_upload[m] > (ipspeed_last2_upload[m] + 2000))) ipspeed_last2_counter_upload[m] = nomasq_cycles;
	    ipspeed_last2_upload[m] = ipspeed_upload[m];
	    natstat_tab_upload[1] = (char **) realloc((char **)natstat_tab_upload[1], sizeof(char *)*((natstat_tab_pos_upload+1)*4));
	    natstat_tab_upload[1][(natstat_tab_pos_upload*4)+1] = (char *) calloc(strlen(iplista[m])+2,sizeof(char));
    	    strcpy(natstat_tab_upload[1][(natstat_tab_pos_upload*4)+1],iplista[m]);
	    natstat_tab_upload[1][(natstat_tab_pos_upload*4)+2] = (char *) calloc(strlen("nomasq")+2,sizeof(char));
	    strcpy(natstat_tab_upload[1][(natstat_tab_pos_upload*4)+2],"nomasq");
	    natstat_tab_upload[1][(natstat_tab_pos_upload*4)+3] = (char *) calloc(strlen("all")+2,sizeof(char));
	    strcpy(natstat_tab_upload[1][(natstat_tab_pos_upload*4)+3],"all");
	    if (debug) printf("natstat_upload_nomasq: %s %s %s\n",
	        natstat_tab_upload[1][(natstat_tab_pos_upload*4)+1],
    	        natstat_tab_upload[1][(natstat_tab_pos_upload*4)+2],
	        natstat_tab_upload[1][(natstat_tab_pos_upload*4)+3]);
	    natstat_tab_pos_upload++;
	}
	else
	{
	    if (ipspeed_upload[m] < ipspeed_last2_upload[m]) ipspeed_last2_upload[m] = ipspeed_upload[m];
	}
	if (ipspeed_last2_counter_upload[m] > 0) ipspeed_last2_counter_upload[m]--;
    }
    return(natstat_tab_upload);
}

void free_natstat_tab(char ***natstat_tab)
{
    int		m,n;
    
    m=0;
    for(m=0;m<natstat_tab_pos;m++)
    {
        for(n=3;n>0;n--)
	{
//    	    free((char *) natstat_tab[1][(m*4)+n]);
    	    free(natstat_tab[1][(m*4)+n]);
	}
    }
    free(natstat_tab[1]);
    free(natstat_tab);
    natstat_tab_pos = 0;
}

void free_natstat_tab_upload(char ***natstat_tab)
{
    int		m,n;
    
    m=0;
    for(m=0;m<natstat_tab_pos_upload;m++)
    {
        for(n=3;n>0;n--)
	{
//    	    free((char *) natstat_tab[1][(m*4)+n]);
    	    free(natstat_tab[1][(m*4)+n]);
	}
    }
    free(natstat_tab[1]);
    free(natstat_tab);
    natstat_tab_pos_upload = 0;
}

char **read_ignore(char *fname)
{
    FILE        *fp;
    char	*res;
    int         m;
    char	buft[100];
    char	**ignore_tab;

    m = numlines(fname);
    ignore_tab = (char **) calloc(m+2,sizeof(char *));
    fp = fopen(fname,"r");
    while ((res=strtok(fgets(buft,100,fp),"\n")))
    {
	if (res[0] != '#' && strlen(res))
	{
	    ignore_tab[ignore_pos] = (char *) calloc(strlen(buft)+2,sizeof(char));
	    strcpy(ignore_tab[ignore_pos],buft);
	    if (debug > 1) printf("ignore: %s\n",ignore_tab[ignore_pos]);
	    ignore_pos++;
	}
    }
    fclose(fp);
    return(ignore_tab);
}

void free_ignore(char **ignore_tab)
{
    int		n;

    for(n=1;n<ignore_pos;n++)
    {
	free(ignore_tab[n]);
    }
    free(ignore_tab);
    ignore_pos = 1;
}

char **get_masqip(char ***natstat_tab, char *iface, int int_cnt)
{
    char	**masqip = NULL;
    char	*ip;
    char	ipt[20];
    int		m,n,fin;

    masqip = (char **) malloc(sizeof(char *)*iplista_pos+2);
    for(n=0;n<natstat_tab_pos;n++)
    {
	if (strlen(natstat_tab[1][(n*4)+1]) > 0)
	{
	    if (ip = ip2ip_with_mask(natstat_tab[1][(n*4)+1]))
	    {
		fin = 0;
	        for(m=1;m<masqip_pos[int_cnt];m++)
		    if (! strcmp(ip,masqip[m]) && ! strcmp(masqip[m],ip)) fin = 1;

		if (! fin && ! strcmp(iface,get_ip_int_iface(ip)) && ! strcmp(get_ip_int_iface(ip),iface))
		{
		    masqip[masqip_pos[int_cnt]] = (char *) malloc(sizeof(char)*strlen(ip)+2);
		    strcpy(masqip[masqip_pos[int_cnt]++],ip);
		    if (debug) printf("get_masqip: %s\n",ip);
		}
	    }
	    else
	    {
		syslog(LOG_ERR,"Can't find mask for IP %s\n",natstat_tab[1][(n*4)+1]);
		if (debug) printf("Can't find mask for IP %s\n",natstat_tab[1][(n*4)+1]);
	    }
	}
    }
    return(masqip);
}

char **get_masqip_upload(char ***natstat_tab, char *iface, int int_cnt)
{
    char	**masqip = NULL;
    char	*ip;
    char	ipt[20];
    int		m,n,fin;

    masqip = (char **) malloc(sizeof(char *)*iplista_pos+2);
    for(n=0;n<natstat_tab_pos_upload;n++)
    {
	if (strlen(natstat_tab[1][(n*4)+1]) > 0)
	{
	    if (ip = ip2ip_with_mask(natstat_tab[1][(n*4)+1]))
	    {
		fin = 0;
	        for(m=1;m<masqip_pos_upload[int_cnt];m++)
		    if (! strcmp(ip,masqip[m]) && ! strcmp(masqip[m],ip)) fin = 1;

		if (! fin && ! strcmp(iface,get_ip_int_iface(ip)) && ! strcmp(get_ip_int_iface(ip),iface))
		{
		    masqip[masqip_pos_upload[int_cnt]] = (char *) malloc(sizeof(char)*strlen(ip)+2);
		    strcpy(masqip[masqip_pos_upload[int_cnt]++],ip);
		    if (debug) printf("get_masqip_upload: %s\n",ip);
		}
	    }
	    else
	    {
		syslog(LOG_ERR,"Can't find mask for IP %s\n",natstat_tab[1][(n*4)+1]);
		if (debug) printf("Can't find mask for IP %s\n",natstat_tab[1][(n*4)+1]);
	    }
	}
    }
    return(masqip);
}

void free_masqip(char **masqip, int int_cnt)
{
    int		n;

    for(n=1;n<masqip_pos[int_cnt];n++)
    {
	free(masqip[n]);
    }
    free(masqip);
    masqip_pos[int_cnt] = 1;
}

void free_masqip_upload(char **masqip, int int_cnt)
{
    int		n;

    for(n=1;n<masqip_pos_upload[int_cnt];n++)
    {
	free(masqip[n]);
    }
    free(masqip);
    masqip_pos_upload[int_cnt] = 1;
}

char ***create_speed_table(int ilip)
{
    char	***speed_tab;

    speed_tab = (char ***) calloc(3,sizeof(char **));
    speed_tab[1] = (char **) calloc(ilip*10,sizeof(char *));
    return(speed_tab);
}

void free_speed_table(char ***speed_tab, int pos)
{
    int		m, n;

//    if (speed_tab)
//    {
	for(n=1;n<9;n++)
	{
	    for(m=0;m<=(pos-1);m++)
	    {
//		if (speed_tab[1][(m*9)+n]) free(speed_tab[1][(m*9)+n]);
		free(speed_tab[1][(m*9)+n]);
	    }
	}
	free(speed_tab[1]);
	free(speed_tab);
//    }
}

void add_ip2speed_table_new(char ***speed_tab, char *ip)
{
    int		pos = 0;

    while(speed_tab[1][(pos*9)+1])
	pos++;

    speed_tab[1][(pos*9)+1] = (char *) calloc(strlen(ip)+2,sizeof(char));
    strcpy(speed_tab[1][(pos*9)+1],ip);
}

void add_ip2speed_table_sub1(char ***speed_tab, char *ip)
{
    int		pos = 0;

    while(speed_tab[1][(pos*9)+2])
	pos++;

    speed_tab[1][(pos*9)+2] = (char *) calloc(strlen(ip)+2,sizeof(char));
    strcpy(speed_tab[1][(pos*9)+2],ip);
}

void add_ip2speed_table_nop1(char ***speed_tab, char *ip)
{
    int		pos = 0;

    while(speed_tab[1][(pos*9)+3])
	pos++;

    speed_tab[1][(pos*9)+3] = (char *) calloc(strlen(ip)+2,sizeof(char));
    strcpy(speed_tab[1][(pos*9)+3],ip);
}

void add_ip2speed_table_add1(char ***speed_tab, char *ip)
{
    int		pos = 0;

    while(speed_tab[1][(pos*9)+4])
	pos++;

    speed_tab[1][(pos*9)+4] = (char *) calloc(strlen(ip)+2,sizeof(char));
    strcpy(speed_tab[1][(pos*9)+4],ip);
}

void add_ip2speed_table_sub2(char ***speed_tab, char *ip)
{
    int		pos = 0;

    while(speed_tab[1][(pos*9)+5])
	pos++;

    speed_tab[1][(pos*9)+5] = (char *) calloc(strlen(ip)+2,sizeof(char));
    strcpy(speed_tab[1][(pos*9)+5],ip);
}

void add_ip2speed_table_nop2(char ***speed_tab, char *ip)
{
    int		pos = 0;

    while(speed_tab[1][(pos*9)+6])
	pos++;

    speed_tab[1][(pos*9)+6] = (char *) calloc(strlen(ip)+2,sizeof(char));
    strcpy(speed_tab[1][(pos*9)+6],ip);
}

void add_ip2speed_table_add2(char ***speed_tab, char *ip)
{
    int		pos = 0;

    while(speed_tab[1][(pos*9)+7])
	pos++;

    speed_tab[1][(pos*9)+7] = (char *) calloc(strlen(ip)+2,sizeof(char));
    strcpy(speed_tab[1][(pos*9)+7],ip);
}

void del_ip2speed_table(char ***speed_tab, char *ip)
{
    int		pos = 0;

    while(speed_tab[1][(pos*9)+8])
	pos++;

    speed_tab[1][(pos*9)+8] = (char *) calloc(strlen(ip)+2,sizeof(char));
    strcpy(speed_tab[1][(pos*9)+8],ip);
}

char *get_speed_table_new(char ***speed_tab, int pos)
{
    char	*nil = "\0";
    char	*res;

    if (res = speed_tab[1][((pos-1)*9)+1]) return(res);
    else return(nil);
}

char *get_speed_table_sub1(char ***speed_tab, int pos)
{
    char	*nil = "\0";
    char	*res;

    if (res = speed_tab[1][((pos-1)*9)+2]) return(res);
    else return(nil);
}

char *get_speed_table_nop1(char ***speed_tab, int pos)
{
    char	*nil = "\0";
    char	*res;

    if (res = speed_tab[1][((pos-1)*9)+3]) return(res);
    else return(nil);
}

char *get_speed_table_add1(char ***speed_tab, int pos)
{
    char	*nil = "\0";
    char	*res;

    if (res = speed_tab[1][((pos-1)*9)+4]) return(res);
    else return(nil);
}

char *get_speed_table_sub2(char ***speed_tab, int pos)
{
    char	*nil = "\0";
    char	*res;

    if (res = speed_tab[1][((pos-1)*9)+5]) return(res);
    else return(nil);
}

char *get_speed_table_nop2(char ***speed_tab, int pos)
{
    char	*nil = "\0";
    char	*res;

    if (res = speed_tab[1][((pos-1)*9)+6]) return(res);
    else return(nil);
}

char *get_speed_table_add2(char ***speed_tab, int pos)
{
    char	*nil = "\0";
    char	*res;

    if (res = speed_tab[1][((pos-1)*9)+7]) return(res);
    else return(nil);
}

char *get_speed_table_del(char ***speed_tab, int pos)
{
    char	*nil = "\0";
    char	*res;

    if (res = speed_tab[1][((pos-1)*9)+8]) return(res);
    else return(nil);
}

char *get_ip_iface(char *ip)
{
    int		n;

    for(n=1;n<iplista_pos;n++)
	if ((ip2hex2(ip)&iplista_mask[n]) == (iplista_ip[n]&iplista_mask[n]))
	    return(iplista_iface[n]);
    return("\0");
}

char *get_ip_int_iface(char *ip)
{
    int		n;

    for(n=1;n<iplista_pos;n++)
	if ((ip2hex2(ip)&iplista_mask[n]) == (iplista_ip[n]&iplista_mask[n]))
	    return(iplista_int_iface[n]);
    return("\0");
}

unsigned short int get_ip_cnt(char *ip)
{
    int			n;
    unsigned short int	m = 0;
    char		*iface;
    
    iface = get_ip_int_iface(ip);
    for(n=1;n<iplista_pos;n++)
    {
	if (!strcmp(iplista_int_iface[n],iface))
	{
	    m++;
	    if ((ip2hex2(ip)&iplista_mask[n]) == (iplista_ip[n]&iplista_mask[n]))
	    {
		return(m);
	    }
	}
    }
    return(m);
}

int get_ip_mask(char *ip)
{
    int		n;

    for(n=1;n<iplista_pos;n++)
    {
	if (! strcmp(iplista[n],ip) && ! strcmp(ip,iplista[n]))
	{
	    return(iplista_mask[n]);
	}
    }
    return(0);
}
unsigned long int get_ip_lospeed(char *ip)
{
    int		n;

    for(n=1;n<iplista_pos;n++)
    {
	if (! strcmp(iplista[n],ip) && ! strcmp(ip,iplista[n]))
	{
	    return(iplista_lo[n]);
	}
    }
    return(100);
}

unsigned long int get_ip_lospeed_upload(char *ip)
{
    int		n;

    for(n=1;n<iplista_pos;n++)
    {
	if (! strcmp(iplista[n],ip) && ! strcmp(ip,iplista[n]))
	{
	    return(iplista_lo_upload[n]);
	}
    }
    return(100);
}

unsigned long int get_ip_hispeed(char *ip)
{
    int		n;

    for(n=1;n<iplista_pos;n++)
    {
	if (! strcmp(iplista[n],ip) && ! strcmp(ip,iplista[n]))
	{
	    return(iplista_hi[n]);
	}
    }
    return(100);
}

unsigned long int get_ip_hispeed_upload(char *ip)
{
    int		n;

    for(n=1;n<iplista_pos;n++)
    {
	if (! strcmp(iplista[n],ip) && ! strcmp(ip,iplista[n]))
	{
	    return(iplista_hi_upload[n]);
	}
    }
    return(100);
}

int get_config_by_ip(char ***config, char *ip)
{
    int		n;
    char	*iface;

    iface = get_ip_iface(ip);
//    printf("ip=%s %s\n",ip,iface);
    for(n=1;n<local_int_pos;n++)
    {
	if ((!local_int_tab2[1][(n*6)+5])
	    && (! strcmp(iface,config[1][(n*6)+1]))
	    && (! strcmp(config[1][(n*6)+1],iface)))
	{
//	    printf("%s %d\n",config[1][(n*6)+1],n);
	    return(n);
	}
    }
    return(-1);
}

int get_config_by_ip_upload(char ***config, char *ip)
{
    int		n;
    char	*iface;

    iface = get_ip_int_iface(ip);
//    printf("ip=%s %s\n",ip,iface);
    for(n=1;n<local_int_pos;n++)
    {
	if ((local_int_tab2[1][(n*6)+5])
	    && (! strcmp(iface,config[1][(n*6)+1]))
	    && (! strcmp(config[1][(n*6)+1],iface)))
	{
//	    printf("%s %d\n",config[1][(n*6)+1],n);
	    return(n);
	}
    }
    return(-1);
}

char *check_mask(char *ip)
{
    char	mask[20];
    int		d1,d2,d3,d4;
    int		n = 0;
    int		no_dots = 0;
    int		m;
    
    if (! strchr(ip,'/')) return(NULL);

    while(ip[n++] != '/')
	;

    if (! strlen(ip+n)) return(NULL);

    m = n;
    while(ip[m])
	if (ip[m++] == '.') no_dots++;

    if (no_dots == 3)
    {
        sscanf(ip+n,"%3d.%3d.%3d.%3d",&d1,&d2,&d3,&d4);    
        if (d1<0 || d1>255 || d2<0 || d2>255 | d3<0 || d3>255 || d4<0 || d4>255)
	    return(NULL);
	else return(ip+n);
    }
    else
    if (no_dots>3 || (no_dots>0 && no_dots<3)) return(NULL);
    else
    if (atoi(ip+n)<=32 || atoi(ip+n)>=0) return(ip+n);

    return(NULL);
}


int ip2hex(char *ip)
{
    char	buf[20];
    int		a,b,c,d;
    int		res;

    sscanf(ip,"%d.%d.%d.%d",&a,&b,&c,&d);
    if (a>=0 && a<=255
	&& b>=0 && b<=255
	&& c>=0 && c<=255
	&& d>=0 && d<=255)
    {
	sprintf(buf,"%02x%02x%02x%02x",a,b,c,d);
	sscanf(buf,"%x",&res);
	return(res);
    }
    else return(0);
}

int ip2hex2(char *ip)
{
    char	buf[20];
    int		a,b,c,d;
    int		res;

    sscanf(ip,"%d.%d.%d.%d",&a,&b,&c,&d);
    if (a>=0 && a<=255
	&& b>=0 && b<=255
	&& c>=0 && c<=255
	&& d>=0 && d<=255)
    {
	res = (a*256+b)*65536+(c*256+d);
	return(res);
    }
    else return(0);
}

char *hex2ip(int ip)
{
    char	*res;
//    static char	res[20];
    char	ipt[20];
    int		a,b,c,d;

    res = (char *) calloc(22,sizeof(char));
    sprintf(ipt,"%08x",ip);
    sscanf(ipt,"%02x%02x%02x%02x",&a,&b,&c,&d);
    sprintf(res,"%d.%d.%d.%d",a,b,c,d);
    return(res);
}

char *hex2ip2(char *ip)
{
    char	*res;
//    static char	res[20];
    char	ipt[20];
    int		a,b,c,d;

    res = (char *) calloc(22,sizeof(char));
    sprintf(ipt,"%s",ip);
    sscanf(ipt,"%02x%02x%02x%02x",&a,&b,&c,&d);
    sprintf(res,"%d.%d.%d.%d",a,b,c,d);
    return(res);
}

char *get_ip_iface2(char ***local_int_tab, char *ip)
{
    int		intip, mip, maska, n;
    char	*mainip;
    int		res;

    mip = ip2hex(ip);
    for(n=1;n<local_int_pos;n++)
    {
	maska = mask2hex(local_int_tab[1][(n*6)+4]);
        intip = ip2hex(local_int_tab[1][(n*6)+4]);
	res = intip & maska;
	if ((mip & maska) == res) return(hex2ip(res));
    }
    return(NULL);
}

int mask2hex(char *ip)
{
    char	mask[20];
    int		d1,d2,d3,d4;
    int		n = 0;
    int		no_dots = 0;
    int		m;
    int		res = 0;

    if (! strchr(ip,'/')) return(0);

    while(ip[n++] != '/')
	;

    if (! strlen(ip+n)) return(0);

    m = n;
    while(ip[m])
	if (ip[m++] == '.') no_dots++;

    if (no_dots == 3)
    {
        sscanf(ip+n,"%3d.%3d.%3d.%3d",&d1,&d2,&d3,&d4);    
        if (d1<0 || d1>255 || d2<0 || d2>255 | d3<0 || d3>255 || d4<0 || d4>255)
	    return(0);
	else return(ip2hex(ip+n));
    }
    else
    if (no_dots>3 || (no_dots>0 && no_dots<3)) return(0);
    else
    if (atoi(ip+n)<=32 || atoi(ip+n)>=0)
    {
	for(m=31;m>=(32-atoi(ip+n));m--)
	    res = res + ldexp(1,m);
	return(res);
    }
    return(0);
}

int mask2hex2(char *maska)
{
    char	mask[20];
    int		d1,d2,d3,d4;
    int		n = 0;
    int		no_dots = 0;
    int		m;
    int		res = 0;

    if (!strlen(maska)) return(0);

    m = n;
    while(maska[m])
	if (maska[m++] == '.') no_dots++;

    if (no_dots == 3)
    {
        sscanf(maska,"%3d.%3d.%3d.%3d",&d1,&d2,&d3,&d4);    
        if (d1<0 || d1>255 || d2<0 || d2>255 | d3<0 || d3>255 || d4<0 || d4>255)
	    return(0);
	else return(ip2hex(maska));
    }
    else
    if (no_dots>3 || (no_dots>0 && no_dots<3)) return(0);
    else
    if (atoi(maska)<=32 || atoi(maska)>=0)
    {
	for(m=31;m>=(32-atoi(maska));m--)
	    res = res + ldexp(1,m);
	return(res);
    }
    return(0);
}

void create_firewall(char ***config, int firewall_type)
{
    int		pos;
    int		n;
    char	bufor[1000];
    FILE	*fp;

    fflush(NULL);
    if (fp = popen("/bin/sh 2>/dev/null","w"))
    {
	if (firewall_type == 1)
	{
	    char	pop1[100];
	    char	pop2[100];
	    
	    sprintf(bufor,"ipchains -M -S %d 10 60\n",TIMEOUT);
	    fputs(bufor,fp);
	    // tablice download
	    sprintf(pop1,"ipchains -N shaper%d\n",shaperd_counter);
	    sprintf(pop2,"ipchains -I output -j shaper%d\n",shaperd_counter);
    	    fputs(pop1,fp);
	    fputs(pop2,fp);
	    if (divide_upload)
	    {
	    // tablice upload
	    sprintf(pop1,"ipchains -N shaout%d\n",shaperd_counter);
	    sprintf(pop2,"ipchains -I forward -j shaout%d\n",shaperd_counter);
    	    fputs(pop1,fp);
	    fputs(pop2,fp);
	    }
    	    for(n=1;n<iplista_pos;n++)
	    {
		if ((pos = get_config_by_ip(config,iplista[n])) != -1)
		{
		    // download
		    sprintf(bufor,"ipchains -A shaper%d -s ! %s -d %s -j RETURN\n",
			shaperd_counter,config[1][(pos*6)+3],iplista[n]);
		    fputs(bufor,fp);
		    if (divide_upload)
		    {
			int	pos2;
			if ((pos2 = get_config_by_ip_upload(config,iplista[n])) != -1)
			{
			    // upload
		    	    sprintf(bufor,"ipchains -A shaout%d -s %s -d ! %s -m %d -j RETURN\n",
				    shaperd_counter,iplista[n],config[1][(pos*6)+3],(1000*atoi(config[1][(pos2*6)+3]))+get_ip_cnt(iplista[n])+4);
			    fputs(bufor,fp);
			}
		    }
		}
	    }
	}
	else
	if (firewall_type == 2)
	{
	    char	pop1[100];
	    int		int_cnt;
	    
	    // download
	    sprintf(pop1,"iptables -N shaper%d\n",shaperd_counter);
	    fputs(pop1,fp);
	    if (divide_upload)
	    {
	    // upload
	    sprintf(pop1,"iptables -N shaout%d\n",shaperd_counter);
	    fputs(pop1,fp);
	    }
	    for(int_cnt=1;int_cnt<local_int_pos;int_cnt++)
	    {
		if (local_int_tab2[1][(int_cnt*6)+5])
		{
		    // download
		    sprintf(bufor,"iptables -I FORWARD -i %s -j shaper%d\n",config[1][(int_cnt*6)+1],shaperd_counter);
		    fputs(bufor,fp);
		    if (divide_upload)
		    {
		    // upload
		    sprintf(bufor,"iptables -I FORWARD -o %s -j shaout%d\n",config[1][(int_cnt*6)+1],shaperd_counter);
		    fputs(bufor,fp);
		    }
		}
	    }
	    if (squid)
	    {
		for(pos=1;pos<local_int_pos;pos++)
		{
		    if (!local_int_tab2[1][(pos*6)+5])
		    {
    			sprintf(bufor,"iptables -I OUTPUT 1 -t mangle -p tcp --src %s --sport %d -m tos --tos 0 -j RETURN\n",
			    config[1][(pos*6)+3],squid_port);
			fputs(bufor,fp);
			sprintf(bufor,"iptables -I OUTPUT 2 -t mangle -p tcp --src %s --sport ! %d -j RETURN\n",
			    config[1][(pos*6)+3],squid_port);
			fputs(bufor,fp);
		    }
		}
	    }
    	    for(n=1;n<iplista_pos;n++)
	    {
		if ((pos = get_config_by_ip(config,iplista[n])) != -1)
		{
		    if (squid)
		    {
			sprintf(bufor,"iptables -I OUTPUT %d -t mangle -p tcp --src %s --sport %d -m tos ! --tos 0 --dst %s -j RETURN\n",
				n+2,config[1][(pos*6)+3],squid_port,iplista[n]);
			fputs(bufor,fp);
		    }
		    // download
		    sprintf(bufor,"iptables -A shaper%d -o %s -s ! %s -d %s -j RETURN\n",
			shaperd_counter,config[1][(pos*6)+1],config[1][(pos*6)+3],iplista[n]);
		    fputs(bufor,fp);
		    if (divide_upload)
		    {
			int	pos2;
			if ((pos2 = get_config_by_ip_upload(config,iplista[n])) != -1)
			{
			    // upload
			    sprintf(bufor,"iptables -A shaout%d -i %s -s %s -d ! %s -j RETURN\n",
				    shaperd_counter,config[1][(pos*6)+1],iplista[n],config[1][(pos*6)+3]);
			    fputs(bufor,fp);
			    sprintf(bufor,"iptables -t mangle -I FORWARD -s %s -d ! %s -j MARK --set-mark %d\n",
				    iplista[n],config[1][(pos*6)+3],(1000*atoi(config[1][(pos2*6)+3]))+get_ip_cnt(iplista[n])+4);
			    fputs(bufor,fp);
			}
		    }
		}
	    }
	}
//	fflush(fp);
	pclose(fp);
    }
}

void delete_firewall(char ***config, int firewall_type)
{
    int		pos;
    int		n;
    char	bufor[1000];
    FILE	*fp;

    fflush(NULL);
    if (fp = popen("/bin/sh 2>/dev/null","w"))
    {
	if (firewall_type == 1)
	{
	    char	pop1[100];
	    
	    // download
	    sprintf(pop1,"ipchains -F shaper%d\n",shaperd_counter);
	    fputs(pop1,fp);
	    sprintf(pop1,"ipchains -D output -j shaper%d\n",shaperd_counter);
	    fputs(pop1,fp);
	    sprintf(pop1,"ipchains -X shaper%d\n",shaperd_counter);
	    fputs(pop1,fp);
	    if (divide_upload)
	    {
	    // upload
	    sprintf(pop1,"ipchains -F shaout%d\n",shaperd_counter);
	    fputs(pop1,fp);
	    sprintf(pop1,"ipchains -D forward -j shaout%d\n",shaperd_counter);
    	    fputs(pop1,fp);
	    sprintf(pop1,"ipchains -X shaout%d\n",shaperd_counter);
	    fputs(pop1,fp);
	    }
	}
	else
	if (firewall_type == 2)
	{
	    char	pop[100];
	    int         int_cnt;

	    // download
	    sprintf(pop,"iptables -F shaper%d\n",shaperd_counter);
	    fputs(pop,fp);
	    if (divide_upload)
	    {
	    // upload
	    sprintf(pop,"iptables -F shaout%d\n",shaperd_counter);
	    fputs(pop,fp);
	    }
	    for(int_cnt=1;int_cnt<local_int_pos;int_cnt++)
	    {
		if (local_int_tab2[1][(int_cnt*6)+5])
		{
		    sprintf(bufor,"iptables -D FORWARD -i %s -j shaper%d\n",config[1][(int_cnt*6)+1],shaperd_counter);
		    fputs(bufor,fp);
		    if (divide_upload)
		    {
		    sprintf(bufor,"iptables -D FORWARD -o %s -j shaout%d\n",config[1][(int_cnt*6)+1],shaperd_counter);
		    fputs(bufor,fp);
		    }
		}
	    }
	    sprintf(pop,"iptables -X shaper%d\n",shaperd_counter);
	    fputs(pop,fp);
	    for(pos=1;pos<local_int_pos;pos++)
	    {
	        if (!local_int_tab2[1][(pos*6)+5])
	        {
	    	    if (squid)
		    {
    			sprintf(bufor,"iptables -D OUTPUT -t mangle -p tcp --src %s --sport %d -m tos --tos 0 -j RETURN\n",
			    config[1][(pos*6)+3],squid_port);
			fputs(bufor,fp);
			sprintf(bufor,"iptables -D OUTPUT -t mangle -p tcp --src %s --sport ! %d -j RETURN\n",
			    config[1][(pos*6)+3],squid_port);
			fputs(bufor,fp);
		    }
		}
	    }
    	    for(n=1;n<iplista_pos;n++)
	    {
	        if ((pos = get_config_by_ip(config,iplista[n])) != -1)
	        {
		    int		pos2;

	    	    if (squid)
	    	    {
			sprintf(bufor,"iptables -D OUTPUT -t mangle -p tcp --src %s --sport %d -m tos ! --tos 0 --dst %s -j RETURN\n",
			        config[1][(pos*6)+3],squid_port,ip2ip_with_mask(iplista[n]));
			fputs(bufor,fp);
		    }
		    if ((pos2 = get_config_by_ip_upload(config,iplista[n])) != -1)
		    {
			sprintf(bufor,"iptables -t mangle -D FORWARD -s %s -d ! %s -j MARK --set-mark %d\n",
				iplista[n],config[1][(pos*6)+3],(1000*atoi(config[1][(pos2*6)+3]))+get_ip_cnt(iplista[n])+4);
			fputs(bufor,fp);
		    }
		}
	    }
	}
	pclose(fp);
    }
}

char ***mkbitrate_user_last(char ***bitrate_user_last, char *ip, long int ispeed, int int_cnt)
{
    char	speed[20];
    char	time[20];

    
    sprintf(speed,"%d",ispeed);
    if ((ckbitrate_user_last(bitrate_user_last,ip,int_cnt)) == -1)
    {
        if (! bitrate_user_last)
	{
	    bitrate_user_last = (char ***) realloc(bitrate_user_last,sizeof(char **)*5);
	    bitrate_user_last[1] = (char **) NULL;
    	    bitrate_user_last[2] = (char **) NULL;
	}
	bitrate_user_last[1] = (char **) realloc((char **) bitrate_user_last[1],sizeof(char *)*((bitrate_user_last_pos[int_cnt]+1)*4));
	bitrate_user_last[2] = (char **) realloc((char **) bitrate_user_last[2],sizeof(char *)*((bitrate_user_last_pos[int_cnt]+1)*4));
        bitrate_user_last[1][bitrate_user_last_pos[int_cnt]+1]= (char *) calloc(strlen(ip)+2,sizeof(char));
	bitrate_user_last[2][bitrate_user_last_pos[int_cnt]+1]= (char *) calloc(strlen(speed)+2,sizeof(char));
	strcpy(bitrate_user_last[1][bitrate_user_last_pos[int_cnt]+1],ip);
        strcpy(bitrate_user_last[2][bitrate_user_last_pos[int_cnt]+1],speed);
	bitrate_user_last_pos[int_cnt]++;
    }
    else
    {
	int	n;

	for(n=0;n<bitrate_user_last_pos[int_cnt];n++)
    	    if (! strcmp(bitrate_user_last[1][n+1],ip)
		&& ! strcmp(ip,bitrate_user_last[1][n+1]))
		break;
	bitrate_user_last[1][n+1]= (char *) realloc(bitrate_user_last[1][n+1],sizeof(char *)*((n+1)*(strlen(ip)+2)));
	bitrate_user_last[2][n+1]= (char *) realloc(bitrate_user_last[2][n+1],sizeof(char *)*((n+1)*(strlen(speed)+2)));
	strcpy(bitrate_user_last[1][n+1],ip);
        strcpy(bitrate_user_last[2][n+1],speed);
    }
    return(bitrate_user_last);
}

char ***mkbitrate_user_last_upload(char ***bitrate_user_last, char *ip, long int ispeed, int int_cnt)
{
    char	speed[20];
    char	time[20];

    
    sprintf(speed,"%d",ispeed);
    if ((ckbitrate_user_last_upload(bitrate_user_last,ip,int_cnt)) == -1)
    {
        if (! bitrate_user_last)
	{
	    bitrate_user_last = (char ***) realloc(bitrate_user_last,sizeof(char **)*5);
	    bitrate_user_last[1] = (char **) NULL;
    	    bitrate_user_last[2] = (char **) NULL;
	}
	bitrate_user_last[1] = (char **) realloc((char **) bitrate_user_last[1],sizeof(char *)*((bitrate_user_last_pos_upload[int_cnt]+1)*4));
	bitrate_user_last[2] = (char **) realloc((char **) bitrate_user_last[2],sizeof(char *)*((bitrate_user_last_pos_upload[int_cnt]+1)*4));
        bitrate_user_last[1][bitrate_user_last_pos_upload[int_cnt]+1]= (char *) calloc(strlen(ip)+2,sizeof(char));
	bitrate_user_last[2][bitrate_user_last_pos_upload[int_cnt]+1]= (char *) calloc(strlen(speed)+2,sizeof(char));
	strcpy(bitrate_user_last[1][bitrate_user_last_pos_upload[int_cnt]+1],ip);
        strcpy(bitrate_user_last[2][bitrate_user_last_pos_upload[int_cnt]+1],speed);
	bitrate_user_last_pos_upload[int_cnt]++;
    }
    else
    {
	int	n;

	for(n=0;n<bitrate_user_last_pos_upload[int_cnt];n++)
    	    if (! strcmp(bitrate_user_last[1][n+1],ip)
		&& ! strcmp(ip,bitrate_user_last[1][n+1]))
		break;
	bitrate_user_last[1][n+1]= (char *) realloc(bitrate_user_last[1][n+1],sizeof(char *)*((n+1)*(strlen(ip)+2)));
	bitrate_user_last[2][n+1]= (char *) realloc(bitrate_user_last[2][n+1],sizeof(char *)*((n+1)*(strlen(speed)+2)));
	strcpy(bitrate_user_last[1][n+1],ip);
        strcpy(bitrate_user_last[2][n+1],speed);
    }
    return(bitrate_user_last);
}

char ***clear_bitrate_user_last(char ***bitrate_user_last, char **masq, int int_cnt)
{
    int		m,n;
    int		*iplista_fin;

    iplista_fin = (int *) calloc(iplista_pos,sizeof(int));
    for(n=1;n<iplista_pos;n++)
	iplista_fin[n] = 0;

    for(n=1;n<iplista_pos;n++)
    {
	for(m=1;m<masqip_pos[int_cnt];m++)
        {
	    if ((ip2hex2(masq[m])&iplista_mask[n]) == (iplista_ip[n]&iplista_mask[n]))
		iplista_fin[n] = 1;
	}
    }

    for(n=1;n<iplista_pos;n++)
    {
	if (! iplista_fin[n])
	{
    	    bitrate_user_last = mkbitrate_user_last(bitrate_user_last,iplista[n],0,int_cnt);
	}
    }
    
    free(iplista_fin);
    return(bitrate_user_last);
}

char ***clear_bitrate_user_last_upload(char ***bitrate_user_last, char **masq, int int_cnt)
{
    int		m,n;
    int		*iplista_fin;

    iplista_fin = (int *) calloc(iplista_pos,sizeof(int));
    for(n=1;n<iplista_pos;n++)
	iplista_fin[n] = 0;

    for(n=1;n<iplista_pos;n++)
    {
	for(m=1;m<masqip_pos_upload[int_cnt];m++)
        {
	    if ((ip2hex2(masq[m])&iplista_mask[n]) == (iplista_ip[n]&iplista_mask[n]))
		iplista_fin[n] = 1;
	}
    }

    for(n=1;n<iplista_pos;n++)
    {
	if (! iplista_fin[n])
	{
//	    printf("clearing: %s\n",iplista[n]);
    	    bitrate_user_last = mkbitrate_user_last_upload(bitrate_user_last,iplista[n],0,int_cnt);
	}
    }
    
    free(iplista_fin);
    return(bitrate_user_last);
}

long int ckbitrate_user_last(char ***bitrate_user_last, char *ip, int int_cnt)
{
    int		n;

    if (bitrate_user_last)
	for(n=0;n<bitrate_user_last_pos[int_cnt];n++)
	{
	    if (! strcmp(bitrate_user_last[1][n+1],ip)
		&& ! strcmp(ip,bitrate_user_last[1][n+1]))
		return(atoi(bitrate_user_last[2][n+1]));
	}
    return(-1);
}

long int ckbitrate_user_last_upload(char ***bitrate_user_last, char *ip, int int_cnt)
{
    int		n;

    if (bitrate_user_last)
	for(n=0;n<bitrate_user_last_pos_upload[int_cnt];n++)
	{
	    if (! strcmp(bitrate_user_last[1][n+1],ip)
		&& ! strcmp(ip,bitrate_user_last[1][n+1]))
		return(atoi(bitrate_user_last[2][n+1]));
	}
    return(-1);
}

void free_bitrate_user_last(char ***bitrate_user_last, int int_cnt)
{
    int		n;

//    if (bitrate_user_last)
//    {
        for(n=0;n<bitrate_user_last_pos[int_cnt];n++)
        {
    	    free(bitrate_user_last[1][n+1]);
	    free(bitrate_user_last[2][n+1]);
        }
	free(bitrate_user_last[1]);
        free(bitrate_user_last[2]);
	free(bitrate_user_last);
//    }
}

void free_bitrate_user_last_upload(char ***bitrate_user_last, int int_cnt)
{
    int		n;

        for(n=0;n<bitrate_user_last_pos_upload[int_cnt];n++)
        {
    	    free(bitrate_user_last[1][n+1]);
	    free(bitrate_user_last[2][n+1]);
        }
	free(bitrate_user_last[1]);
        free(bitrate_user_last[2]);
	free(bitrate_user_last);
}

//void write_bitrate_user_last(char ***bitrate_user_last, char *fname, int int_cnt)
void write_bitrate_user_last(char ****bitrate_user_last, char *fname, int int_cnt)
{
    FILE	*fw;
    int		n;
    int		fd;
    char	buf[200];
    long int	speed;

    if (fw = fopen(fname,"w"))
    {
/*
	for(n=0;n<bitrate_user_last_pos[int_cnt];n++)
	{
	    speed = strtol(bitrate_user_last[2][n+1],NULL,10);
	    if (speed > 0)
	    {
		sprintf(buf,"%s %ld %s\n",bitrate_user_last[1][n+1],speed,speed_ext);
		fputs(buf,fw);
	    }
	}
	fclose(fw);
*/
	for(int_cnt=1;int_cnt<local_int_pos;int_cnt++)
	{
	    if (local_int_tab2[1][(int_cnt*6)+5])
	    {
		for(n=0;n<bitrate_user_last_pos[int_cnt];n++)
		{
		    speed = strtol(bitrate_user_last[int_cnt][2][n+1],NULL,10);
		    if (speed > 0)
		    {
			sprintf(buf,"%s %ld %s\n",bitrate_user_last[int_cnt][1][n+1],speed,speed_ext);
			fputs(buf,fw);
		    }
		}
	    }
	}
	fclose(fw);
    }
}

void write_bitrate_user_last_upload(char ****bitrate_user_last, char *fname, int int_cnt)
{
    FILE	*fw;
    int		n;
    int		fd;
    char	buf[200];
    long int	speed;

    if (fw = fopen(fname,"w"))
    {
/*
	for(n=0;n<bitrate_user_last_pos[int_cnt];n++)
	{
	    speed = strtol(bitrate_user_last[2][n+1],NULL,10);
	    if (speed > 0)
	    {
		sprintf(buf,"%s %ld %s\n",bitrate_user_last[1][n+1],speed,speed_ext);
		fputs(buf,fw);
	    }
	}
	fclose(fw);
*/
	for(int_cnt=1;int_cnt<local_int_pos;int_cnt++)
	{
	    if (local_int_tab2[1][(int_cnt*6)+5])
	    {
		for(n=0;n<bitrate_user_last_pos_upload[int_cnt];n++)
		{
		    speed = strtol(bitrate_user_last[int_cnt][2][n+1],NULL,10);
		    if (speed > 0)
		    {
			sprintf(buf,"%s %ld %s\n",bitrate_user_last[int_cnt][1][n+1],speed,speed_ext);
			fputs(buf,fw);
		    }
		}
	    }
	}
	fclose(fw);
    }
}

static int daemonize(void)
{
    int fd;
    int pid;
    char buf[100];

    fprintf(stderr, "daemonizing...");

    if ((pid = fork()) < 0)
    {
	fprintf(stderr, " failed!\n");
	return -1;
    }
    else if (pid != 0)
    {
	unlink(pidfile);
	if ((fd = open(pidfile, O_CREAT|O_WRONLY, 0644)) >= 0)
	{
	    sprintf(buf,"%d\n",pid);
	    write(fd,buf,strlen(buf));
	    close(fd);
	}
	fprintf(stderr, " done. PID=%d\n", pid);
	exit(0);
    }

    // parent is gone now
    setsid();   // ditch controlling terminal, become session leader
    chdir("/"); // new working directory (don't prevent unmounting a FS)
    umask(0);   // clear inherited file creation mask

    // set up logging facility
//    sprintf(buf,"shaperd%s",shaperd_counter);
//    openlog(buf, LOG_CONS, LOG_DAEMON);
    syslog(LOG_INFO, "starting: LAN Traffic shaper %s Grzegorz Fitrzyk (sp9wun@poczta.onet.pl)",VERSION);
    syslog(LOG_INFO, "running, PID=%d", getpid());
    if (debug) printf("Starting shaperd.%d %s\n",shaperd_counter,VERSION);
    return 0;
}

int check_linux(void)
{
    FILE	*fp;
    char	buf[1000];
    char	*p,*q;
    int		a = 0;
    int		b = 0;
    
    if (fp = fopen("/proc/version","r"))
    {
	while(fgets(buf,1000,fp))
	{
	    if (strstr(buf,"Linux version"))
	    {
		p = strtok(buf," ");
		p = strtok(NULL," ");
		p = strtok(NULL," ");
		p = strtok(p,".");
		q = strtok(NULL,".");
		a = atoi(p);
		b = atoi(q);
//		printf("wersja: %d %d\n",a,b);
		if (a == 2)
		{
		    fclose(fp);
		    return(b);
		}
	    }
	}
	fclose(fp);
    }
    return(0);
}

int check_ipchains(void)
{
    FILE	*fp;
    char	buf[1000];

    if (fp = popen("ipchains -L -n 2> /dev/null","r"))
    {
	fgets(buf,1000,fp);
	pclose(fp);
	if (strstr(buf,"Chain input")) return(1);
	else return(0);	
    }
}

int check_iptables(void)
{
    FILE	*fp;
    char	buf[1000];

    if (fp = popen("iptables -L -n 2> /dev/null","r"))
    {
	fgets(buf,1000,fp);
	pclose(fp);
	if (strstr(buf,"Chain INPUT")) return(1);
	else return(0);
    }
}

int is_shaperd_running(void)
{
    FILE	*fp;
    char	buft[1000];
    int		fin = 0;

    if (fp = fopen(pidfile,"r"))
    {
	fclose(fp);
	return(1);
    }
    else return(0);
}

int is_iproute2(void)
{
    FILE	*fp, *fq;
    char	buft[1000];
    int		res = 0;
    char	tmp[100];
    char	tmp2[100];

    fflush;
    sprintf(tmp,"/tmp/tc.%d.tmp",shaperd_counter);
    sprintf(tmp2,"tc 2> /tmp/tc.%d.tmp\n",shaperd_counter);
    if (fp = popen(tmp2,"w"))
    {
	pclose(fp);
	if (fq = fopen(tmp,"r"))
	{
	    while (fgets(buft,1000,fq))
	    {
		if (strstr(buft,"sage: tc ["))
		{
		    res = 1;
		    break;
		}
	    }
	    fclose(fq);
	    if (!res)
	    {
		if (fq = fopen(tmp,"r"))
		{
		    printf("Unknown answer of tc command. Dumping results:\n");
		    while (fgets(buft,1000,fq))
			printf("%s",buft);
		    fclose(fq);
		}
	    }
	    remove(tmp);
	}
        else
        {
    	    printf("Can't open %s file! Maybe there's no /tmp directory?\n",tmp);
	}
    }
    return(res);
}

int is_qos(void)
{
    FILE	*fp, *fq;
    char	buft[1000];
    int		res = 0;
    char	tmp[100];
    char	tmp2[100];

    sprintf(tmp,"/tmp/tc.%d.tmp",shaperd_counter);
    sprintf(tmp2,"tc -s qdisc > /dev/null 2>/tmp/tc.%d.tmp\n",shaperd_counter);
    fflush;
    if (fp = popen(tmp2,"w"))
    {
	pclose(fp);
	if (fq = fopen(tmp,"r"))
	{
	    fgets(buft,1000,fq);
	    fclose(fq);
	    if (strstr(buft,"RTNETLINK error")) res = 0;
	    else res = 1;
	    remove(tmp);
	}
    }
    return(res);
}

void shownat(char ***natstat_tab)
{
    int		n;

    for(n=0;n<natstat_tab_pos;n++)
    	printf("%s %s %s\n",
	    natstat_tab[1][(n*4)+1],
	    natstat_tab[1][(n*4)+2],
	    natstat_tab[1][(n*4)+3]);
    return;
}

char *lower(char *string)
{
    char	*res;
//    static char	res[1000];
    int		n = 0;

    res = (char *) calloc(strlen(string)+2,sizeof(char));
    while((res[n] = tolower(string[n])) && n<999)
	n++;

    return(res);
}

void exit_handler()
{
    exit_signal = 1;
}

void read_squid(int firewall_type)
{
    int		f1,m,n;
    struct	stat stbuf;
    unsigned long int	cnt1,cnt2;
    unsigned long int	dd1,dd2,dd3,dd4;
    char	aa[12][20];
    char	*src;
    char	buf[30];
    char	buft[1000];

    FILE	*fw,*fp;

    if (debug>2) printf("debug 3: reading squid firewall rules\n");
    fflush(NULL);
    if (firewall_type==1)
    {
/*
	if (!(fp = popen("ipchains -vxL shaper -n 2> /dev/null","r")))
	{
	    syslog(LOG_ERR,"Can't read squid table from ipchains");
	    exit(1);
	}
*/
	syslog(LOG_ERR,"Shaperd don't support squid for ipchains firewall type");
	error("shaperd don't support squid for ipchains firewall type\nExiting\n");
    }
    else
    if (firewall_type==2)
    {
	if (!(fp = popen("iptables -t mangle -vxL OUTPUT -n 2> /dev/null","r")))
	{
	    syslog(LOG_ERR,"Can't read squid table from iptables");
	    error("Can't read squid table from iptables\nExiting.\n");
	}
    }
    else
    {
	syslog(LOG_ERR,"BUG: firewall type %d not exists!",firewall_type);
	error("BUG! Firewall type %d not exists!\nExiting\n",firewall_type);
    }

    while ((fgets(buft,1000,fp))!=NULL)
    {
	char	bufor[200];
	char	buf2[200];
	char	ipt[20];

	sprintf(buf2,"spt:%d",squid_port);
	if (strstr(buft,buf2) && strstr(buft,"!0x00"))
	{
	    sscanf(buft,"%lu %lu %s %s %s %s %s %s %s",
		&dd1,&dd2,aa[3],aa[4],aa[5],aa[6],aa[7],aa[8],aa[9]);
	    for(m=1;m<iplista_pos;m++)
	    {
		if (iplista_mask[m] == 0xffffffff)
		{
		    char	*res = hex2ip(iplista_ip[m]&iplista_mask[m]);

		    strcpy(ipt,res);
		    free(res);
		}
		else
		{
		    strcpy(ipt,iplista[m]);
		}
		strcat(ipt," ");
	        if (strstr(buft,ipt))
		{
		    squid_speed[m] = dd2;
		    squid_time[m]  = (long unsigned int) time(NULL);
		    if (debug > 1) printf("read_squid: %s %lu %lu\n",iplista[m],squid_speed[m],squid_time[m]);
	        }
	    }
	}
    }
    pclose(fp);
}

char *ip2ip_with_mask(char *ip)
{
    int	m;

    for(m=1;m<iplista_pos;m++)
    {
//	printf("%s %x %x %x\n",ip,(ip2hex2(ip)&iplista_mask[m]),(iplista_ip[m]&iplista_mask[m]),iplista_ip[m]);
	if ((ip2hex2(ip)&iplista_mask[m]) == (iplista_ip[m]&iplista_mask[m]))
	    return(iplista[m]);
    }
    return(NULL);
}

char *get_mainip(char *iface)
{
    FILE        	*fp;
    char		buf[2000];
    static char		buf2[20];
    char		*res;

    sprintf(buf,"ifconfig %s 2> /dev/null | grep 'inet addr' | cut -d ':' -f2 | cut -d ' ' -f1\n",iface);
    if (fp = popen(buf,"r"))
    {
	fgets(buf2,20,fp);
	pclose(fp);
	buf2[strlen(buf2)-1] = '\0';
//	printf("mainip=%s#\n",buf2);
	if (strlen(buf2)) return(buf2);
    }
    return(NULL);
}

int count_char_in_string(char *string, char c)
{
    int		n = 0;
    int		m = 0;
    char	p;
    
    while(p = string[n++])
	if (p == c ) m++;
    return(m);
}

int is_device(char *dev)
{
    int		res = 0;
    int		n;


    for(n=1;n<devlist_pos;n++)
    {
	if (!strcmp(devlist[n],dev) && !strcmp(dev,devlist[n]))
	{
//    	    printf("%s istnieje\n",devlist[n]);
	    res = 1;
	}
    }
    return(res);
}
